<?php
class objects
{
    var $object_tree;
    var $res;
    var $db;
    var $a_params;
    var $object_parent; 

    function objects(&$db, &$a_params, &$object_tree)
    {
        $this->db = &$db;
        $this->object_tree = &$object_tree;
        $this->a_params = &$a_params;
    }

    function getTree($table, $id)
    {
        $res = $this->db->Execute("SELECT * FROM ".$table." WHERE ".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            $elements = $res->FetchArray();
        }
        if ((isset($elements[$table."_parent"])) AND ($elements[$table."_parent"]!=0))
        {
           if (isset($elements[$table."_id"])) $this->object_tree["id"][]=$elements[$table."_id"]; else $this->object_tree["id"][]=null;
           if (isset($elements[$table."_name"])) $this->object_tree["name"][]=$elements[$table."_name"]; else $this->object_tree["name"][]=null;
           if (isset($elements[$table."_path"])) $this->object_tree["path"][]=$elements[$table."_path"]; else $this->object_tree["path"][]=null;
           if (isset($elements["view_id"])) $this->object_tree["view_id"][]=$elements["view_id"]; else $this->object_tree["view_id"][]=null;
           return $this->getTree($table, $elements[$table."_parent"]);
        }
        else
        {
            if (isset($elements[$table."_id"])) $this->object_tree["id"][]=$elements[$table."_id"]; else $this->object_tree["id"][]=null;
            if (isset($elements[$table."_name"])) $this->object_tree["name"][]=$elements[$table."_name"]; else $this->object_tree["name"][]=null;
            if (isset($elements[$table."_path"])) $this->object_tree["path"][]=$elements[$table."_path"]; else $this->object_tree["path"][]=null;
            if (isset($elements["view_id"])) $this->object_tree["view_id"][]=$elements["view_id"]; else $this->object_tree["view_id"][]=null;
            if (isset($elements["category_id"])) return $elements["category_id"]; else return 0;
        }
    }

    function getTable($table, $id)
    {
        $res = $this->db->Execute("SELECT * FROM (object LEFT JOIN object_name ON object.object_id=object_name.object_id) LEFT JOIN object_name_file
         ON object_name.object_name_id=object_name_file.object_name_id WHERE ".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            $elements = $res->FetchArray();
        }
        $this->object_tree["id"][]=$elements["object_id"];
        $this->object_tree["name"][]=$elements["object_name"];
    }
    
    // 
    function getHorseTree($id)
    {
        if ((isset($id)) AND ($id>0))
        {
        $mass_element=array();
        $res = $this->db->Execute("SELECT
        object.object_id,
        object.category_id,
        object.object_name,
        object.object_number,
        object.object_prefix,
        object.object_date,
        object.object_status,
        object.object_new,
        object.object_picture_icon, 
        object_name.object_name_id, 
        object_name.object_name_name,
        object_name.object_name_description,
        object_name.object_name_picture,
        object_name.object_name_title,
        object_name.object_name_keywords,
        object_name.object_name_descriptions,
        object.object_picture_banner,
        sex.sex_id, 
        sex_name.sex_name_name,  
        poroda.poroda_id, 
        poroda_name.poroda_name_name, 
        poroda_name.poroda_name_short,
        mast.mast_id, 
        mast_name.mast_name_name, 
        special.special_id, 
        special_name.special_name_name, 
        status.status_id, 
        status_name.status_name_name, 
        object.father_id, 
        father_name.object_name_name as father_name_name, 
        object.mother_id, 
        mother_name.object_name_name as mother_name_name  
        FROM ((((((((((((((object 
        LEFT JOIN object_name ON object.object_id=object_name.object_id) 
        LEFT JOIN sex ON object.sex_id=sex.sex_id)
        LEFT JOIN sex_name ON sex.sex_id=sex_name.sex_id) 
        LEFT JOIN poroda ON object.poroda_id=poroda.poroda_id) 
        LEFT JOIN poroda_name ON poroda.poroda_id=poroda_name.poroda_id)
        LEFT JOIN mast ON object.mast_id=mast.mast_id)
        LEFT JOIN mast_name ON mast.mast_id=mast_name.mast_id)  
        LEFT JOIN special ON object.special_id=special.special_id) 
        LEFT JOIN special_name ON special.special_id=special_name.special_id)
        LEFT JOIN status ON object.status_id=status.status_id)
        LEFT JOIN status_name ON status.status_id=status_name.status_id)
        LEFT JOIN object as father ON object.father_id=father.object_id)
        LEFT JOIN object_name as father_name ON father.object_id=father_name.object_id)
        LEFT JOIN object as mother ON object.mother_id=mother.object_id)
        LEFT JOIN object_name as mother_name ON mother.object_id=mother_name.object_id  
        WHERE object.object_id=".$id);

        if ($res->RecordCount()>0)
        {
            $element = $res->FetchArray();
            
            $mass_element["object_id"][]=$element["object_id"];
            $mass_element["category_id"][]=$element["category_id"];
            $mass_element["object_name"][]=$element["object_name"];
            $mass_element["object_prefix"][]=$element["object_prefix"];
            $mass_element["object_number"][]=$element["object_number"];
            $mass_element["object_status"][]=$element["object_status"];
            $mass_element["object_new"][]=$element["object_new"];
            $mass_element["object_name_id"][]=$element["object_name_id"];
            $mass_element["object_picture_icon"][]=$element["object_picture_icon"];
            $mass_element["object_picture_banner"][]=$element["object_picture_banner"]; 

            if (($element["object_date"]!="0000-00-00") AND ($element["object_date"]!=""))
            {
                $mass_element["object_date"][]=date('d.m.Y', $this->str2time($element["object_date"], 'Y-m-d'));
                $mass_element["object_day"][]=date('d', $this->str2time($element["object_date"], 'Y-m-d'));
                $mass_element["object_moon"][]=date('m', $this->str2time($element["object_date"], 'Y-m-d'));
                $mass_element["object_year"][]=date('Y', $this->str2time($element["object_date"], 'Y-m-d'));
            }
            else
            {
                $mass_element["object_date"][]=null;
                $mass_element["object_day"][]=null;
                $mass_element["object_moon"][]=null;
                $mass_element["object_year"][]=null;
            }

            $mass_element["object_name_id"][]=$element["object_name_id"];
            $mass_element["object_name_name"][]=$element["object_name_name"];
            $mass_element["object_name_description"][]=$element["object_name_description"];
            $mass_element["object_name_picture"][]=$element["object_name_picture"];
            $mass_element["object_name_title"][]=$element["object_name_title"];
            $mass_element["object_name_keywords"][]=$element["object_name_keywords"];
            $mass_element["object_name_descriptions"][]=$element["object_name_descriptions"];
            
            $mass_element["sex_id"][]=$element["sex_id"]; 
            $mass_element["sex_name_name"][]=$element["sex_name_name"]; 
            
            $mass_element["poroda_id"][]=$element["poroda_id"]; 
            $mass_element["poroda_name_name"][]=$element["poroda_name_name"];
            $mass_element["poroda_name_short"][]=$element["poroda_name_short"];
            
            $mass_element["mast_id"][]=$element["mast_id"]; 
            $mass_element["mast_name_name"][]=$element["mast_name_name"];
            
            $mass_element["special_id"][]=$element["special_id"]; 
            $mass_element["special_name_name"][]=$element["special_name_name"];
            
            $mass_element["status_id"][]=$element["status_id"]; 
            $mass_element["status_name_name"][]=$element["status_name_name"];
            
            $mass_element["father_id"][]=$element["father_id"]; 
            $mass_element["father_name_name"][]=$element["father_name_name"];
            
            $mass_element["mother_id"][]=$element["mother_id"]; 
            $mass_element["mother_name_name"][]=$element["mother_name_name"];                         
        }
        
        return $mass_element;
        }
        else
        {
        return null;
        }
    }

    function getView($id)
    {
        $res = $this->db->Execute("SELECT * FROM view WHERE view_id=".$id);

        $mass_object=array();
        if ($res->RecordCount()>0)
        {
            $element = $res->FetchArray();
            $mass_object["view_id"][]=$element["view_id"];
            $mass_object["view_name"][]=$element["view_name"];
            $mass_object["view_filename"][]=$element["view_filename"];
        }

        return $mass_object;
    }

    function getObject($table, $id)
    {
        $res = $this->db->Execute("SELECT * FROM ".$table." WHERE ".$table."_id=".$id);
        if ($res->RecordCount()>0)
        {
            $element = $res->FetchArray();
            $mass_object[$table."_name"][]=$element[$table."_name"];
        }
        return $mass_object;
    }    

    function getParent($id, $level)
    {

        $res = $this->db->Execute("SELECT
        object.object_id,
        object.category_id,
        object.object_name,
        object.object_number,
        object.object_prefix,
        object.object_date,
        object.object_status,
        object.object_new,
        object.object_picture_icon, 
        object_name.object_name_id, 
        object_name.object_name_name,
        object_name.object_name_description,
        object_name.object_name_picture,
        object_name.object_name_title,
        object_name.object_name_keywords,
        object_name.object_name_descriptions,
        object.object_picture_banner,
        sex.sex_id, 
        sex_name.sex_name_name,  
        poroda.poroda_id, 
        poroda_name.poroda_name_name, 
        poroda_name.poroda_name_short,
        mast.mast_id, 
        mast_name.mast_name_name, 
        special.special_id, 
        special_name.special_name_name, 
        status.status_id, 
        status_name.status_name_name, 
        object.father_id, 
        father_name.object_name_name as father_name_name, 
        object.mother_id, 
        mother_name.object_name_name as mother_name_name, 
        category_name.category_name_name  
        FROM ((((((((((((((((object 
        LEFT JOIN object_name ON object.object_id=object_name.object_id) 
        LEFT JOIN sex ON object.sex_id=sex.sex_id)
        LEFT JOIN sex_name ON sex.sex_id=sex_name.sex_id) 
        LEFT JOIN poroda ON object.poroda_id=poroda.poroda_id) 
        LEFT JOIN poroda_name ON poroda.poroda_id=poroda_name.poroda_id)
        LEFT JOIN mast ON object.mast_id=mast.mast_id)
        LEFT JOIN mast_name ON mast.mast_id=mast_name.mast_id)  
        LEFT JOIN special ON object.special_id=special.special_id) 
        LEFT JOIN special_name ON special.special_id=special_name.special_id)
        LEFT JOIN status ON object.status_id=status.status_id)
        LEFT JOIN status_name ON status.status_id=status_name.status_id)
        LEFT JOIN object as father ON object.father_id=father.object_id)
        LEFT JOIN object_name as father_name ON father.object_id=father_name.object_id)
        LEFT JOIN object as mother ON object.mother_id=mother.object_id)
        LEFT JOIN object_name as mother_name ON mother.object_id=mother_name.object_id)  
        LEFT JOIN category ON object.category_id=category.category_id)
        LEFT JOIN category_name ON category.category_id=category_name.category_id  
        WHERE object.father_id=".$id);       
        
        if ($res->RecordCount()>0)
        {
            $level++;
            while ($element = $res->FetchArray())
            {         
                $this->object_parent[$level]["object_id"][]=$element["object_id"];
                $this->object_parent[$level]["category_id"][]=$element["category_id"];
                $this->object_parent[$level]["object_name"][]=$element["object_name"];
                $this->object_parent[$level]["object_prefix"][]=$element["object_prefix"];
                $this->object_parent[$level]["object_number"][]=$element["object_number"];
                $this->object_parent[$level]["object_status"][]=$element["object_status"];
                $this->object_parent[$level]["object_new"][]=$element["object_new"];
                $this->object_parent[$level]["object_name_id"][]=$element["object_name_id"];
                $this->object_parent[$level]["object_picture_icon"][]=$element["object_picture_icon"];
                $this->object_parent[$level]["object_picture_banner"][]=$element["object_picture_banner"]; 

                if (($element["object_date"]!="0000-00-00") AND ($element["object_date"]!=""))
                {
                    $this->object_parent[$level]["object_date"][]=date('d.m.Y', $this->str2time($element["object_date"], 'Y-m-d'));
                    $this->object_parent[$level]["object_day"][]=date('d', $this->str2time($element["object_date"], 'Y-m-d'));
                    $this->object_parent[$level]["object_moon"][]=date('m', $this->str2time($element["object_date"], 'Y-m-d'));
                    $this->object_parent[$level]["object_year"][]=date('Y', $this->str2time($element["object_date"], 'Y-m-d'));
                }
                else
                {
                    $this->object_parent[$level]["object_date"][]=null;
                    $this->object_parent[$level]["object_day"][]=null;
                    $this->object_parent[$level]["object_moon"][]=null;
                    $this->object_parent[$level]["object_year"][]=null;
                }

                $this->object_parent[$level]["object_name_id"][]=$element["object_name_id"];
                $this->object_parent[$level]["object_name_name"][]=$element["object_name_name"];
                $this->object_parent[$level]["object_name_description"][]=$element["object_name_description"];
                $this->object_parent[$level]["object_name_picture"][]=$element["object_name_picture"];
                $this->object_parent[$level]["object_name_title"][]=$element["object_name_title"];
                $this->object_parent[$level]["object_name_keywords"][]=$element["object_name_keywords"];
                $this->object_parent[$level]["object_name_descriptions"][]=$element["object_name_descriptions"];
                
                $this->object_parent[$level]["sex_id"][]=$element["sex_id"]; 
                $this->object_parent[$level]["sex_name_name"][]=$element["sex_name_name"]; 
                
                $this->object_parent[$level]["poroda_id"][]=$element["poroda_id"]; 
                $this->object_parent[$level]["poroda_name_name"][]=$element["poroda_name_name"];
                $this->object_parent[$level]["poroda_name_short"][]=$element["poroda_name_short"];
                
                $this->object_parent[$level]["mast_id"][]=$element["mast_id"]; 
                $this->object_parent[$level]["mast_name_name"][]=$element["mast_name_name"];
                
                $this->object_parent[$level]["special_id"][]=$element["special_id"]; 
                $this->object_parent[$level]["special_name_name"][]=$element["special_name_name"];
                
                $this->object_parent[$level]["status_id"][]=$element["status_id"]; 
                $this->object_parent[$level]["status_name_name"][]=$element["status_name_name"];
                
                $this->object_parent[$level]["father_id"][]=$element["father_id"]; 
                $this->object_parent[$level]["father_name_name"][]=$element["father_name_name"];
                
                $this->object_parent[$level]["mother_id"][]=$element["mother_id"]; 
                $this->object_parent[$level]["mother_name_name"][]=$element["mother_name_name"]; 
                
                $this->object_parent[$level]["category_name_name"][]=$element["category_name_name"]; 
                
                //echo $element["object_number"].' - '.$level."<hr>";
                $this->getParent($element["object_id"], $level);
            }
        }
        else
        {
            return 0;
        }

    }
    
    //   
    function str2time($strStr, $strPattern = null)
    {
       $arrCharacters = array(
           'd', // day
           'm', // month
           'y', // year, 2 digits
           'Y', // year, 4 digits
           'H', // hours
           'i', // minutes
           's'  // seconds
       );
       $strCharacters = implode('', $arrCharacters);
       $arrDelimiters = preg_split('~['.$strCharacters.']~', $strPattern);
       $strDelimiters = quotemeta(implode('', array_unique($arrDelimiters)));
       $arrStr    = preg_split('~['.$strDelimiters.']~', $strStr);
       $arrPattern = preg_split('~['.$strDelimiters.']~', $strPattern);

       if (count($arrStr) !== count($arrPattern)) {
           return false;
       }

       $arrTime = array();
       for ($i = 0;$i < count($arrStr);$i++) {
           $arrTime[$arrPattern[$i]] = $arrStr[$i];
       }

       if (isset($arrTime['y']) && !isset($arrTime['Y'])) {
           $arrTime['Y'] = substr(date('Y'), 0, 2) . $arrTime['y'];
       }

       foreach ($arrCharacters as $strCharacter) {
           if (empty($arrTime[$strCharacter])) {
               $arrTime[$strCharacter] = date($strCharacter);
           }
       }

       if (!checkdate($arrTime['m'], $arrTime['d'], $arrTime['Y'])) {
           return false;
       }

       $intTime = mktime($arrTime['H'], $arrTime['i'], $arrTime['s'], $arrTime['m'], $arrTime['d'], $arrTime['Y']);

       return $intTime;
    }
    
    function RecordCount()
    {
        return $this->res->RecordCount();
    }

    function FetchArray()
    {
        return $this->res->FetchArray();
    }
}
?>
