<?php
class statistic
{
    var $common_hits='common_hits.dat';
    var $common_hosts='common_hosts.dat';
    var $common_sid='common_sids.dat';
    var $common_click='common_clicks.dat';
    var $online_data='online.dat';

    var $objects;
    var $a_params;
    var $path;
    var $ip;
    var $dns;
    var $url;
    var $sid;
    var $dates;
    var $times;
    var $past_time;
    var $yesterday;
    var $week;
    var $mon;

    function statistic(&$objects, &$a_params)
    {
        $this->objects = &$objects;
        $this->a_params = &$a_params;
        $this->ip = getenv('REMOTE_ADDR');
        $this->dns = getenv('HTTP_X_FORWARDED_FOR');
        $this->url = getenv('DOCUMENT_ROOT').getenv('REQUEST_URI');
        $this->sid = session_id();
        $this->dates = (int)(time()/86400);
        $this->times = time();
        $this->past_time = time()-300;
        $this->yesterday = $this->dates - 1;
        $this->week = $this->dates - 7;
        $this->mon = $this->dates - 30;
    }

    //Получить данные по посещаемости
    function getVisit($type, $date_begin = null, $date_end = null, $objectname = null)
    {


        //Активность
        if ($type=='active')
        {
            $this->path = './visit/';

            $date1=0;
            $date2=99999;

            if ($this->a_params["find_section_timestamp_1"]!="")
            {
                $splitdate1=split("\.",$this->a_params["find_section_timestamp_1"]);
                $date1 = (int)((strtotime($splitdate1[1]."/".$splitdate1[0]."/".$splitdate1[2])+10000)/86400);
            }

            if ($this->a_params["find_section_timestamp_2"]!="")
            {
                $splitdate2=split("\.",$this->a_params["find_section_timestamp_2"]);
                $date2 = (int)((strtotime($splitdate2[1]."/".$splitdate2[0]."/".$splitdate2[2])+10000)/86400);
            }

            if ($this->a_params["data"]=="")
            {
                $this->showFormSelect($objectname);

                //Получение кликов компания
                $tarray=file($this->path.'/'.$this->common_hits);
                $o=0;

                for($i=0;$i<count($tarray);$i++)
                {
                    list($date,$num)=explode("|",$tarray[$i]);

                    if (($date>=$date1) AND ($date<=$date2))
                    {
                        //Получение объектов
                        $tarray_obj=file($this->path.'/'.$date.'.dat');
                        $olddate=null;
                        $active_common_quantity=0;
                        for($n=0;$n<count($tarray_obj);$n++)
                        {
                            list($ip,$sid,$time,$url)=explode("|",$tarray_obj[$n]);

                            if ($date==$olddate)
                            {
                                $mass_active["quantity"][$o-1]=$mass_active["quantity"][$o-1]+1;

                                $sid_id=array_search($sid, $mass_sid[$o-1]);
                                if (!is_numeric($sid_id))
                                {
                                    $mass_sid[$o-1][]=$sid;
                                }
                            }
                            else
                            {
                                $mass_active["ip"][$o]=$ip;
                                $mass_active["sid"][$o]=$sid;
                                $mass_active["time"][$o]=$time;
                                $mass_active["url"][$o]=$url;
                                $mass_active["quantity"][$o]=1;
                                $mass_sid[$o][]=$sid;
                                $o++;
                            }
                            $olddate=$date;
                            $active_common_quantity++;
                        }
                    }
                }

                //График
                $mas_message[0]='Хиты';
                $mas_message[1]='Посещения';
                if (isset($mass_active["ip"])) $this->showGraph(null, null, null, $mas_message, count($mass_active["ip"]));

                //Таблица
                $table_width='45%';
                $mas_col["name"][0]='Дата';            $mas_col["width"][0]='15%';
                $mas_col["name"][1]='Хиты';            $mas_col["width"][1]='13%';
                $mas_col["name"][2]='Посещения';       $mas_col["width"][2]='13%';
                $mas_col["name"][3]='Активность (%)';  $mas_col["width"][3]='13%';

                $kol=31;
                $max=0;
                $str_num=$this->a_params["start"]*$kol;
                if (isset($mass_active["ip"])) $max=count($mass_active["ip"]);
                if ($max>($str_num+$kol)) $konec=($str_num+$kol);
                else $konec=$max;

                for($i=$str_num; $i<$konec; $i++)
                {
                     //Получить даты и клики
                     $mas_row["name"][]=date('d.m.Y', $mass_active["time"][$i]);
                     $mas_row["link"][]='./statistic.php?type=active&data='.(int)($mass_active["time"][$i]/86400);
                }

                $ind=0;
                for($i=$str_num; $i<$konec; $i++)
                {
                     $mas_data[$ind][1]=$mass_active["quantity"][$i];
                     $mas_data[$ind][2]=count($mass_sid[$i]);
                     $mas_data[$ind][3]=round((count($mass_sid[$i])*100)/intval($mass_active["quantity"][$i]), 1);
                     $ind++;
                }

                if ((isset($mas_row)) AND (isset($mas_data))) $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
                else
                echo '<table width="100%"  border="0" cellspacing="0" cellpadding="0" style="padding-left: 15px;"><tr><td class="text1">По Вашему запросу ничего не найдено';
                echo '</td></tr></table>';

            }
            else
            {
                //Получить по дате
                $tarray_obj=file($this->path.'/'.$this->a_params["data"].'.dat');
                for($n=0;$n<count($tarray_obj);$n++)
                {
                    list($ip,$sid,$time,$url)=explode("|",$tarray_obj[$n]);

                    $mass_active["ip"][]=$ip;
                    $mass_active["sid"][]=$sid;
                    $mass_active["time"][]=$time;
                    $mass_active["url"][]=$url;
                }


                //Таблица
                $table_width='70%';
                $mas_col["name"][0]='Дата и время';    $mas_col["width"][0]='15%';
                $mas_col["name"][1]='IP адрес';        $mas_col["width"][1]='12%';
                $mas_col["name"][2]='URL';             $mas_col["width"][2]='30%';
                $mas_col["name"][3]='SID';             $mas_col["width"][3]='13%';

                for($i=0;$i<count($mass_active["ip"]);$i++)
                {
                     //Получить даты и клики
                     $mas_row["name"][]=date('d.m.Y H:m:s', $mass_active["time"][$i]);
                }

                for($i=0;$i<count($mass_active["ip"]);$i++)
                {
                     $mas_data[$i][1]=$mass_active["ip"][$i];
                     $mas_data[$i][2]=$mass_active["url"][$i];
                     $mas_data[$i][3]=$mass_active["sid"][$i];
                }

                $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
            }

        }



       //Посещения
        if ($type=='visit')
        {
            $this->path = './visit/';

            $date1=0;
            $date2=99999;

            if ($this->a_params["find_section_timestamp_1"]!="")
            {
                $splitdate1=split("\.",$this->a_params["find_section_timestamp_1"]);
                $date1 = (int)((strtotime($splitdate1[1]."/".$splitdate1[0]."/".$splitdate1[2])+10000)/86400);
            }

            if ($this->a_params["find_section_timestamp_2"]!="")
            {
                $splitdate2=split("\.",$this->a_params["find_section_timestamp_2"]);
                $date2 = (int)((strtotime($splitdate2[1]."/".$splitdate2[0]."/".$splitdate2[2])+10000)/86400);
            }

            if ($this->a_params["data"]=="")
            {
                $this->showFormSelect($objectname);

                //Получение кликов компания
                $tarray=file($this->path.'/'.$this->common_hits);
                $o=0;

                for($i=0;$i<count($tarray);$i++)
                {
                    list($date,$num)=explode("|",$tarray[$i]);

                    if (($date>=$date1) AND ($date<=$date2))
                    {
                        //Получение объектов
                        $tarray_obj=file($this->path.'/'.$date.'.dat');
                        $olddate=null;
                        $visit_common_quantity=0;
                        for($n=0;$n<count($tarray_obj);$n++)
                        {
                            list($ip,$sid,$time,$url)=explode("|",$tarray_obj[$n]);

                            if ($date==$olddate)
                            {
                                $mass_visit["quantity"][$o-1]=$mass_visit["quantity"][$o-1]+1;
                            }
                            else
                            {
                                $mass_visit["ip"][$o]=$ip;
                                $mass_visit["sid"][$o]=$sid;
                                $mass_visit["time"][$o]=$time;
                                $mass_visit["url"][$o]=$url;
                                $mass_visit["quantity"][$o]=1;
                                $o++;
                            }
                            $olddate=$date;
                            $visit_common_quantity++;
                        }
                    }
                }


                //График
                $mas_message[0]='Посещения';
                if (isset($mass_visit["ip"])) $this->showGraph(null, null, null, $mas_message, count($mass_visit["ip"]));

                //Таблица
                $table_width='41%';
                $mas_col["name"][0]='Дата';        $mas_col["width"][0]='15%';
                $mas_col["name"][1]='Обращений';   $mas_col["width"][1]='13%';
                $mas_col["name"][2]='%';           $mas_col["width"][2]='13%';

                $kol=31;
                $max=0;
                $str_num=$this->a_params["start"]*$kol;
                if (isset($mass_visit["ip"])) $max=count($mass_visit["ip"]);
                if ($max>($str_num+$kol)) $konec=($str_num+$kol);
                else $konec=$max;

                for($i=$str_num; $i<$konec; $i++)
                {
                     //Получить даты и клики
                     $mas_row["name"][]=date('d.m.Y', $mass_visit["time"][$i]);
                     $mas_row["link"][]='./statistic.php?type=visit&data='.(int)($mass_visit["time"][$i]/86400);
                }

                $ind=0;
                for($i=$str_num; $i<$konec; $i++)
                {
                     $mas_data[$ind][1]=$mass_visit["quantity"][$i];
                     $mas_data[$ind][2]=round((intval($mass_visit["quantity"][$i])*100)/$visit_common_quantity, 1);
                     $ind++;
                }

                if ((isset($mas_row)) AND (isset($mas_data))) $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
                else
                echo '<table width="100%"  border="0" cellspacing="0" cellpadding="0" style="padding-left: 15px;"><tr><td class="text1">По Вашему запросу ничего не найдено';
                echo '</td></tr></table>';

            }
            else
            {
                //Получить по дате
                $tarray_obj=file($this->path.'/'.$this->a_params["data"].'.dat');
                for($n=0;$n<count($tarray_obj);$n++)
                {
                    list($ip,$sid,$time,$url)=explode("|",$tarray_obj[$n]);

                    $mass_visit["ip"][]=$ip;
                    $mass_visit["sid"][]=$sid;
                    $mass_visit["time"][]=$time;
                    $mass_visit["url"][]=$url;
                }


                //Таблица
                $table_width='70%';
                $mas_col["name"][0]='Дата и время';    $mas_col["width"][0]='15%';
                $mas_col["name"][1]='IP адрес';        $mas_col["width"][1]='12%';
                $mas_col["name"][2]='URL';             $mas_col["width"][2]='30%';
                $mas_col["name"][3]='SID';             $mas_col["width"][3]='13%';

                for($i=0;$i<count($mass_visit["ip"]);$i++)
                {
                     //Получить даты и клики
                     $mas_row["name"][]=date('d.m.Y H:m:s', $mass_visit["time"][$i]);
                }

                for($i=0;$i<count($mass_visit["ip"]);$i++)
                {
                     $mas_data[$i][1]=$mass_visit["ip"][$i];
                     $mas_data[$i][2]=$mass_visit["url"][$i];
                     $mas_data[$i][3]=$mass_visit["sid"][$i];
                }

                $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
            }

        }



        //Хосты по ip
        if ($type=='host_ip')
        {
            $this->path = './visit/';

            $date1=0;
            $date2=99999;

            if ($this->a_params["find_section_timestamp_1"]!="")
            {
                $splitdate1=split("\.",$this->a_params["find_section_timestamp_1"]);
                $date1 = (int)((strtotime($splitdate1[1]."/".$splitdate1[0]."/".$splitdate1[2])+10000)/86400);
            }

            if ($this->a_params["find_section_timestamp_2"]!="")
            {
                $splitdate2=split("\.",$this->a_params["find_section_timestamp_2"]);
                $date2 = (int)((strtotime($splitdate2[1]."/".$splitdate2[0]."/".$splitdate2[2])+10000)/86400);
            }

            if ($this->a_params["data"]=="")
            {
                $this->showFormSelect($objectname);

                //Получение кликов компания
                $tarray=file($this->path.'/'.$this->common_hits);
                for($i=0;$i<count($tarray);$i++)
                {
                    list($date,$num)=explode("|",$tarray[$i]);

                    if (($date>=$date1) AND ($date<=$date2))
                    {
                        //Получение объектов
                        $tarray_obj=file($this->path.'/'.$date.'.dat');
                        $host_common_quantity=0;
                        for($n=0;$n<count($tarray_obj);$n++)
                        {
                            list($ip,$sid,$time,$url)=explode("|",$tarray_obj[$n]);

                            if (trim($ip)==trim($this->a_params["ip"]))
                            {
                                if (isset($mass_host["ip"])) $search_ip=array_search($ip, $mass_host["ip"]);
                                if ((isset($search_ip)) AND ((is_numeric($search_ip)) AND ($date==$olddate)))
                                {
                                    $mass_host["quantity"][$search_ip]=$mass_host["quantity"][$search_ip]+1;
                                }
                                else
                                {
                                    $mass_host["ip"][]=$ip;
                                    $mass_host["sid"][]=$sid;
                                    $mass_host["time"][]=$time;
                                    $mass_host["url"][]=$url;
                                    $mass_host["quantity"][]=1;
                                }
                                $olddate=$date;
                                $host_common_quantity++;
                            }
                        }
                    }
                }

                //График
                $mas_message[0]='Обращения';
                $this->showGraph(null, null, null, $mas_message, count($mass_host["ip"]));

                //Таблица
                $table_width='41%';
                $mas_col["name"][0]='Дата';        $mas_col["width"][0]='15%';
                $mas_col["name"][1]='Обращений';   $mas_col["width"][1]='13%';
                $mas_col["name"][2]='%';           $mas_col["width"][2]='13%';

                $kol=31;
                $str_num=$this->a_params["start"]*$kol;
                $max=count($mass_host["ip"]);
                if ($max>($str_num+$kol)) $konec=($str_num+$kol);
                else $konec=$max;

                for($i=$str_num; $i<$konec; $i++)
                {
                     //Получить даты и клики
                     $mas_row["name"][]=date('d.m.Y', $mass_host["time"][$i]);
                     $mas_row["link"][]='./statistic.php?type=host_ip&ip='.$mass_host["ip"][$i].'&data='.(int)($mass_host["time"][$i]/86400);
                }

                $ind=0;
                for($i=$str_num; $i<$konec; $i++)
                {
                     $mas_data[$ind][1]=$mass_host["quantity"][$i];
                     $mas_data[$ind][2]=round((intval($mass_host["quantity"][$i])*100)/$host_common_quantity, 1);
                     $ind++;
                }

                $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
            }
            else
            {
                //Получить по дате
                $tarray_obj=file($this->path.'/'.$this->a_params["data"].'.dat');
                for($n=0;$n<count($tarray_obj);$n++)
                {
                    list($ip,$sid,$time,$url)=explode("|",$tarray_obj[$n]);

                    if (trim($ip)==trim($this->a_params["ip"]))
                    {
                            $mass_page["ip"][]=$ip;
                            $mass_page["sid"][]=$sid;
                            $mass_page["time"][]=$time;
                            $mass_page["url"][]=$url;
                    }

                }


                //Таблица
                $table_width='70%';
                $mas_col["name"][0]='Дата и время';    $mas_col["width"][0]='15%';
                $mas_col["name"][1]='URL';        $mas_col["width"][1]='30%';
                $mas_col["name"][2]='SID';             $mas_col["width"][2]='13%';

                for($i=0;$i<count($mass_page["url"]);$i++)
                {
                     //Получить даты и клики
                     $mas_row["name"][]=date('d.m.Y H:m:s', $mass_page["time"][$i]);
                }

                for($i=0;$i<count($mass_page["url"]);$i++)
                {
                     $mas_data[$i][1]=$mass_page["url"][$i];
                     $mas_data[$i][2]=$mass_page["sid"][$i];
                }

                $this->showTable($mas_col, $mas_row, $mas_data, $table_width);

            }

        }



        //Хосты
        if ($type=='host')
        {
            $this->path = './visit/';

            $date1=0;
            $date2=99999;

            if ($this->a_params["find_section_timestamp_1"]!="")
            {
                $splitdate1=split("\.",$this->a_params["find_section_timestamp_1"]);
                $date1 = (int)((strtotime($splitdate1[1]."/".$splitdate1[0]."/".$splitdate1[2])+10000)/86400);
            }

            if ($this->a_params["find_section_timestamp_2"]!="")
            {
                $splitdate2=split("\.",$this->a_params["find_section_timestamp_2"]);
                $date2 = (int)((strtotime($splitdate2[1]."/".$splitdate2[0]."/".$splitdate2[2])+10000)/86400);
            }

            $this->showFormSelect($objectname);

            //Получение кликов category
            $tarray=file($this->path.'/'.$this->common_hits);
            for($i=0;$i<count($tarray);$i++)
            {
                list($date,$num)=explode("|",$tarray[$i]);

                if (($date>=$date1) AND ($date<=$date2))
                {
                    //Получение объектов
                    $tarray_obj=file($this->path.'/'.$date.'.dat');
                    $host_common_quantity=0;
                    for($n=0;$n<count($tarray_obj);$n++)
                    {
                        list($ip,$sid,$time,$url)=explode("|",$tarray_obj[$n]);

                        if (isset($mass_host["ip"])) $search_ip=array_search($ip, $mass_host["ip"]);
                        if ((isset($search_ip)) AND (is_numeric($search_ip)))
                        {
                            $mass_host["quantity"][$search_ip]=$mass_host["quantity"][$search_ip]+1;
                            if ($mass_host["lasttime"][$search_ip]<=$time) $mass_host["lasttime"][$search_ip]=$time;
                        }
                        else
                        {
                            $mass_host["ip"][]=$ip;
                            $mass_host["sid"][]=$sid;
                            $mass_host["time"][]=$time;
                            $mass_host["url"][]=$url;
                            $mass_host["quantity"][]=1;
                            $mass_host["lasttime"][]=$time;
                        }
                        $host_common_quantity++;
                    }
                }
            }

            //Таблица
            $table_width='41%';
            $mas_col["name"][0]='IP адрес';     $mas_col["width"][0]='10%';
            $mas_col["name"][1]='Обращений';    $mas_col["width"][1]='13%';
            $mas_col["name"][2]='%';            $mas_col["width"][2]='13%';
            $mas_col["name"][3]='Время последнего обращения';       $mas_col["width"][3]='20%';

            if (isset($mass_host["ip"]))
            {
                for($i=0;$i<count($mass_host["ip"]);$i++)
                {
                    $mas_row["name"][]=$mass_host["ip"][$i];
                    $mas_row["link"][]='./statistic.php?type=host_ip&ip='.$mass_host["ip"][$i];
                }

                for($i=0;$i<count($mass_host["ip"]);$i++)
                {
                     $mas_data[$i][1]=intval($mass_host["quantity"][$i]);
                     $mas_data[$i][2]=round((intval($mass_host["quantity"][$i])*100)/$host_common_quantity, 1);
                     $mas_data[$i][3]=date('d.m.Y H:m:s', $mass_host["lasttime"][$i]);
                }
            }
            
            if ((isset($mas_row)) AND (isset($mas_data))) $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
                else
                echo '<table width="100%"  border="0" cellspacing="0" cellpadding="0" style="padding-left: 15px;"><tr><td class="text1">По Вашему запросу ничего не найдено';
                echo '</td></tr></table>';
            
        }



        //Показы по url
        if ($type=='page_url')
        {
            $this->path = './visit/';
            $page_common_quantity=0;
            if ($this->a_params["data"]=="")
            {
                //Получение кликов компания
                $tarray=file($this->path.'/'.$this->common_hits);
                for($i=0;$i<count($tarray);$i++)
                {
                    list($date,$num)=explode("|",$tarray[$i]);
                    //Получение объектов
                    $tarray_obj=file($this->path.'/'.$date.'.dat');                    
                    for($n=0;$n<count($tarray_obj);$n++)
                    {
                        list($ip,$sid,$time,$url)=explode("|",$tarray_obj[$n]);

                        if (trim($url)==trim($this->a_params["url"]))
                        {
                            if (isset($mass_page["url"])) $search_url=array_search($url, $mass_page["url"]);
                            if ((isset($search_url)) AND ((is_numeric($search_url)) AND ($date==$olddate)))
                            {
                                $mass_page["quantity"][$search_url]=$mass_page["quantity"][$search_url]+1;
                            }
                            else
                            {
                                $mass_page["ip"][]=$ip;
                                $mass_page["sid"][]=$sid;
                                $mass_page["time"][]=$time;
                                $mass_page["url"][]=$url;
                                $mass_page["quantity"][]=1;
                            }
                            $olddate=$date;
                            $page_common_quantity++;
                        }
                    }
                }


                //Таблица
                $table_width='41%';
                $mas_col["name"][0]='Дата';     $mas_col["width"][0]='15%';
                $mas_col["name"][1]='Показы';   $mas_col["width"][1]='13%';
                $mas_col["name"][2]='%';        $mas_col["width"][2]='13%';

                for($i=0;$i<count($mass_page["url"]);$i++)
                {
                     //Получить даты и клики
                     $mas_row["name"][]=date('d.m.Y', $mass_page["time"][$i]);
                     $mas_row["link"][]='./statistic.php?type=page_url&url='.$mass_page["url"][$i].'&data='.(int)($mass_page["time"][$i]/86400);
                }

                for($i=0;$i<count($mass_page["url"]);$i++)
                {
                     $mas_data[$i][1]=$mass_page["quantity"][$i];
                     if ($page_common_quantity!=0) $mas_data[$i][2]=round((intval($mass_page["quantity"][$i])*100)/$page_common_quantity, 1);
                     else $mas_data[$i][2]=0;
                }

                $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
            }
            else
            {
                //Получить по дате
                $tarray_obj=file($this->path.'/'.$this->a_params["data"].'.dat');
                for($n=0;$n<count($tarray_obj);$n++)
                {
                    list($ip,$sid,$time,$url)=explode("|",$tarray_obj[$n]);

                    if (trim($url)==trim($this->a_params["url"]))
                    {
                            $mass_page["ip"][]=$ip;
                            $mass_page["sid"][]=$sid;
                            $mass_page["time"][]=$time;
                            $mass_page["url"][]=$url;
                    }

                }


                //Таблица
                $table_width='47%';
                $mas_col["name"][0]='Дата и время';    $mas_col["width"][0]='15%';
                $mas_col["name"][1]='IP адрес';        $mas_col["width"][1]='20%';
                $mas_col["name"][2]='SID';             $mas_col["width"][2]='13%';

                for($i=0;$i<count($mass_page["url"]);$i++)
                {
                     //Получить даты и клики
                     $mas_row["name"][]=date('d.m.Y H:m:s', $mass_page["time"][$i]);
                }

                for($i=0;$i<count($mass_page["url"]);$i++)
                {
                     $mas_data[$i][1]=$mass_page["ip"][$i];
                     $mas_data[$i][2]=$mass_page["sid"][$i];
                }

                $this->showTable($mas_col, $mas_row, $mas_data, $table_width);

            }

        }



        //Страницы
        if ($type=='page')
        {
            $this->path = './visit/';
            //$this->showFormSelect($objectname);

            //Получение кликов category
            $tarray=file($this->path.'/'.$this->common_hits);
            $page_common_quantity=0;
            for($i=0;$i<count($tarray);$i++)
            {
                list($date,$num)=explode("|",$tarray[$i]);

                //Получение объектов
                $tarray_obj=file($this->path.'/'.$date.'.dat');
                for($n=0;$n<count($tarray_obj);$n++)
                {
                    list($ip,$sid,$time,$url)=explode("|",$tarray_obj[$n]);

                    if (isset($mass_page["url"])) $search_url=array_search($url, $mass_page["url"]);
                    if ((isset($search_url)) AND (is_numeric($search_url)))
                    {
                        $mass_page["quantity"][$search_url]=$mass_page["quantity"][$search_url]+1;
                    }
                    else
                    {
                        $mass_page["ip"][]=$ip;
                        $mass_page["sid"][]=$sid;
                        $mass_page["time"][]=$time;
                        $mass_page["url"][]=$url;
                        $mass_page["quantity"][]=1;
                    }
                    $page_common_quantity++;
                }
            }

            //Таблица
            $table_width='41%';
            $mas_col["name"][0]='URL';     $mas_col["width"][0]='80%';
            $mas_col["name"][1]='Показы';  $mas_col["width"][1]='13%';
            $mas_col["name"][2]='%';       $mas_col["width"][2]='13%';

            for($i=0;$i<count($mass_page["url"]);$i++)
            {
                $mas_row["name"][]=$mass_page["url"][$i];
                $mas_row["link"][]='./statistic.php?type=page_url&url='.$mass_page["url"][$i];
            }

            for($i=0;$i<count($mass_page["url"]);$i++)
            {
                 $mas_data[$i][1]=intval($mass_page["quantity"][$i]);
                 $mas_data[$i][2]=round((intval($mass_page["quantity"][$i])*100)/$page_common_quantity, 1);
            }
            
            array_multisort($mas_data, SORT_DESC);
            
            $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
        }



        //Клики по категориям
        if (($type=='click_category') OR ($type=='click_object_property_link') OR ($type=='click_banner_link'))
        {
            $t_name=split("_", $type);

            $pos = strpos($type, "_");
            $t_name[1] = substr($type, $pos+1 , (strlen($type)-$pos));

            $this->path = './click/';

            if ($this->a_params["id"]=="")
            {
                $this->showFormSelect($objectname);

                //Получение кликов category
                $tarray=file($this->path.$t_name[1].'/'.$this->common_click);

                for($i=0;$i<count($tarray);$i++)
                {
                    list($date,$num)=explode("|",$tarray[$i]);

                    //Получение объектов
                    $tarray_obj=file($this->path.$t_name[1].'/'.$date.'_com.dat');
                    for($n=0;$n<count($tarray_obj);$n++)
                    {
                        list($obj_id,$quantity)=explode("|",$tarray_obj[$n]);

                        $search_id=array_search($obj_id, $mass_categoiry["id"]);
                        if (is_numeric($search_id))
                        {
                            $mass_categoiry["quantity"][$search_id]=$mass_categoiry["quantity"][$search_id]+$quantity;
                        }
                        else
                        {
                            $mass_categoiry["id"][]=$obj_id;
                            $mass_categoiry["quantity"][]=$quantity;
                        }
                    }

                }
                $click_category_quantity=$i;


                //Таблица
                $table_width='41%';
                $mas_col["name"][0]='Название';     $mas_col["width"][0]='80%';
                $mas_col["name"][1]='Клики';      $mas_col["width"][1]='13%';

                for($i=0;$i<count($mass_categoiry["id"]);$i++)
                {
                     //Получить название компании из БД
                     if ($t_name[1]=="object_property_link") $table_name=$this->objects->getTablePropertyName($t_name[1], $mass_categoiry["id"][$i]);
                     if ($t_name[1]=="category") $table_name=$this->objects->getTableName($t_name[1], $mass_categoiry["id"][$i]);
                     if ($t_name[1]=="banner_link") $table_name=$this->objects->getTableBannerName($t_name[1], $mass_categoiry["id"][$i]);
                     if ($table_name["name"][0]=="") $mas_row["name"][]="no data";
                     else $mas_row["name"][]=$table_name["name"][0];
                     $mas_row["link"][]='./statistic.php?type=click_'.$t_name[1].'&id='.$mass_categoiry["id"][$i];
                }

                for($i=0;$i<count($mass_categoiry["id"]);$i++)
                {
                     $mas_data[$i][1]=intval($mass_categoiry["quantity"][$i]);
                }

                $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
            }
            else
            {
                //Выбрана компания

                if ($this->a_params["data"]=="")
                {
                    //Получение кликов компания
                    $tarray=file($this->path.$t_name[1].'/'.$this->common_click);
                    $o=0;
                    for($i=0;$i<count($tarray);$i++)
                    {
                        list($date,$num)=explode("|",$tarray[$i]);
                        //Получение объектов
                        $tarray_obj=file($this->path.$t_name[1].'/'.$date.'.dat');
                        for($n=0;$n<count($tarray_obj);$n++)
                        {
                            list($obj_id,$ip,$sid,$time,$url)=explode("|",$tarray_obj[$n]);

                            if ($obj_id==$this->a_params["id"])
                            {
                                $search_id=array_search($obj_id, $mass_categoiry["id"]);
                                if ((is_numeric($search_id)) AND ($date==$olddate))
                                {
                                    $mass_categoiry["quantity"][$o-1]=$mass_categoiry["quantity"][$o-1]+1;

                                    $sid_id=array_search($sid, $mass_sid[$o-1]);
                                    if (!is_numeric($sid_id))
                                    {
                                        $mass_sid[$o-1][]=$sid;
                                    }
                                }
                                else
                                {
                                    $mass_categoiry["id"][$o]=$obj_id;
                                    $mass_categoiry["ip"][$o]=$ip;
                                    $mass_categoiry["sid"][$o]=$sid;
                                    $mass_categoiry["time"][$o]=$time;
                                    $mass_categoiry["url"][$o]=$url;
                                    $mass_categoiry["quantity"][$o]=1;
                                    $mass_sid[$o][]=$sid;
                                    $o++;
                                }
                                $olddate=$date;
                            }

                        }

                    }
                    $click_category_quantity=$i;


                    //Таблица
                    $table_width='41%';
                    $mas_col["name"][0]='Дата';                $mas_col["width"][0]='15%';
                    $mas_col["name"][1]='Первичный клик';      $mas_col["width"][1]='13%';
                    $mas_col["name"][2]='Вторичный клик';      $mas_col["width"][2]='13%';
                    $mas_col["name"][3]='Общий клик';          $mas_col["width"][3]='13%';

                    for($i=0;$i<count($mass_categoiry["id"]);$i++)
                    {
                         //Получить даты и клики
                         $mas_row["name"][]=date('d.m.Y', $mass_categoiry["time"][$i]);
                         $mas_row["link"][]='./statistic.php?type=click_'.$t_name[1].'&id='.$mass_categoiry["id"][$i].'&data='.(int)($mass_categoiry["time"][$i]/86400);
                    }

                    for($i=0;$i<count($mass_categoiry["id"]);$i++)
                    {
                         $mas_data[$i][1]=count($mass_sid[$i]);
                         $mas_data[$i][2]=intval($mass_categoiry["quantity"][$i])-count($mass_sid[$i]);
                         $mas_data[$i][3]=intval($mass_categoiry["quantity"][$i]);
                    }

                    $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
                }
                else
                {
                    //Получить по дате
                    $tarray_obj=file($this->path.$t_name[1].'/'.$this->a_params["data"].'.dat');
                    for($n=0;$n<count($tarray_obj);$n++)
                    {
                        list($obj_id,$ip,$sid,$time,$url)=explode("|",$tarray_obj[$n]);

                        if ($obj_id==$this->a_params["id"])
                        {
                                $mass_categoiry["id"][]=$obj_id;
                                $mass_categoiry["ip"][]=$ip;
                                $mass_categoiry["sid"][]=$sid;
                                $mass_categoiry["time"][]=$time;
                                $mass_categoiry["url"][]=$url;
                        }

                    }


                    //Таблица
                    $table_width='90%';
                    $mas_col["name"][0]='Дата и время';        $mas_col["width"][0]='15%';
                    $mas_col["name"][1]='IP адрес';             $mas_col["width"][1]='20%';
                    $mas_col["name"][2]='SID';    $mas_col["width"][2]='13%';
                    $mas_col["name"][3]='URL';             $mas_col["width"][3]='70%';

                    for($i=0;$i<count($mass_categoiry["id"]);$i++)
                    {
                         //Получить даты и клики
                         $mas_row["name"][]=date('d.m.Y H:m:s', $mass_categoiry["time"][$i]);
                    }

                    for($i=0;$i<count($mass_categoiry["id"]);$i++)
                    {
                         $mas_data[$i][1]=$mass_categoiry["ip"][$i];
                         $mas_data[$i][2]=$mass_categoiry["sid"][$i];
                         $mas_data[$i][3]=$mass_categoiry["url"][$i];
                    }

                    $this->showTable($mas_col, $mas_row, $mas_data, $table_width);

                }

            }
        }



        //Клики
        if ($type=='click')
        {
            $this->path = './click/';

            //Получение кликов category
            $tarray=file($this->path.'category/'.$this->common_click);
            for($i=0;$i<count($tarray);$i++)
            {
                list($date,$num)=explode("|",$tarray[$i]);

                if($this->dates==$date) { $click_category_today=$hits_category_today+$num; }                   //сегодня
                if($this->yesterday==$date) { $click_category_yestertday=$click_category_yestertday+$num; }     //вчера
                if($this->week<=$date) { $click_category_week=$click_category_week+$num; }                      //неделя
                if($this->mon<=$date) { $click_category_mon=$click_category_mon+$num; }                         //месяц
                $click_category_total=$click_category_total+$num;                                               //всего
            }
            $click_category_quantity=$i;

            //Получение кликов category_property_link
            $tarray=file($this->path.'object_property_link/'.$this->common_click);
            for($i=0;$i<count($tarray);$i++)
            {
                list($date,$num)=explode("|",$tarray[$i]);

                if($this->dates==$date) { $click_property_today=$hits_property_today+$num; }                   //сегодня
                if($this->yesterday==$date) { $click_property_yestertday=$click_property_yestertday+$num; }     //вчера
                if($this->week<=$date) { $click_property_week=$click_property_week+$num; }                      //неделя
                if($this->mon<=$date) { $click_property_mon=$click_property_mon+$num; }                         //месяц
                $click_property_total=$click_property_total+$num;                                               //всего
            }
            $click_property_quantity=$i;

            //Получение кликов banner
            $tarray=file($this->path.'banner_link/'.$this->common_click);
            for($i=0;$i<count($tarray);$i++)
            {
                list($date,$num)=explode("|",$tarray[$i]);

                if($this->dates==$date) { $click_banner_today=$hits_banner_today+$num; }                   //сегодня
                if($this->yesterday==$date) { $click_banner_yestertday=$click_banner_yestertday+$num; }     //вчера
                if($this->week<=$date) { $click_banner_week=$click_banner_week+$num; }                      //неделя
                if($this->mon<=$date) { $click_banner_mon=$click_banner_mon+$num; }                         //месяц
                $click_banner_total=$click_banner_total+$num;                                               //всего
            }
            $click_banner_quantity=$i;

            //Таблица
            $table_width='41%';
            $mas_col["name"][0]='&nbsp;';     $mas_col["width"][0]='19%';
            $mas_col["name"][1]='всего';      $mas_col["width"][1]='13%';
            $mas_col["name"][2]='сегодня';    $mas_col["width"][2]='13%';
            $mas_col["name"][3]='вчера';      $mas_col["width"][3]='13%';
            $mas_col["name"][4]='за неделю';  $mas_col["width"][4]='13%';
            $mas_col["name"][5]='за месяц';   $mas_col["width"][5]='13%';

            $mas_row["name"][0]='Компании:';  $mas_row["link"][0]='./statistic.php?type=click_category';
            $mas_row["name"][1]='Ссылки:';    $mas_row["link"][1]='./statistic.php?type=click_object_property_link';
            $mas_row["name"][2]='Баннеры:';   $mas_row["link"][2]='./statistic.php?type=click_banner_link';

            $mas_data[0][1]=intval($click_category_total);
            $mas_data[0][2]=intval($click_category_today);
            $mas_data[0][3]=intval($click_category_yestertday);
            $mas_data[0][4]=intval($click_category_week);
            $mas_data[0][5]=intval($click_category_mon);

            $mas_data[1][1]=intval($click_property_total);
            $mas_data[1][2]=intval($click_property_today);
            $mas_data[1][3]=intval($click_property_yestertday);
            $mas_data[1][4]=intval($click_property_week);
            $mas_data[1][5]=intval($click_property_mon);

            $mas_data[2][1]=intval($click_banner_total);
            $mas_data[2][2]=intval($click_banner_today);
            $mas_data[2][3]=intval($click_banner_yestertday);
            $mas_data[2][4]=intval($click_banner_week);
            $mas_data[2][5]=intval($click_banner_mon);

            $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
        }


        //Общая
        if ($type=='common')
        {
            $this->path = './visit/';
            //Insert_online
            $readdata=fopen($this->path.$this->online_data,"r") or die("Не могу открыть файл ".$this->online_data);
            $online_data_array=file($this->path.$this->online_data);
            fclose($readdata);

            $d=count($online_data_array);
            for($i=0;$i<$d;$i++)
            {
            list($live_user,$last_time)=explode("::","$online_data_array[$i]");
            if($live_user!=""&&$last_time!=""):
            if($last_time<$this->past_time):
                    $live_user="";
                    $last_time="";
            endif;
            if($live_user!=""&&$last_time!="")
                {
                if($this->ip==$live_user)
                        {
                        $online_array[]="$this->ip::$this->times\r\n";
                        }
                else
                        $online_array[]="$live_user::$last_time";
                }
            endif;
            }

            if(isset($online_array)):
            foreach($online_array as $i=>$str)
            {
            if($str=="$this->ip::$this->times\r\n")
                    {
                    $ok=$i;
                    break;
                    }
            }
            foreach($online_array as $j=>$str)
            {
            if($ok==$j) { $online_array[$ok]="$this->ip::$this->times\r\n"; break;}
            }
           endif;

            $writedata=fopen($this->path.$this->online_data,"w") or die("Не могу открыть файл ".$this->online_data);
            flock($writedata,2);
            if(!isset($online_array)) $online_array[]="$this->ip::$this->times\r\n";
            foreach($online_array as $str)
            fputs($writedata,"$str");
            flock($writedata,3);
            fclose($writedata);

            $readdata=fopen($this->path.$this->online_data,"r") or die("Не могу открыть файл ".$this->online_data);
            $online_data_array=file($this->path.$this->online_data);
            fclose($readdata);
            $online=count($online_data_array);


            //Получение хитов
            $hits_today=0;
            $hits_yestertday=0;
            $hits_week=0;
            $hits_mon=0;
            $hits_total=0;
            $tarray=file($this->path.$this->common_hits);
            for($i=0;$i<count($tarray);$i++)
            {
                list($date,$num)=explode("|",$tarray[$i]);

                if($this->dates==$date) { $hits_today=$hits_today+$num; }                   //сегодня
                if($this->yesterday==$date) { $hits_yestertday=$hits_yestertday+$num; }     //вчера
                if($this->week<=$date) { $hits_week=$hits_week+$num; }                      //неделя
                if($this->mon<=$date) { $hits_mon=$hits_mon+$num; }                         //месяц
                $hits_total=$hits_total+$num;                                               //всего
            }
            $hits_quantity=$i;

            //Получение посещений
            $sid_today=0;
            $sid_yestertday=0;
            $sid_week=0;
            $sid_mon=0;
            $sid_total=0;
            $tarray=file($this->path.$this->common_sid);
            for($i=0;$i<count($tarray);$i++)
            {
                list($date,$num)=explode("|",$tarray[$i]);

                if($this->dates==$date) { $sid_today=$sid_today+$num; }                   //сегодня
                if($this->yesterday==$date) { $sid_yestertday=$sid_yestertday+$num; }     //вчера
                if($this->week<=$date) { $sid_week=$sid_week+$num; }                      //неделя
                if($this->mon<=$date) { $sid_mon=$sid_mon+$num; }                         //месяц
                $sid_total=$sid_total+$num;                                               //всего
            }
            $sid_quantity=$i;

            //Получение хостов
            $hosts_today=0;
            $hosts_yestertday=0;
            $hosts_week=0;
            $hosts_mon=0;
            $hosts_total=0;
            $tarray=file($this->path.$this->common_hosts);
            for($i=0;$i<count($tarray);$i++)
            {
                list($date,$num)=explode("|",$tarray[$i]);

                if($this->dates==$date) { $hosts_today=$hosts_today+$num; }                   //сегодня
                if($this->yesterday==$date) { $hosts_yestertday=$hosts_yestertday+$num; }     //вчера
                if($this->week<=$date) { $hosts_week=$hosts_week+$num; }                      //неделя
                if($this->mon<=$date) { $hosts_mon=$hosts_mon+$num; }                         //месяц
                $hosts_total=$hosts_total+$num;                                               //всего
            }
            $hosts_quantity=$i;

            //График
            $mas_message[0]='Хиты';
            $mas_message[1]='Посещения';
            $mas_message[2]='Хосты';
            $this->showGraph(null, null, null, $mas_message, $hits_quantity);

            //Online
            $this->showOnline($online);

            //Таблица
            $table_width='60%';
            $mas_col["name"][0]='&nbsp;';     $mas_col["width"][0]='19%';
            $mas_col["name"][1]='всего';      $mas_col["width"][1]='13%';
            $mas_col["name"][2]='сегодня';    $mas_col["width"][2]='13%';
            $mas_col["name"][3]='вчера';      $mas_col["width"][3]='13%';
            $mas_col["name"][4]='за неделю';  $mas_col["width"][4]='13%';
            $mas_col["name"][5]='за месяц';   $mas_col["width"][5]='13%';

            $mas_row["name"][0]='Хитов:';
            $mas_row["name"][1]='Посещений:';
            $mas_row["name"][2]='Хостов:';

            $mas_data[0][1]=intval($hits_total);
            $mas_data[0][2]=intval($hits_today);
            $mas_data[0][3]=intval($hits_yestertday);
            $mas_data[0][4]=intval($hits_week);
            $mas_data[0][5]=intval($hits_mon);

            $mas_data[1][1]=intval($sid_total);
            $mas_data[1][2]=intval($sid_today);
            $mas_data[1][3]=intval($sid_yestertday);
            $mas_data[1][4]=intval($sid_week);
            $mas_data[1][5]=intval($sid_mon);

            $mas_data[2][1]=intval($hosts_total);
            $mas_data[2][2]=intval($hosts_today);
            $mas_data[2][3]=intval($hosts_yestertday);
            $mas_data[2][4]=intval($hosts_week);
            $mas_data[2][5]=intval($hosts_mon);

            $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
            echo '<p>&nbsp;</p>';
            //include("../admin/class/rank.php");
        }


        //Общая
        if ($type=='wap')
        {
            $this->path = './wap/visit/';
            $common_hits="common_hits.dat";
            $common_hosts="common_hosts.dat";


            echo '<img src="./wap/krug.php">';


            echo "<table cellspacing=1 cellpadding=2 border=0 style=\"font-family:Verdana;font-size:11px;\" align=left>";
            $this->clicked(14, "Знаменитости");
            echo "</table><br>";

            echo "<table cellspacing=1 cellpadding=2 border=0 style=\"font-family:Verdana;font-size:11px;\" align=left>";
            $this->clicked(13, "Найди себя");
            echo "</table><br>";

            echo "<table cellspacing=1 cellpadding=2 border=0 style=\"font-family:Verdana;font-size:11px;\" align=left>";
            $this->clicked(11, "Треки");
            echo "</table><br>";
            //$this->clicked(17, "Музыкальные темы");
            //$this->clicked(18, "Звуки и фразы");
            //$this->clicked(19, "Звуки для СМС");
            //$this->clicked(13, "Постеры");
            //$this->clicked(15, "Анимации");
            echo "<table cellspacing=1 cellpadding=2 border=0 style=\"font-family:Verdana;font-size:11px;\" align=left>";
            $this->clicked_tema("Темы");
            echo "</table><br>";

        }
    }


    //Получение скачек контента для WAP
    function clicked($category_num, $name)
    {
        global $objects;

        //Таблица
        $table_width='50%';
        $mas_col["name"][0]='<strong>'.$name.'</strong>';     $mas_col["width"][0]='100%';
        $this->showTable($mas_col, $mas_row, $mas_data, $table_width);

        $table_width='50%';
        $mas_col["name"][0]='&nbsp;';     $mas_col["width"][0]='7%';
        $mas_col["name"][1]='Название';      $mas_col["width"][1]='40%';
        $mas_col["name"][2]='Скачано';    $mas_col["width"][2]='40%';

        $query_statistic = $objects->getObjectClick($category_num);
        if ((isset($query_statistic["object_id"])) AND (count($query_statistic["object_id"])>0))
        {
            $i=1;
            for ($n=0;$n<count($query_statistic["object_id"]);$n++)
            {
                $mas_row["name"][$n]=$i;
                $mas_data[$n][1]='<a href="../index.php?sort,top,c,'.$query_statistic["category_id"][$n].'" class="links5">'.
                $query_statistic["object_name"][$n].'</a> ('.$query_statistic["category_name"][$n].')';
                $mas_data[$n][2]=$query_statistic["object_top"][$n];
                $i++;
            }
        }
        $this->showTable($mas_col, $mas_row, $mas_data, $table_width);
    }

    //Получение скачек тем для WAP
    function clicked_tema($name)
    {
        global $objects;

        //Таблица
        $table_width='50%';
        $mas_col["name"][0]=$name;     $mas_col["width"][0]='100%';
        $this->showTable($mas_col, $mas_row, $mas_data, $table_width);

        $table_width='60%';
        $mas_col["name"][0]='&nbsp;';     $mas_col["width"][0]='13%';
        $mas_col["name"][1]='Название';      $mas_col["width"][1]='23%';
        $mas_col["name"][2]='Скачано';    $mas_col["width"][2]='23%';

        $mas_row["name"][0]='Хитов:';

        $query_statistic = $objects->getObjectClickTema();

        if ((isset($query_statistic["object_id"])) AND (count($query_statistic["object_id"])>0))
        {
            $i=1;
            for ($n=0;$n<count($query_statistic["object_id"]);$n++)
            {
                //$i
                $mas_data[0][1]='<a href="../index.php?sort,top,c,'.$query_statistic["category_id"][$n].'" class="links5">'.
                $query_statistic["object_name"][$n].'</a> ('.$query_statistic["category_name"][$n].')';
                $mas_data[0][2]=$query_statistic["object_top"][$n];
                $i++;
            }
        }
    }



    //Получить данные по кликам
    function getClick($type, $date_begin = null, $date_end = null)
    {

    }

    //Вывод таблицы по данным статистики
    function showTable($mas_col, $mas_row, $mas_data, $table_width)
    {
        $mas_col_count=count($mas_col["name"]);
        $mas_row_count=count($mas_row["name"]);

        echo '<table width="'.$table_width.'"  border="0" cellpadding="2" cellspacing="1" bgcolor="#3E71DB">';
        echo '<tr valign="top" bgcolor="#3E71DB">';
        for ($i=0;$i<$mas_col_count;$i++)
        {
            echo '<td width="'.$mas_col["width"][$i].'" class="text"><div align="center">'.$mas_col["name"][$i].'</div></td>';
        }
        echo '</tr>';

        for ($i=0;$i<$mas_row_count;$i++)
        {
            if (($i % 2)==0) $bcolor='bgcolor="#538BFF"'; else $bcolor='bgcolor="#6699FF"';
            echo '<tr '.$bcolor.'>';
            echo '<td class="text">';
            if (isset($mas_row["link"][$i]))
            {
                echo '<a href="'.$mas_row["link"][$i].'" class="links5">';
                
                $value=$mas_row["name"][$i];
                $out_table=array(); 
                $mass_category=array();
                $mass_object=array();
                //Проверка на категорию
                $preg = "|c=(\d+)|si";
                preg_match_all(trim($preg), $value, $out_table);
                if (isset($out_table[1][0])) $mass_category=$this->getCategory($out_table[1][0]);
                
                //Проверка на объект
                $preg = "|o=(\d+)|si";
                preg_match_all(trim($preg), $value, $out_table);
                if (isset($out_table[1][0])) $mass_object=$this->getObject($out_table[1][0]);
                
                if (isset($mass_object["object_name"][0])) 
                {   
                    echo $mass_object["object_name"][0];
                }
                else
                {
                    if (isset($mass_category["category_name"][0])) 
                    { 
                        echo $mass_category["category_name"][0];
                    }
                    else
                    {
                        echo $value;
                    }
                }
                                
                echo '</a>';
            }
            else
            {
                echo $mas_row["name"][$i];
            }
            echo '</td>';
            for ($n=1;$n<$mas_col_count;$n++)
            {
                echo '<td class="text"><div align="center">';
                $value=$mas_data[$i][$n];
                $out_table=array();
                $mass_category=array();
                $mass_object=array();
                //Проверка на категорию
                $preg = "|c=(\d+)|si";
                preg_match_all(trim($preg), $value, $out_table);
                if (isset($out_table[1][0])) $mass_category=$this->getCategory($out_table[1][0]);
                
                //Проверка на объект
                $preg = "|o=(\d+)|si";
                preg_match_all(trim($preg), $value, $out_table);
                if (isset($out_table[1][0])) $mass_object=$this->getObject($out_table[1][0]);
                
                if (isset($mass_object["object_name"][0])) 
                {   
                    echo $mass_object["object_name"][0];
                }
                else
                {
                    if (isset($mass_category["category_name"][0])) 
                    { 
                        echo $mass_category["category_name"][0];
                    }
                    else
                    {
                        echo $value;
                    }
                }
                
                echo '</div></td>';
            }
            echo '</tr>';
        }
        echo '</table>';
    }

    //Вывод таблицы по данным статистики
    function showOnline($online)
    {
        echo '<span class="text"><strong>Сейчас на сайте:</strong> </span><span class="text">'.$online.'</span><br>&nbsp;<br>';
    }

    //Вывод формы отбора
    function showFormSelect($objectname)
    {
        echo '<table border="0" cellspacing="0" cellpadding="3">';
        echo '<tr>';
        echo '<td>';
        echo '<span class="text"><strong>&nbsp;&nbsp;&nbsp;'.$objectname.' за период: </strong></span><br>';
        echo '</td>';
        echo '</tr>';
        echo '<tr>';
        echo '<td>';
        echo '<table border="0" cellspacing="0" cellpadding="3">';
        echo '<tr>';
        echo '<td>';
		echo '<span class="text">с&nbsp;';

        echo '<script type="text/javascript" src="calendar/calendar.js"></script><script type="text/javascript">';
        echo "jsCalendar.mess = {";
        echo "'title': 'Календарь',";
        echo "'date': 'Вставить дату',";
        echo "'jan': 'Январь',";
        echo "'feb': 'Февраль',";
        echo "'mar': 'Март',";
        echo "'apr': 'Апрель',";
        echo "'may': 'Май',";
        echo "'jun': 'Июнь',";
        echo "'jul': 'Июль',";
        echo "'aug': 'Август',";
        echo "'sep': 'Сентябрь',";
        echo "'okt': 'Октябрь',";
        echo "'nov': 'Ноябрь',";
        echo "'des': 'Декабрь',";
        echo "'prev_mon': 'Предыдущий месяц',";
        echo "'next_mon': 'Следующий месяц',";
        echo "'curr': 'Перейти на текущий месяц',";
        echo "'curr_day': 'Вставить текущую дату',";
        echo "'mo': 'Пн',";
        echo "'tu': 'Вт',";
        echo "'we': 'Ср',";
        echo "'th': 'Чт',";
        echo "'fr': 'Пт',";
        echo "'sa': 'Сб',";
        echo "'su': 'Вс',";
        echo "'per_week': 'Период: неделя',";
        echo "'per_mon': 'Период: месяц',";
        echo "'per_year': 'Период: год',";
        echo "'close': 'Закрыть',";
        echo "'month': 'Выбрать месяц',";
        echo "'year': 'Выбрать год',";
        echo "'time': 'Показать время',";
        echo "'time_hide': 'Скрыть время',";
        echo "'hour': 'ч:',";
        echo "'minute': 'м:',";
        echo "'second': 'с:',";
        echo "'hour_title': 'Часы (00 - 23)',";
        echo "'minute_title': 'Минуты (00 - 59)',";
        echo "'second_title': 'Секунды (00 - 59)',";
        echo "'set_time': 'Установить текущее время (серверное)',";
        echo "'clear_time': 'Сбросить время'";
        echo "};";
        echo "</script>";
        echo '<input class="input" type="text" name="find_section_timestamp_1" size="10" value="'.$this->a_params["find_section_timestamp_1"].'">';
        echo "<a href=\"javascript:void(0);\" title=\"Календарь\"><img src=\"calendar/images/icon.gif\" alt=\"Календарь\" class=\"calendar-icon\" onclick=\"jsCalendar.Show(this, 'find_section_timestamp_1', 'find_section_timestamp_1', 'find_section_timestamp_1', false, ".time().");\"></a>";



		echo '&nbsp;по&nbsp;';
		echo '<input name="find_section_timestamp_2" type="text" value="'.$this->a_params["find_section_timestamp_2"].'" size="10"  class="input">';

        echo "<a href=\"javascript:void(0);\" title=\"Календарь\"><img src=\"calendar/images/icon.gif\" alt=\"Календарь\" class=\"calendar-icon\" onclick=\"jsCalendar.Show(this, 'find_section_timestamp_2', 'find_section_timestamp_2', 'find_section_timestamp_2', false, 1167835473);\" onmouseover=\"this.className+=' calendar-icon-hover';\" onmouseout=\"this.className = this.className.replace(/\s*calendar-icon-hover/ig, '');\"></a>";

        echo '</span>';
		echo '</td>';
        echo '<td>';
		echo '<span class="text">';
        echo '<a href="javascript: SelectDate()"><img src="pict/knopka3.jpg" width="83" height="21" border="0" alt="показать"></a>';
        echo '<SCRIPT language=JavaScript>';
        echo 'function SelectDate()';
        echo '{';
        echo 'document.formcase.submit();';
        echo '}';
        echo '</SCRIPT>';
        echo '</span>';
		echo '</td>';
        echo '</tr>';
        echo '</table>';
        echo '</td>';
        echo '</tr>';
        echo '</table>';
        echo '<br>';
    }

    //Вывод графика по данным статистики
    function showGraph($type, $date_begin = null, $date_end = null, $mas_message = null, $quantity = 0)
    {

        $kol=31;
        if ($this->a_params["start"]=="") $this->a_params["start"]=intval($quantity/$kol);
        $str_num=$this->a_params["start"]*$kol;
        $max=$quantity;

        if ($max>($str_num+$kol)) $konec=($str_num+$kol);
        else $konec=$max;

        echo '<table width="504"  border="0" cellspacing="0" cellpadding="2">';
        echo '<tr>';
        echo '<td>';

        $form_link='';
        $great_labels = array_keys($this->a_params);
        for ($i=0; $i<count($great_labels); $i++)
        {
            if (($this->a_params[$great_labels[$i]]!="") AND ($great_labels[$i]!="start")) 
            $form_link = $form_link.'&'.$great_labels[$i].'='.$this->a_params[$great_labels[$i]];
        }
        $form_link=substr($form_link,1,strlen($form_link)-1);

        print LeftRight($max,$this->a_params["start"],
        "./statistic.php?".$form_link.
        "&start=",$kol);
        echo '</td>';
        echo '</tr>';
        echo '<tr>';
        echo '<td>';
        echo '<img src="graph.php?'.$form_link.'&start='.$this->a_params["start"].'">';
        echo '</td>';
        echo '</tr>';
        echo '</table>';


        //Вывод определения цветов
        if (isset($mas_message))
        {
            echo '<table width="504"  border="0" cellspacing="0" cellpadding="2">';
            echo '<tr class="text">';
            echo '<td width="30%">';
            if (isset($mas_message[0]))
            {
                echo '<table border="0" cellspacing="0" cellpadding="2" align="right">';
                echo '<tr class="text1">';
                echo '<td>'.$mas_message[0].' &#8212; </td>';
                echo '<td width="10"><img src="pict/yellow.gif" width="9" height="9" class="ramka"></td>';
                echo '</tr>';
                echo '</table>';
            }
            echo '</td>';
            echo '<td width="30%">';
            if (isset($mas_message[1]))
            {
                echo '<table  border="0" cellspacing="0" cellpadding="2" align="center">';
                echo '<tr class="text1">';
                echo '<td>'.$mas_message[1].' &#8212;  </td>';
                echo '<td width="10"><img src="pict/green.gif" width="9" height="9" class="ramka"></td>';
                echo '</tr>';
                echo '</table>';
            }
            echo '</td>';
            echo '<td width="30%">';
            if (isset($mas_message[2]))
            {
                echo '<table  border="0" cellspacing="0" cellpadding="2">';
                echo '<tr class="text1">';
                echo '<td>'.$mas_message[2].' &#8212; </td>';
                echo '<td width="10"><img src="pict/blue.gif" width="9" height="9" class="ramka"></td>';
                echo '</tr>';
                echo '</table>';
            }
            echo '</td>';
            echo '</tr>';
            echo '</table>';
        }

        echo '<br>';
    }

    //Получение объекта
    function getObject($id)
    {
        $res = $this->objects->db->Execute("SELECT object_name FROM object WHERE object_id=".$id); 
        
        $mass_object=array();
        if ($res->RecordCount()>0)
        {
            $element = $res->FetchArray();
            $mass_object["object_name"][]=$element["object_name"];
        }

        return $mass_object;
    }
    
    //Получение категории
    function getCategory($id)
    {
        $res = $this->objects->db->Execute("SELECT category_name FROM category WHERE category_id=".$id); 
        
        $mass_category=array();
        if ($res->RecordCount()>0)
        {
            $element = $res->FetchArray();
            $mass_category["category_name"][]=$element["category_name"];
        }

        return $mass_category;
    }
    
    //Количество
    function RecordCount()
    {
        return $this->res->RecordCount();
    }

    //Выборка
    function FetchArray()
    {
        return $this->res->FetchArray();
    }

}
?>
