<?php
header("Content-Type: text/html; charset=UTF-8",true);
session_start();
error_reporting(0);
include("./cfg/connect.php");
include("./admin/functions/functions.php");
require_once('./admin/class/db_mysql.php');
require_once('./admin/class/category.php');
require_once('./admin/class/edit.php');
require_once('./admin/class/objects.php');
require_once('./admin/class/banner.php');

$db = new db(DB_HOST, $DB_USER, $DB_PASSWORD, DB_BASE_NAME);
$sql = 'SET NAMES utf8';
$db->Execute($sql);
unset($DB_PASSWORD, $DB_USER);

// 
checkUser();

//  
$category = new category('category', 'category', $db);

//   (insert, update, delete)
include("./admin/action/act.php");

//   
$banner = new banner($db, $a_params, $banner_tree);
$banner_id=$banner->getTree(1);

getParam("id", null);
getParam("select_id", null); 
getParam("action", null);

$category->Parents($a_params["id"]);
while ($item = $category->NextRow())
{
    $a_branch[]=$item["category_id"];
}

//  $ID, $newParentId
//$category->MoveAll(82, 1);  

// 
//$category->Resurection();

if ($_SESSION["access_group_id"]==1)
{
?>
<html>
<head>
<title>ABCname.net CMS</title>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=utf-8">  
<link href="./admin/images/favico.ico" rel="shortcut icon" type="image/x-icon" />
<script type="text/javascript" language="JavaScript1.2" src="./admin/menu/tree-menu/apytmenu.js"></script>
<script type="text/javascript" language="JavaScript1.2" src="./admin/menu/tree-menu/apytmenu_dyn.js"></script>
<script type="text/javascript" language="JavaScript1.2">

var tpressedFontColor = "#AA0000";

var tpathPrefix_img = "./admin/menu/img/";

var tlevelDX = 1;
var ttoggleMode = 1;

var texpanded = 0;
var tcloseExpanded   = 0;
var tcloseExpandedXP = 0;

//var texpandItemClick = 1;

var tblankImage      = "./admin/menu/img/blank.gif";
var tmenuWidth       = 170;
var tmenuHeight      = 0;

var tabsolute        = 1;
var tleft            = 5;
var ttop             = 65

var tfloatable       = 0;
var tfloatIterations = 10;

var tmoveable        = 0;
var tmoveImage       = "./admin/menu/img/movepic.gif";
var tmoveImageHeight = 12;

var tfontStyle       = "8pt Time New Roman";
var tfontColor       = ["#111111","#428EFF"];
var tfontDecoration  = ["none","underline"];

var titemBackColor   = ["#D6DFF7","#D6DFF7"];
var titemAlign       = "left";
var titemBackImage   = ["",""];
var titemCursor      = "pointer";
var titemHeight      = 20;
var titemTarget      = "frmSelect";

var ticonWidth       = 20;
var ticonHeight      = 15;
var ticonAlign       = "left";

var tmenuBackImage   = "";
var tmenuBackColor   = "";
var tmenuBorderColor = "#FFFFFF";
var tmenuBorderStyle = "solid";
var tmenuBorderWidth = 0;

var texpandBtn       =["expandbtn2.gif","expandbtn2.gif","collapsebtn2.gif"];
var texpandBtnW      = 9;
var texpandBtnH      = 9;
var texpandBtnAlign  = "left"

var tpoints       = 0;
var tpointsImage  = "";
var tpointsVImage = "";
var tpointsCImage = "";

// XP-Style Parameters
var tXPStyle = 1;
var tXPIterations = 4;                  // expand/collapse speed
var tXPTitleBackColor    = "#265BCC";
var tXPExpandBtn    = ["xpexpand1.gif","xpexpand2.gif","xpcollapse1.gif","xpcollapse2.gif"];
var tXPTitleBackImg = "xptitle.gif";

var tXPTitleLeft      = "xptitleleft.gif";
var tXPTitleLeftWidth = 2;

var tXPBtnWidth  = 25;
var tXPBtnHeight = 25;

var tXPIconWidth  = 31;
var tXPIconHeight = 32;

var tXPFilter=1;

var tXPBorderWidth = 1;
var tXPBorderColor = '#666666';



var tstyles =
[
    ["tfontStyle=bold 8pt Tahoma","titemBackColor=#265BCC,#265BCC","tfontColor=#111111,#428EFF", "tfontDecoration=none,none"],
    ["tfontStyle=bold 8pt Tahoma","titemBackColor=#265BCC,#265BCC","tfontColor=#111111,#428EFF", "tfontDecoration=none,none"],
    ["tfontDecoration=none,none"],
    ["tfontStyle=bold 8pt Tahoma","tfontColor=#444444,#5555FF"],
];

var tXPStyles =
[
    ["tXPTitleBackColor=#D0DAF8", "tXPExpandBtn=xpexpand3.gif,xpexpand4.gif,xpcollapse3.gif,xpcollapse4.gif", "tXPTitleBackImg=xptitle2.gif"]
];

var tmenuItems =
[
    ["<?php echo win2utf(""); ?>", "", "xpicon1.gif","","", "XP Title Tip",,"0"],
    <?php
    // 
    $category->Full();

    // 
    $a_img["show"][]="icon1.gif"; $a_img["hide"][]="icon1o.gif";
    $a_img["show"][]="icon2.gif"; $a_img["hide"][]="icon2o.gif";
    $a_img["show"][]="icon3.gif"; $a_img["hide"][]="icon3o.gif";
    $a_img["show"][]="icon5.gif"; $a_img["hide"][]="icon5o.gif";
    $a_img["show"][]="icon4.gif"; $a_img["hide"][]="icon4o.gif";
    $a_img["show"][]="icon2.gif"; $a_img["hide"][]="icon2o.gif";
    $a_img["show"][]="icon2.gif"; $a_img["hide"][]="icon2o.gif";
    $a_img["show"][]="icon2.gif"; $a_img["hide"][]="icon2o.gif";
    $a_img["show"][]="icon2.gif"; $a_img["hide"][]="icon2o.gif";
    $a_img["show"][]="icon2.gif"; $a_img["hide"][]="icon2o.gif";
    $a_img["show"][]="icon2.gif"; $a_img["hide"][]="icon2o.gif";
    $a_img["show"][]="icon2.gif"; $a_img["hide"][]="icon2o.gif";
    $a_img["show"][]="icon2.gif"; $a_img["hide"][]="icon2o.gif";
    $a_img["show"][]="icon2.gif"; $a_img["hide"][]="icon2o.gif";

    $n=0;
    while ($item = $category->NextRow())
    {
        $plus="";
        $selected="";
        for($i=0; $i<count($a_branch)-1; $i++) if ($item["category_id"]==$a_branch[$i]) $plus='+';
        if ($item["category_id"]==$a_branch[count($a_branch)-1]) $selected='>';

        if ($item["category_level"]>1)
        {
            $palka="";
            for($i=2; $i<=$item["category_level"]; $i++) $palka=$palka.'|';

            $str_name="";
            if (strlen($item["category_name"])>25) 
            {                    
                $str_split=split(" ", $item["category_name"]);
                $str_name=$str_split[0].'...';    
                
            }
            else $str_name=$item["category_name"];
            $str_name=str_replace("'","\'",$str_name);

            if ($item["category_level"]==2)
            {
                echo "['".$palka.$plus.$selected.$str_name."', './select.php?database=".DB_BASE_NAME."&select=category&table=category&select_id=".$item["category_id"]."', '".
                $a_img["show"][$n]."', '".$a_img["hide"][$n]."', '', '".$str_name."'],";
                $n++;
            }
            else
            {
                echo "['".$palka.$plus.$selected.$str_name."', './select.php?database=".DB_BASE_NAME."&select=category&table=category&select_id=".$item["category_id"].
                "', 'iconarr.gif', 'iconarr.gif','', '".$str_name."'],";
            }
        }
    }
    ?>
           ["<?php echo win2utf(""); ?>", "", "","","", "<?php echo win2utf(""); ?>",,"1","0"],
  ["|<?php echo win2utf(""); ?>", "./select.php?database=<?php echo DB_BASE_NAME; ?>&select=brand", "icon3.gif", "icon3o.gif"],
  
    ["<?php echo win2utf(""); ?>", "", "","","", "XP Title Tip",,"1","0"],
    ["|<?php echo win2utf(" "); ?>", "./select.php?database=<?php echo DB_BASE_NAME; ?>&select=interface", "icon3.gif", "icon3o.gif"],
    ["|<?php echo win2utf(""); ?>", "./select.php?database=<?php echo DB_BASE_NAME; ?>&select=lang", "icon3.gif", "icon3o.gif"],
    ["|<?php echo win2utf(""); ?>", "./select.php?database=<?php echo DB_BASE_NAME; ?>&select=meta", "icon3.gif", "icon3o.gif"],
    <?php 
    if ($_SESSION["access_group_id"]==1)
    {
    ?>
     ["<?php echo win2utf(" "); ?>", "", "","","", "<?php echo win2utf(" "); ?>",,"1","0"],
  ["|<?php echo win2utf(""); ?>", "./select.php?database=<?php echo DB_BASE_NAME; ?>&select=zakaz", "icon3.gif", "icon3o.gif"],
    ["<?php echo win2utf(""); ?>", "", "","","", "XP Title Tip",,"1","0"],
    ["|<?php echo win2utf(""); ?>", "./select.php?database=<?php echo DB_BASE_NAME; ?>&select=user", "icon3.gif", "icon3o.gif"], 
     ["|<?php echo win2utf(" "); ?>", "./select.php?database=<?php echo DB_BASE_NAME; ?>&select=user_site", "icon3.gif", "icon3o.gif"],    
    
     ["<?php echo win2utf(""); ?>", "", "","","", "XP Title Tip",,"1","0"],
    ["|<?php echo win2utf(" "); ?>", "./select.php?database=<?php echo DB_BASE_NAME; ?>&select=lang_translate", "icon3.gif", "icon3o.gif"],    
    ["|<?php echo win2utf(" "); ?>", "./select.php?database=<?php echo DB_BASE_NAME; ?>&select=theme", "icon3.gif", "icon3o.gif"],    
    
    ["<?php echo win2utf(""); ?>", "", "","","", "XP Title Tip",,"1","0"],
	<?php
    //
    for($i=0;$i<count($banner_tree["banner_group_name"]);$i++)
    {
        $palka="";
        for ($n=0;$n<$banner_tree["level"][$i];$n++) $palka=$palka.'|';

        echo '["'.$palka.$banner_tree["banner_group_name"][$i].'", "./select.php?database='.DB_BASE_NAME.'&select=banner_group'.
        '&table=banner_group&select_id='.$banner_tree["banner_group_id"][$i].'", "icon3.gif", "icon3o.gif"],';
    }
    ?>
	
	["<?php echo win2utf(""); ?>", "", "","","", "XP Title Tip",,"1","0"],
    ["|<?php echo win2utf(" SQL"); ?>", "./select.php?database=<?php echo DB_BASE_NAME; ?>&select=statistic", "icon3.gif", "icon3o.gif"],
    ["|<?php echo win2utf(" ."); ?>", "./statistic/statistic.php?type=common", "icon3.gif", "icon3o.gif"],
    ["|<?php echo win2utf(""); ?>", "./statistic/statistic.php?type=visit", "icon3.gif", "icon3o.gif"],
    ["|<?php echo win2utf(""); ?>", "./statistic/statistic.php?type=active", "icon3.gif", "icon3o.gif"],
    ["|<?php echo win2utf(""); ?>", "./statistic/statistic.php?type=host", "icon3.gif", "icon3o.gif"],
    ["|<?php echo win2utf(""); ?>", "./statistic/statistic.php?type=page", "icon3.gif", "icon3o.gif"],
    
    


    <?php
    }
    ?>
];


apy_tmenuInit();

  </script>

  <link REL=stylesheet HREF="./admin/menu/tstyles.css" TYPE=text/css>
</head>
<form name="formmain" action="./category.php">
<body class="TopBack" topmargin=0 leftmargin=0 rightmargin=0 bottommargin=0 marginheight=0 marginwidth=0>
<table CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
<tr>
  <td colspan=3 class="XPSilverTopBack" style="padding-left: 15px;" valign="top">
    <font class="XPSilverExTitle">ABCname</font>&nbsp;<font class="StyleNameW"><b>System</b></font>&nbsp;version&nbsp;2.0<br>
  </td>
  <td class="XPSilverTopBack" width=100% align=right>
  </td>
</tr>
<tr><td colspan=4 class="XPSilverHorLine"><img src="./admin/menu/img/blank.gif" width=1 height=1></td></tr>
<tr>
  <td class="MenuBack" height=100%><img src="./admin/menu/img/blank.gif" width=20 height=1></td>
  <td class="MenuBack" valign=top><img src="./admin/menu/img/blank.gif" width=160 height=1></td>
  <td class="MenuBack" valign=top width=1><img src="./admin/menu/img/xpvertline.gif" width=1 height=150></td>
  <td class="MenuBack" width=100% valign=top>

<table CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>

<tr>
    <td valign=top width=100%> 
      <iframe scrolling="auto" name="frmSelect" width=100% height=800 FRAMEBORDER=0 src="<?php echo './select.php?select=category&database='.DB_BASE_NAME.'&table=category&select_id=1&tab=0'; ?>"></iframe>
    </td>
</tr>
</table>

  </td>
</tr>
</table>
</body>
</form>
</html>
<?php
}
else
{
?>
<html>
<head>
<title>ABCname.net CMS</title>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=utf-8">
<link href="./admin/images/favico.ico" rel="shortcut icon" type="image/x-icon" /> 
<link REL=stylesheet HREF="./admin/menu/tstyles.css" TYPE=text/css>
<!--[if lte IE 7]>
<link rel="stylesheet" href="style_ie.css" type="text/css" media="screen" />
<![endif]-->
<!-- 
<link rel="stylesheet" href="css/lightbox.css" type="text/css" media="screen" />
<script src="js/scriptaculous.js?load=effects,builder" type="text/javascript"></script>
<script src="js/lightbox.js" type="text/javascript"></script>
-->
<script type="text/javascript" src="./admin/js/mootools.js"> </script>   
<script type="text/javascript" src="./admin/js/mootools-more.js"> </script>   
<script type="text/javascript" src="./admin/js/slimbox.js"></script>
<link rel="stylesheet" href="./admin/css/slimbox.css" type="text/css" media="screen" />

<script type="text/javascript" src="./admin/js/UvumiDropdown-compressed.js"> </script>
<link rel="stylesheet" type="text/css" media="screen" href="./admin/css/uvumi-dropdown.css" />

<script type="text/javascript">
    var menu = new UvumiDropdown('dropdown-demo');
</script>
</head>
<form name="formmain" action="./category.php">
<body class="XPSilverTopBack" topmargin=0 leftmargin=0 rightmargin=0 bottommargin=0 marginheight=0 marginwidth=0>
<table CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
<tr>
  <td colspan=3 class="XPSilverTopBack" style="padding-left: 0px; background-color:#222222;" valign="top">
  <select name="service" style="FONT-SIZE: 9px; COLOR: #000000; FONT-FAMILY: ms sans serif; margin: 6px;">
  <option value="category" selected><?php echo win2utf(""); ?></option>
  </select>
  <?php    
  $category->GetChildTree(1, null);
  $a_category=array();
  while ($item = $category->NextRow())
  {                                       
        $a_category["category_id"][]=$item["category_id"]; 
        $a_category["category_name"][]=$item["category_name"]; 
        $a_category["link"][]='./select.php?select=category&database='.DB_BASE_NAME.'&table=category&select_id='.$item["category_id"].'&category_id='.$item["category_id"];
        $a_category["category_parent"][]=$item["category_parent"];
        $a_category["category_level"][]=$item["category_level"];            
  }
    

  if ((isset($a_category["category_id"])) AND (count($a_category["category_id"])>0))
  {
  ?>
  <div style="float:right; padding-top:0px;">
  <ul id="dropdown-demo" class="dropdown">
  <?php
  for ($i=0;$i<count($a_category["category_id"]);$i++)
  {   
      if ((isset($a_category["category_level"][($i-1)])) AND ($a_category["category_level"][($i-1)]<$a_category["category_level"][$i]))  { echo "<ul>"; } 
       
      echo "<li>";            
      echo "<a href=\"".$a_category["link"][$i]."\" target=\"frmSelect\">".$a_category["category_name"][$i]."</a>";
        
      if ($a_category["category_level"][($i+1)]==$a_category["category_level"][$i]) { echo "</li>"; }   
        
      if ($a_category["category_level"][($i+1)]<$a_category["category_level"][$i])  
      { 
          $raznost=$a_category["category_level"][$i]-$a_category["category_level"][($i+1)];
          for($r=0;$r<$raznost;$r++) 
          {
              echo "</li></ul>";
              if ($r==($raznost-1)) echo "</li>";
          }
      }    
  }
  ?> 
  </ul>
  </div>   
  <?php
  }
  ?>
  </td>
  <td class="XPSilverTopBack" width="1%" align="right" style="background-color:#222222;">
  
  </td>
</tr>
<tr><td colspan=4 class="XPSilverHorLine"><img src="./admin/menu/img/blank.gif" width=1 height=1></td></tr>
<tr>            
<td colspan="4" width=100%>
<table CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
<tr>
    <td valign=top width=100%> 
    <?php 
    if ($a_params["select_id"]=='') $a_params["select_id"]=1;
    ?>
    <iframe scrolling="auto" name="frmSelect" width=100% height=800 FRAMEBORDER=0 src="<?php echo './select.php?select=category&database='.DB_BASE_NAME.'&table=category&select_id='.$a_params["select_id"].'&tab=0'; ?>"></iframe>
    </td>
</tr>
</table>

  </td>
</tr>
</table>
</body>
</form>
</html>
<?php
}
?>