<?php

class db {

    //Соединение
    var $conn;

    function db($host, $user, $password, $database) {
        $this->conn = mysql_connect($host, $user, $password);
        if (false === $this->conn) {
            return false;
        }
        if (false === mysql_select_db($database)) {
            return false;
        }
        return true;
    }

    //Генерация insert id
    function GenID($seqname, $start) {
        $sql = 'update ' . addslashes($seqname) . ' set id=LAST_INSERT_ID(id+1)';
        $res = $this->Execute($sql);
        $id = $start-1;
        if (false === $res) {
            $sql = 'create table ' . addslashes(strtoupper($seqname)) . ' (id int not null)';
            $this->Execute($sql);
            $sql = 'insert into ' . addslashes(strtoupper($seqname)) . '( id ) values ( ' . $id . ' )';
            $this->Execute($sql);
            return $id;
        }
        return mysql_insert_id($this->conn);
    }

    //Выполнение запроса
    function Execute($sql) {
        $res = mysql_query($sql, $this->conn);
        if (false === $res) {
            return false;
        }        
        if (!$res) {
            die('Invalid query: ' . mysql_error());
        }
        
        $recordset = new recordset($res, $sql);
        return $recordset;
    }

    function CacheExecute($cache, $sql) {
        return $this->Execute($sql);
    }


    function GetUpdateSQL($recordset, $data) {
        if (empty($data)) {
            return '';
        }
        preg_match_all("~FROM\s+([^\s]*)~", $recordset->sql, $maches, PREG_PATTERN_ORDER);
        if (!isset($maches[1][0])) {
            return '';
        } else {
            $table = $maches[1][0];
        }
        preg_match_all("~(WHERE\s+.*)~is", $recordset->sql, $maches, PREG_PATTERN_ORDER);
        if (!isset($maches[0][0])) {
            return '';
        } else {
            $where = $maches[0][0];
        }
        foreach ($data as $k => $v)
        {
        	if ($v == '')
        	{
        		unset($data[$k]);
        	}
		}
        $fld_names = array_keys($data);
        $fld_values = array_values($data);
        $data = 'SET ';
        for ($max = count($fld_names), $i = 0;$i < $max;$i++) {
            $data .= $fld_names[$i] . ' = \'' . $fld_values[$i] . '\' ';
            if ($i < $max-1) $data .= ', ';
        }
        $sql = 'UPDATE ' . $table . ' ' . $data . ' ' . $where;
        return $sql;
    }


    function GetInsertSQL($recordset, $data) {
        if (empty($data)) {
            return '';
        }
        preg_match_all("~FROM\s+([^\s]*)~", $recordset->sql, $maches, PREG_PATTERN_ORDER);
        if (!isset($maches[1][0])) {
            return '';
        } else {
            $table = $maches[1][0];
        }
        foreach ($data as $k => $v)
        {
        	if ($v == '')
        	{
        		unset($data[$k]);
        	}
		}
        if (!empty($data)) {
            $fld_names = implode(', ', array_keys($data));
            $fld_values = '\'' . implode('\', \'', array_values($data)) . '\'';
        }
        $sql = 'INSERT INTO ' . $table . ' (' . $fld_names . ') VALUES (' . $fld_values . ')';
        return $sql;
    }

    // Return on field result
    function GetOne($sql) {
        $res = $this->Execute($sql);
        if (false === $res) {
            return false;
        }
        return reset($res->FetchRow());
    }

    //Работа с транзакциями
    function StartTrans()
    {
        return;
    }

    function FailTrans()
    {
        return;
    }

    function CompleteTrans()
    {
        
    }

    //Return database error message
    function ErrorMsg()
    {
        return mysql_error();
    }

    //Return database error number
    function ErrorNum()
    {
        return mysql_errno();
    }

    // Close database connection
    function Close()
    {
        mysql_close($this->conn);
    }


    //$data - одномерный массив полей вывода
    //$getparam - получать или нет параметры get
    function SQLSelect($data, $from, $where, $order, $getparam)
    {
    }

    //$data = $data[$name][]
    //$data[$value][]
    function SQLInsert($data, $table, $getparam)
    {
        $dataname="";
        $valuename="";
        global $a_params;

        for ($i=0;$i<count($data["name"]);$i++)
        {
                $dataname=$dataname.$data["name"][$i].', ';

                if ($data["value"][$i]=="")
                {
                    getParam($data["name"][$i], null);
                    $valuename=$valuename."'".$a_params[$data["name"][$i]]."', ";
                }
                else
                {
                    $valuename=$valuename."'".trim($data["value"][$i])."', ";
                }
        }

        $dataname = substr($dataname,0,strlen($dataname)-2);
        $valuename = substr($valuename,0,strlen($valuename)-2);

        $res=$this->Execute("INSERT INTO ".$table." (".$dataname.") VALUES (".$valuename.");");
        //echo "INSERT INTO ".$table." (".$dataname.") VALUES (".$valuename.");";
        return $res;
    }

    function SQLUpdate($data, $table, $where, $getparam, $is_check)
    {
        $stroka="";
        global $a_params;
        $check_mass=explode(" ",$where);

        for ($i=0;$i<count($data["name"]);$i++)
        {
            if ($getparam==true)
            {
                $temp=$data["name"][$i];
                if ($a_params[$temp."_check"]=="") getParam($temp, "check");

                $dataname=$data["name"][$i];

                $valuename=$data["value"][$i];

                if ($valuename=="") { $valuename=$a_params[$temp]; }

                if ($a_params[$dataname."_check"]=="on") $stroka=$stroka.$dataname."='".trim($valuename)."', ";

            }
            else
            {
                $dataname=$data["name"][$i];
                $valuename=$data["value"][$i];

                if ((isset($a_params[$dataname."_check"])) AND ($a_params[$dataname."_check"]=="on")) $stroka=$stroka.$dataname."='".trim($valuename)."', ";
                else if ($is_check) $stroka=$stroka.$dataname."='".trim($valuename)."', ";
            }
        }

        if ($stroka!="")
        {
            $stroka = substr($stroka,0,strlen($stroka)-2);

            if (count($check_mass)>1)
            {
                $res = $this->Execute("UPDATE ".$table." SET ".$stroka." WHERE ".$where);
                //echo "UPDATE ".$table." SET ".$stroka." WHERE ".$where;
            }
            else
            {
                $res = $this->Execute("UPDATE ".$table." SET ".$stroka." WHERE ".$table."_id='".$where."'");
                //echo "UPDATE ".$table." SET ".$stroka." WHERE ".$table."_id='".$where."'";
            }
        }
        return $res;
    }


    function SQLInsertPicture($data, $table, $where, $getparam)
    {
        $stroka="";
        global $a_params;
        $check_mass=explode(" ",$where);

        for ($i=0;$i<count($data["name"]);$i++)
        {
            if ($getparam==true)
            {
                $temp=$data["name"][$i];
                getParam($temp, "check");

                if ($a_params[$temp]!="")
                {
                    $dataname=$data["name"][$i];

                    $valuename=$data["value"][$i];
                    if ($valuename=="") $valuename=$a_params[$temp];

                    $stroka=$stroka.$dataname."='".$valuename."', ";
                }
            }
            else
            {
                $dataname=$data["name"][$i];
                $valuename=$data["value"][$i];
                $stroka=$stroka.$dataname."='".$valuename."', ";
            }

            if (!$_FILES[$dataname]['name']=="")
            {
                if (move_uploaded_file($_FILES[$dataname]['tmp_name'],'./content/'.$table.'/'.$_FILES[$dataname]['name']))
                {
                    echo 'Upload='.$_FILES[$dataname]['name'].' to ./content/'.$table.'/'.$_FILES[$dataname]['name'].'<BR>';
                    chmod ('./content/'.$table.'/'.$id.substr($_FILES[$dataname]['name'],-4),0777);
                    $valuename='./content/'.$table.'/'.$_FILES[$dataname]['name'];
                    $stroka=$stroka.$dataname."='".$valuename."', ";
                }
                else
                {
                    echo 'File '.$_FILES[$dataname]['name'].' some errors! to ./content/'.$table.'/'.$_FILES[$dataname]['name'].'<BR>';
                }
            }

        }


        if ($stroka!="")
        {
            $stroka = substr($stroka,0,strlen($stroka)-2);

            if (count($check_mass)>1)
            {
                $res = $this->Execute("UPDATE ".$table." SET ".$stroka." WHERE ".$where);
            }
            else
            {
                $res = $this->Execute("UPDATE ".$table." SET ".$stroka." WHERE ".$table."_id='".$where."'");
            }
        }

        return $res;
    }


    function SQLUpdatePicture($data, $table, $where, $getparam)
    {
        $stroka="";
        global $a_params;
        $check_mass=explode(" ",$where);

        for ($i=0;$i<count($data["name"]);$i++)
        {
            if ($getparam==true)
            {
                $temp=$data["name"][$i];
                getParam($temp, "check");

                if ($a_params[$temp]!="")
                {
                    $dataname=$data["name"][$i];

                    $valuename=$data["value"][$i];
                    if ($valuename=="") $valuename=$a_params[$temp];

                    if ($a_params[$dataname."_check"]=="on") $stroka=$stroka.$dataname."='".$valuename."', ";
                }
            }
            else
            {
                $dataname=$data["name"][$i];
                $valuename=$data["value"][$i];
                if ($a_params[$dataname."_check"]=="on") $stroka=$stroka.$dataname."='".$valuename."', ";
            }

            getParam($dataname, "check");
            if ((!$_FILES[$dataname]['name']=="") AND ($a_params[$dataname."_check"]=="on"))
            {
                if (move_uploaded_file($_FILES[$dataname]['tmp_name'],'./content/'.$table.'/'.$_FILES[$dataname]['name']))
                {
                    echo 'Upload='.$_FILES[$dataname]['name'].' to ./content/'.$table.'/'.$_FILES[$dataname]['name'].'<BR>';
                    chmod ('./content/'.$table.'/'.$id.substr($_FILES[$dataname]['name'],-4),0777);
                    $valuename='./content/'.$table.'/'.$_FILES[$dataname]['name'];
                    $stroka=$stroka.$dataname."='".$valuename."', ";
                }
                else
                {
                    echo 'File '.$_FILES[$dataname]['name'].' some errors! to ./content/'.$table.'/'.$_FILES[$dataname]['name'].'<BR>';
                }
            }

        }


        if ($stroka!="")
        {
            $stroka = substr($stroka,0,strlen($stroka)-2);

            if (count($check_mass)>1)
            {
                $res = $this->Execute("UPDATE ".$table." SET ".$stroka." WHERE ".$where);
                //echo "UPDATE ".$table." SET ".$stroka." WHERE ".$where;
            }
            else
            {
                $res = $this->Execute("UPDATE ".$table." SET ".$stroka." WHERE ".$table."_id='".$where."'");
                //echo "UPDATE ".$table." SET ".$stroka." WHERE ".$table."_id='".$where."'";
            }
        }
    }


    function SQLDelete($table, $where)
    {
        $check_mass=explode(" ",$where);
        if (count($check_mass)>1)
        {
            $res = $this->Execute("DELETE FROM ".$table." WHERE ".$where);
        }
        else
        {
            $res = $this->Execute("DELETE FROM ".$table." WHERE ".$table."_id='".$where."'");
        }
        return $res;
    }

    function SQLDeleteCascade($table, $where, $getparam)
    {
    }
}

class recordset
{
    var $recordset;
    var $sql;

    function recordset($recordset, $sql) {
        $this->recordset = $recordset;
        $this->sql = $sql;
    }

    function RecordCount()
    {
        $res = mysql_num_rows($this->recordset);
        //echo mysql_error();
        return $res;
    }

    function FetchArray()
    {
        return mysql_fetch_array($this->recordset);
    }

    function FieldName($field_num)
    {
        return mysql_field_name($this->recordset, $field_num);
    }

    function FieldNums()
    {
        return mysql_num_fields($this->recordset);
    }

    function FetchRow($opt=MYSQL_BOTH)
    {
        return mysql_fetch_array($this->recordset, $opt);
    }

    function InsertID()
    {
    	return mysql_insert_id();
    }
}
?>