<?php
class module
{
    var $table;
    var $table_id;
    var $table_parent;
    var $object_tree;
    var $res;
    var $db;
    var $a_params;

    function module(&$db, &$a_params, &$object_tree, $table, $prefix)
    {
        $this->db = &$db;
        $this->table = $table;
        $this->table_id = $prefix . '_id';
        $this->table_parent = $prefix . '_parent';
        $this->object_tree = &$object_tree;
        $this->a_params = &$a_params;
    }

    function getList()
    {
    }

    function getTree($table, $id)
    {
        $res = $this->db->Execute("SELECT * FROM ".$table." WHERE ".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            $elements = $res->FetchArray();
        }
        if ($elements[$table."_parent"]!=0)
        {
           $this->object_tree["id"][]=$elements[$table."_id"];
           $this->object_tree["name"][]=$elements[$table."_name"];
           return $this->getTree($table, $elements[$table."_parent"]);
        }
        else
        {
            $this->object_tree["id"][]=$elements[$table."_id"];
            $this->object_tree["name"][]=$elements[$table."_name"];
            return $elements["category_id"];
        }
    }

    function getTable($table, $id)
    {
        $res = $this->db->Execute("SELECT * FROM (object LEFT JOIN object_name ON object.object_id=object_name.object_id) LEFT JOIN object_name_file
         ON object_name.object_name_id=object_name_file.object_name_id WHERE ".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            $elements = $res->FetchArray();
        }
        $this->object_tree["id"][]=$elements["object_id"];
        $this->object_tree["name"][]=$elements["object_name"];
    }


    function PrepareSelLeftJoin($fields, $leftjoin)
    {
    	if (is_array($fields))
        {
            $fields = implode(', ', $fields);
        } else
        {
            $fields = '*';
        }

		if (count($leftjoin["table"])>0)
        {
            for ($i=0; $i<count($leftjoin["table"]); $i++)
            {
                $skoba_close=' '.str_repeat(")",$i);
                if ($i>0)
                {
                    $str_leftjoin = $str_leftjoin.$skoba_close.' LEFT JOIN '.$leftjoin["table"][$i].' ON '.$leftjoin["table"][$i-1].'.'.$leftjoin["field"][$i].'='.$leftjoin["table"][$i].'.'.$leftjoin["field"][$i];
                }
                else
                {
                   $str_leftjoin = $str_leftjoin.$skoba_close.' LEFT JOIN '.$leftjoin["table"][$i].' ON '.$this->table.'.'.$leftjoin["field"][$i].'='.$leftjoin["table"][$i].'.'.$leftjoin["field"][$i];
                }
            }
        }
        else
        {
            $str_leftjoin = '';
        }

        $skoba_open=str_repeat("(",count($leftjoin["table"])-1);

        $sql = 'SELECT ' . $fields . ' FROM ' . $skoba_open. $this->table . $str_leftjoin;
        return $sql;
    }


    // 
    function GetChildsObjectName($id, $fields, $leftjoin)
    {
    	$sql = $this->PrepareSelLeftJoin($fields, $leftjoin);
    	$sql .= ' WHERE '. $this->table . '.' . $this->table_parent . ' = ' . $id;

    	$res = $this->db->Execute($sql);
        if (FALSE === $res)
        {
            $this->ERRORS[] = array(2, 'SQL query error.', __FILE__ . '::' . __CLASS__ . '::' . __FUNCTION__ . '::' . __LINE__, 'SQL QUERY: ' . $sql, 'SQL ERROR: ' . $this->db->ErrorMsg());
            $this->ERRORS_MES[] = extension_loaded('gettext') ? _('internal_error') : 'internal_error';
            return FALSE;
        }

        if ($res->RecordCount()>0)
        {
            $kol_fields=$res->FieldNums();
            while ($result_cat = $res->FetchArray())
            {
                for ($i=0;$i<$kol_fields;$i++)
                {
                    $field_name=$res->FieldName($i);
                    $result_mass[$field_name][]=$result_cat[$i];
                }
            }
        }

        $this->res = $res;
        return $result_mass;
    }


    // 
    function GetProperty($fields, $leftjoin, $where)
    {

        if (count($where["field"])>0)
        {
            for($i=0;$i<count($where["field"]);$i++)
            {
                $str_where = $str_where.$where["field"][$i].'='.$where["value"][$i];
                $str_where = $str_where.' '.$where["logika"][$i].' ';
            }

        }
        else
        {
            $str_where = '';
        }

    	$sql = $this->PrepareSelLeftJoin($fields, $leftjoin);

        if ($where!="")	$sql .= ' WHERE '. $str_where;
    	$res = $this->db->Execute($sql);
        if (FALSE === $res)
        {
            $this->ERRORS[] = array(2, 'SQL query error.', __FILE__ . '::' . __CLASS__ . '::' . __FUNCTION__ . '::' . __LINE__, 'SQL QUERY: ' . $sql, 'SQL ERROR: ' . $this->db->ErrorMsg());
            $this->ERRORS_MES[] = extension_loaded('gettext') ? _('internal_error') : 'internal_error';
            return FALSE;
        }

        if ($res->RecordCount()>0)
        {
            $kol_fields=$res->FieldNums();
            while ($result_cat = $res->FetchArray())
            {
                for ($i=0;$i<$kol_fields;$i++)
                {
                    $field_name=$res->FieldName($i);
                    $result_mass[$field_name][]=$result_cat[$i];
                }
            }
        }

        $this->res = $res;
        return $result_mass;
    }


    function RecordCount()
    {
        return $this->res->RecordCount();
    }

    function FetchArray()
    {
        return $this->res->FetchArray();
    }
}
?>
