<?php
class statistic
{
    var $common_hits='common_hits.dat';
    var $common_hosts='common_hosts.dat';
    var $common_sid='common_sids.dat';
    var $common_click='common_clicks.dat';
    var $online_data='online.dat';

    var $objects;
    var $a_params;
    var $path;
    var $user_agent;
    var $host;
    var $ip;
    var $dns;
    var $url;
    var $sid;
    var $dates;
    var $times;
    var $past_time;

    function statistic(&$objects, &$a_params)
    {
        $this->objects = &$objects;
        $this->a_params = &$a_params;
        $this->user_agent = getenv('HTTP_USER_AGENT');
        $this->host = getenv('HTTP_HOST');
        $this->ip = getenv('REMOTE_ADDR');
        $this->dns = getenv('HTTP_X_FORWARDED_FOR');

        if (strlen(getenv('REQUEST_URI'))>100) $this->url = substr(getenv('REQUEST_URI'),0,100).'...';
        else $this->url = getenv('REQUEST_URI');

        $this->sid = session_id();
        $this->dates = (int)(time()/86400);
        $this->times = time();
        $this->past_time = time()-300;
    }

    //Обновить посещамость страницы
    //$path - путь к каталогу
    function setVisit($path)
    {
        global $domain_path;
        
        if ($this->ip=="77.123.214.175") return 0;
        
        $this->path = $domain_path.$path;

        //Insert_online
        $readdata=fopen($this->path.$this->online_data,"a") or die("Не могу открыть файл ".$this->online_data);
        $online_data_array=file($this->path.$this->online_data);
        fclose($readdata);
		$ok=null;
        $d=count($online_data_array);
        for($i=0;$i<$d;$i++)
                {
                list($live_user,$last_time)=explode("::","$online_data_array[$i]");
                if($live_user!=""&&$last_time!=""):
                if($last_time<$this->past_time):
                        $live_user="";
                        $last_time="";
                endif;
                if($live_user!=""&&$last_time!="")
                        {
                        if($this->ip==$live_user)
                                {
                                $online_array[]="$this->ip::$this->times\r\n";
                                }
                        else
                                $online_array[]="$live_user::$last_time";
                        }
                endif;
                }

                if(isset($online_array)):
                foreach($online_array as $i=>$str)
                        {
                        if($str=="$this->ip::$this->times\r\n")
                                {
                                $ok=$i;
                                break;
                                }
                        }
                foreach($online_array as $j=>$str)
                        {
                        if($ok==$j) { $online_array[$ok]="$this->ip::$this->times\r\n"; break;}
                        }
               endif;

        $writedata=fopen($this->path.$this->online_data,"w") or die("Не могу открыть файл ".$this->online_data);
        flock($writedata,2);
        if (!isset($online_array)) $online_array[]="$this->ip::$this->times\r\n";
        foreach($online_array as $str)
        fputs($writedata,"$str");
        flock($writedata,3);
        fclose($writedata);

        //Добавление хитов
        if (file_exists($this->path.$this->dates.".dat"))
        {
            $f=fopen($this->path.$this->dates.".dat","a");
            $call="$this->ip|$this->user_agent|$this->times|$this->url\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);

            $f=fopen($this->path.$this->common_hits,"r+");
            //Замена
            fseek($f,-6,SEEK_END);
            $cislo=fRead($f,5)+1;

            $call=str_pad($cislo,5,"0",STR_PAD_LEFT);
            $call_size=strlen($call);

            flock($f,2);
            fseek($f,-6,SEEK_END);
            fWrite($f, $call);
            flock($f,3);
            fclose($f);
        }
        else
        {
            $f=fopen($this->path.$this->dates.".dat","a");
            $call="$this->ip|$this->user_agent|$this->times|$this->url\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);

            //Создание и добавление хитов
            $f=fopen($this->path.$this->common_hits,"a");
            $call="$this->dates|00001\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);

            //Создание и добавление хостов
            $f=fopen($this->path.$this->common_hosts,"a");
            $call="$this->dates|00001\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);

            //Создание и добавление сессий
            $f=fopen($this->path.$this->common_sid,"a");
            $call="$this->dates|00001\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);
        }


        //Добавление хостов
        if (file_exists($this->path.$this->dates.".dat"))
        {
            $mass = file($this->path.$this->dates.".dat");
            while(list($key, $val) = each($mass))
            {
                list($ip, $sid, $time, $url) = split("\|", $val);
                $a_ip[]=$ip;
            }
            $cislo=count(array_unique($a_ip));

            $f=fopen($this->path.$this->common_hosts,"r+");
            //Замена
            fseek($f,-6,SEEK_END);

            $call=str_pad($cislo,5,"0",STR_PAD_LEFT);
            $call_size=strlen($call);

            flock($f,2);
            fseek($f,-6,SEEK_END);
            fWrite($f, $call);
            flock($f,3);
            fclose($f);
        }

        //Добавление сессий
        if (file_exists($this->path.$this->dates.".dat"))
        {
            $mass = file($this->path.$this->dates.".dat");
            while(list($key, $val) = each($mass))
            {
                list($ip, $sid, $time, $url) = split("\|", $val);
                $a_sid[]=$sid;
            }
            $cislo=count(array_unique($a_sid));

            $f=fopen($this->path.$this->common_sid,"r+");
            //Замена
            fseek($f,-6,SEEK_END);

            $call=str_pad($cislo,5,"0",STR_PAD_LEFT);
            $call_size=strlen($call);

            flock($f,2);
            fseek($f,-6,SEEK_END);
            fWrite($f, $call);
            flock($f,3);
            fclose($f);
        }
    }

    //Обновить посещамость страницы роботом
    //$path - путь к каталогу
    function setVisitSpider($path, $robot)
    {
        $this->path = $path.$robot.'/';

        $this->check_path($this->path);

        //Добавление хитов
        if (file_exists($this->path.$this->dates.".dat"))
        {
            $f=fopen($this->path.$this->dates.".dat","a");
            $call="$this->ip|$this->sid|$this->times|$this->url|$this->host|$this->user_agent\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);

            $f=fopen($this->path.$this->common_hits,"r+");
            //Замена
            fseek($f,-6,SEEK_END);
            $cislo=fRead($f,5)+1;

            $call=str_pad($cislo,5,"0",STR_PAD_LEFT);
            $call_size=strlen($call);

            flock($f,2);
            fseek($f,-6,SEEK_END);
            fWrite($f, $call);
            flock($f,3);
            fclose($f);
        }
        else
        {
            $f=fopen($this->path.$this->dates.".dat","a");
            $call="$this->ip|$this->sid|$this->times|$this->url|$this->host|$this->user_agent\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);

            //Создание и добавление хитов
            $f=fopen($this->path.$this->common_hits,"a");
            $call="$this->dates|00001\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);

            //Создание и добавление хостов
            $f=fopen($this->path.$this->common_hosts,"a");
            $call="$this->dates|00001\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);
        }


        //Добавление хостов
        if (file_exists($this->path.$this->dates.".dat"))
        {
            $mass = file($this->path.$this->dates.".dat");
            while(list($key, $val) = each($mass))
            {
                list($ip, $sid, $time, $url) = split("\|", $val);
                $a_ip[]=$ip;
            }
            $cislo=count(array_unique($a_ip));

            $f=fopen($this->path.$this->common_hosts,"r+");
            //Замена
            fseek($f,-6,SEEK_END);

            $call=str_pad($cislo,5,"0",STR_PAD_LEFT);
            $call_size=strlen($call);

            flock($f,2);
            fseek($f,-6,SEEK_END);
            fWrite($f, $call);
            flock($f,3);
            fclose($f);
        }
    }

    //Обновить клики на объект
    //$path - путь к каталогу
    //$table - таблица БД
    //$function_check - функция проверки условия для записи в статистику
    //$field_check - поле условия проверки
    //$id_check - id поля
    function setClick($path, $table, $function_check = null, $field_check = null, $id_check = null)
    {
        $this->path = $path;

        switch ($table)
        {
            case 'category':
               $par='c';
               break;
            case 'object_property_link':
               $par='p';
               break;
            case 'object':
               $par='o';
               break;
            case 'banner_link':
               $par='b';
               break;
            default:
            $par=null;
        }

        $id=$this->a_params[$par];  //текущий id

        //Проверка условия для записи в статистику
        if ($function_check!=null)
        {
            $act_check=$this->objects->$function_check($table, $field_check, $id_check, $id);
            if ($act_check==0) return 0;
        }

        //Добавление количества
        if (file_exists($this->path.$table.'/'.$this->dates."_com.dat"))
        {
            $mass = file($this->path.$table.'/'.$this->dates."_com.dat");
            $cursor=0;
            $n=0;
            while(list($key, $val) = each($mass))
            {
                $cursor=$cursor+strlen($val);
                list($iid, $quantity) = split("\|", $val);
                if ($iid==$id) $active_element=$n;
                $a_id[$n]=$iid;
                $a_quantity[$n]=$quantity;
                $a_cursor[$n]=$cursor;
                $n++;
            }

            if (isset($active_element))
            {
                //Замена
                $sdvig=$a_cursor[$active_element]-$cursor-6;
                $cislo=intval($a_quantity[$active_element])+1;
                $f=fopen($this->path.$table.'/'.$this->dates."_com.dat","r+");
                $call=str_pad($cislo,5,"0",STR_PAD_LEFT);
                $call_size=strlen($call);
                flock($f,2);
                fseek($f,$sdvig,SEEK_END);
                fWrite($f, $call);
                flock($f,3);
                fclose($f);
            }
            else
            {
                //Добавление
                $f=fopen($this->path.$table.'/'.$this->dates."_com.dat","a");
                $call="$id|00001\n";
                $call_size=strlen($call);
                flock($f,2);
                fputs($f, $call,$call_size);
                flock($f,3);
                fclose($f);
            }
        }

        //Создание и добавление кликов
        if (file_exists($this->path.$table.'/'.$this->dates.".dat"))
        {
            $f=fopen($this->path.$table.'/'.$this->dates.".dat","a");
            $call="$id|$this->ip|$this->sid|$this->times|$this->url\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);

            $f=fopen($this->path.$table.'/'.$this->common_click,"r+");
            //Замена
            fseek($f,-6,SEEK_END);
            $cislo=fRead($f,5)+1;

            $call=str_pad($cislo,5,"0",STR_PAD_LEFT);
            $call_size=strlen($call);

            flock($f,2);
            fseek($f,-6,SEEK_END);
            fWrite($f, $call);
            flock($f,3);
            fclose($f);
        }
        else
        {
            $f=fopen($this->path.$table.'/'.$this->dates.".dat","a");
            $call="$id|$this->ip|$this->sid|$this->times|$this->url\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);

            //Создание и добавление кликов
            $f=fopen($this->path.$table.'/'.$this->common_click,"a");
            $call="$this->dates|00001\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);

            //Создание и добавление количества
            $f=fopen($this->path.$table.'/'.$this->dates."_com.dat","a");
            $call="$id|00001\n";
            $call_size=strlen($call);
            flock($f,2);
            fputs($f, $call,$call_size);
            flock($f,3);
            fclose($f);
        }

    }

    //Получить данные по посещаемости
    function getVisit($date_begin, $date_end, $type)
    {

    }

    //Получить данные по кликам
    function getClick($date_begin, $date_end, $type)
    {

    }

    //Вывод таблицы по данным статистики
    function showTable($mass, $color)
    {

    }

    //Вывод графика по данным статистики
    function showGraph($mass, $color)
    {

    }

    //Обновить посещамость с телефонов
    //$path - путь к каталогу
    function setVisitTelephone($path, $telephone)
    {
        global $domain_path;

        //Счетчики
        if ($telephone=='Samsung') require_once($domain_path.'statistic/wap/tictak_samsung.php');
        if ($telephone=='Siemens') require_once($domain_path.'statistic/wap/tictak_siemens.php');
        if ($telephone=='Nokia') require_once($domain_path.'statistic/wap/tictak_nokia.php');
        if ($telephone=='LG') require_once($domain_path.'statistic/wap/tictak_lg.php');
        if ($telephone=='SonyEricsson') require_once($domain_path.'statistic/wap/tictak_sonyericsson.php');
        if ($telephone=='Motorola') require_once($domain_path.'statistic/wap/tictak_motorola.php');
        if ($telephone=='Philips') require_once($domain_path.'statistic/wap/tictak_philips.php');
        if ($telephone=='Panasonic') require_once($domain_path.'statistic/wap/tictak_panasonic.php');
        if ($telephone=='Alcatel') require_once($domain_path.'statistic/wap/tictak_alcatel.php');
        if (($telephone=='unknown') OR ($telephone=='')) require_once($domain_path.'statistic/wap/tictak_internet.php');

    }

    //Создание пути
    function check_path($dir)
    {
        if (is_dir($dir)) return 0;

        $w_dir=split("/",$dir);
        $c_str='';
        for ($i=0; $i<count($w_dir); $i++)
        {
            $c_str.=$w_dir[$i]."/";
            if ($w_dir[$i]!=".")
            {
                if (!is_dir($c_str)) 
                {
                	mkdir($c_str, 0777);
                	chmod($c_str, 0777);
                }
            }
        }
    }

    //Количество
    function RecordCount()
    {
        return $this->res->RecordCount();
    }

    //Выборка
    function FetchArray()
    {
        return $this->res->FetchArray();
    }

}
?>
