<?php
//  
class rss_kino
{
    var $db;
    var $a_params;
    var $table;
    var $res;

    function rss_kino(&$db, &$a_params)
    {
        $this->db = &$db;
        $this->a_params = &$a_params;
    }

    //  rss_city
    function createRssCity()
    {
        $res = $this->db->Execute("CREATE TABLE rss_city (
        rss_city_id int(11) NOT NULL auto_increment,
        rss_city_name varchar(70) default NULL,
        rss_city_sort int(11) default '0',
        PRIMARY KEY (rss_city_id)
        ) ENGINE=MyISAM DEFAULT CHARSET=cp1251 AUTO_INCREMENT=1");
        return $res;
    }

    //  rss_city
    function deleteRssCity()
    {
        $res = $this->db->Execute("DROP TABLE IF EXISTS rss_city");
        return $res;
    }

    //   rss_city
    function insertRssCity($city_id, $name, $sort)
    {
        $res = $this->db->Execute("INSERT INTO rss_city (rss_city_id, rss_city_name, rss_city_sort) VALUES ('".$city_id."','".$name."','".$sort."');");
        return $res;
    }

    //  rss_city
    function getRssCity()
    {
        $mass_element=array();
        $res = $this->db->Execute("SELECT * FROM rss_city ORDER BY rss_city_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["rss_city_id"][]=$element["rss_city_id"];
                $mass_element["rss_city_name"][]=$element["rss_city_name"];
                $mass_element["rss_city_sort"][]=$element["rss_city_sort"];
            }
        }
        return $mass_element;
    }

    //  rss_city id=...
    function getRssCityID($city_id)
    {
        $mass_element=array();
        $res = $this->db->Execute("SELECT * FROM rss_city WHERE rss_city_id=".$city_id." ORDER BY rss_city_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["rss_city_id"][]=$element["rss_city_id"];
                $mass_element["rss_city_name"][]=$element["rss_city_name"];
                $mass_element["rss_city_sort"][]=$element["rss_city_sort"];
            }
        }
        return $mass_element;
    }

    //  rss_city_sort
    function getRssCitySort()
    {
        $mass_element=array();
        $res = $this->db->Execute("SELECT * FROM rss_city_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["rss_city_sort_id"][]=$element["rss_city_sort_id"];
                $mass_element["rss_city_id"][]=$element["rss_city_id"];
                $mass_element["rss_city_sort_sort"][]=$element["rss_city_sort_sort"];
            }
        }
        return $mass_element;
    }

    //  rss_city
    function updateSortRssCity($sort, $city_id)
    {
        $res = $this->db->Execute("UPDATE rss_city SET rss_city_sort='".$sort."' WHERE rss_city_id='".$city_id."'");
        return $res;
    }



    //  rss_kino
    function createRssKino()
    {
        $res = $this->db->Execute("CREATE TABLE rss_kino (
        rss_kino_id int(11) NOT NULL auto_increment,
        rss_city_id int(11) default NULL,
        rss_kino_date date default NULL,
        rss_kino_name text,
        rss_kino_info text,
        rss_kino_time text,
        rss_kino_sort int(11) default '0',
        PRIMARY KEY (rss_kino_id)
        ) ENGINE=MyISAM DEFAULT CHARSET=cp1251 AUTO_INCREMENT=1");
        return $res;
    }

    //  rss_kino
    function deleteRssKino()
    {
        $res = $this->db->Execute("DROP TABLE IF EXISTS rss_kino");
        return $res;
    }

    //   rss_city
    function insertRssKino($city_id, $kino_date, $kino_name, $kino_info, $kino_time, $kino_sort)
    {
        $res = $this->db->Execute("INSERT INTO rss_kino (rss_city_id, rss_kino_date, rss_kino_name, rss_kino_info, rss_kino_time, rss_kino_sort)
         VALUES ('".$city_id."','".$kino_date."','".$kino_name."','".$kino_info."','".$kino_time."','".$kino_sort."')");
        return $res;
    }

    //  rss_kino  id=...
    function getRssKinoID($kino_id)
    {
        $mass_element=array();
        $res = $this->db->Execute("SELECT * FROM rss_kino WHERE rss_kino_id=".$kino_id." ORDER BY rss_kino_name");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["rss_kino_id"][]=$element["rss_kino_id"];
                $mass_element["rss_city_id"][]=$element["rss_city_id"];
                $mass_element["rss_kino_date"][]=$element["rss_kino_date"];
                $mass_element["rss_kino_name"][]=$element["rss_kino_name"];
                $mass_element["rss_kino_info"][]=$element["rss_kino_info"];
                $mass_element["rss_kino_time"][]=$element["rss_kino_time"];
                $mass_element["rss_kino_sort"][]=$element["rss_kino_sort"];
            }
        }
        return $mass_element;
    }

    //  rss_kino  $city_id=...
    function getRssKinoCityID($city_id)
    {
        $mass_element=array();
        $res = $this->db->Execute("SELECT * FROM rss_kino WHERE rss_city_id=".$city_id." ORDER BY rss_kino_name");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["rss_kino_id"][]=$element["rss_kino_id"];
                $mass_element["rss_city_id"][]=$element["rss_city_id"];
                $mass_element["rss_kino_date"][]=$element["rss_kino_date"];
                $mass_element["rss_kino_name"][]=$element["rss_kino_name"];
                $mass_element["rss_kino_info"][]=$element["rss_kino_info"];
                $mass_element["rss_kino_time"][]=$element["rss_kino_time"];
                $mass_element["rss_kino_sort"][]=$element["rss_kino_sort"];
            }
        }
        return $mass_element;
    }

    //  rss_kino  $city_id=...  $kino_name
    function getRssKinoCityIDname($city_id, $kino_name)
    {
        $mass_element=array();
        $res = $this->db->Execute("SELECT * FROM rss_kino WHERE rss_city_id=".$city_id." AND rss_kino_name='".$kino_name."' ORDER BY rss_kino_name");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["rss_kino_id"][]=$element["rss_kino_id"];
                $mass_element["rss_city_id"][]=$element["rss_city_id"];
                $mass_element["rss_kino_date"][]=$element["rss_kino_date"];
                $mass_element["rss_kino_name"][]=$element["rss_kino_name"];
                $mass_element["rss_kino_info"][]=$element["rss_kino_info"];
                $mass_element["rss_kino_time"][]=$element["rss_kino_time"];
                $mass_element["rss_kino_sort"][]=$element["rss_kino_sort"];
            }
        }
        return $mass_element;
    }

    //  rss_kino  $city_id=... $kino_name $kino_date
    function getRssKinoCityIDnameKino($city_id, $kino_name, $kino_date)
    {
        $mass_element=array();
        $res = $this->db->Execute("SELECT * FROM rss_kino WHERE rss_city_id=".$city_id." AND rss_kino_name='".$kino_name."' AND rss_kino_date='".$kino_date."' ORDER BY rss_kino_name");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["rss_kino_id"][]=$element["rss_kino_id"];
                $mass_element["rss_city_id"][]=$element["rss_city_id"];
                $mass_element["rss_kino_date"][]=$element["rss_kino_date"];
                $mass_element["rss_kino_name"][]=$element["rss_kino_name"];
                $mass_element["rss_kino_info"][]=$element["rss_kino_info"];
                $mass_element["rss_kino_time"][]=$element["rss_kino_time"];
                $mass_element["rss_kino_sort"][]=$element["rss_kino_sort"];
            }
        }
        return $mass_element;
    }

    function RecordCount()
    {
        return $this->res->RecordCount();
    }

    function FetchArray()
    {
        return $this->res->FetchArray();
    }
}
?>
