<?php
class statistic
{
    var $path;
	var $path_geo;
    var $user_agent;
    var $host;
    var $ip;
    var $dns;
    var $url;
	var $referer;
    var $sid;
    var $dates;
    var $times;
    var $year;
	var $mounth;
	var $day;
	var $lastyear;
	var $lastmounth;
	var $yesterday;

    function statistic()
    {
        $this->user_agent = getenv('HTTP_USER_AGENT');
        $this->host = getenv('HTTP_HOST');
        $this->ip = $this->getRealIpAddr();
        $this->dns = getenv('HTTP_X_FORWARDED_FOR');		
        if (strlen(getenv('REQUEST_URI'))>100) $this->url = substr(getenv('REQUEST_URI'),0,100).'...';
        else $this->url = getenv('REQUEST_URI');
		$this->referer = getenv("HTTP_REFERER");
        $this->sid = session_id();
        $this->dates = (int)(time()/86400);
        $this->times = time();
		$this->year = date('Y',time());
		$this->mounth = date('m',time());
		$this->day = date('d',time());
		$this->lastyear = date('Y',time());
		$this->lastmounth = date('m',time());
		$this->yesterday = date('d',time());
    }
	
	function groupsort($a_mass) 
	{
		$b=array();
		foreach ($a_mass as $a)
		{
			//Проверка на не пустой ключ
			if (trim($a)!='') $b[$a]++;    
		}
		uasort($b, "cmp");
		return $b;
	}
	
	function groupsorthit($a_mass) 
	{
		$b=array();
		foreach ($a_mass as $a)
		{
			//Проверка на не пустой ключ
			if (trim($a)!='') $b[$a]=1;    
		}
		asort($b);
		return $b;
	}
	
	function setPath($path='./visit/')
	{
		$this->path = $path;
		return true;
	}
	
	function setPathGeo($path='./geo/')
	{
		$this->path_geo = $path;
		return true;
	}
	
    //Добавить посещамость страницы
    //$path - путь к каталогу
    function setVisit($path='./statistic/visit/')
    {
        $this->path = $path;
		$this->path_geo = './statistic/geo/';
		//Проверка на права доступа пути $path
		$path_access=substr(decoct(fileperms($this->path)),2,6);
		if (!(($path_access=='777') OR ($path_access=='775'))) return false;
		
		//Создание раздела $path/год/месяц/
		$this->check_path($this->path.$this->year.'/'.$this->mounth);
		
		$f=fopen($this->path.$this->year.'/'.$this->mounth.'/'.$this->day.".dat","a");
		$call="$this->ip|$this->user_agent|$this->times|$this->url|$this->referer|$this->sid\n";
		$call_size=strlen($call);
		flock($f,2);
		fputs($f, $call,$call_size);
		flock($f,3);
		fclose($f);

		//Синхронизация всех файлов день_group за последних N дней, false - текущий день
		$this->synDay(7, false);
		
		//Синхронизация всех файлов месяц_group за последний месяц, false - текущий месяц
		$this->synMounth(false);
		
		//Синхронизация всех файлов год_group за последний год, false - текущий год
		$this->synYear(false);						
    }
	
	function synDay($nday, $cuttern_day=false)
	{
		$mass_syn=$this->getDayPath($nday, $cuttern_day);		

		for($d=0;$d<count($mass_syn);$d++)
		{
			if($ftimeday=@filemtime($mass_syn[$d].".dat"))
			{
				if(!(($ftimedaygroup=@filemtime($mass_syn[$d]."_group.dat")) AND (($this->path.date('Y',$ftimedaygroup).'/'.date('m',$ftimedaygroup).'/'.date('d',$ftimedaygroup))!=($mass_syn[$d]))))												
				{	
					//Группировка день_group.dat
					$day_file = file($mass_syn[$d].".dat");
					$a_hit=array();
					$a_host=array();
					$a_ip=array();
					$a_url=array();
					$a_referer=array();
					$a_sid=array();
					$a_browser=array();
					$a_os=array();
					$a_geo=array();
					$a_script=array();
					$a_search=array();
					//Общий массив
					while(list($key, $val) = each($day_file))
					{
						$mass_file[]= split("\|", $val);
						list($ip, $user_agent, $times, $url, $referer, $sid) = split("\|", $val);
						//Проверка на поисковые системы
						if($sname=$this->check_search($user_agent))
						{
							$a_search[$sname]++;
						}
						else
						{
							//Проверка на скрипты
							$sbrowser=$this->getBrowser($user_agent);
							if($sbrowser=='unknown')
							{
								$a_script[]++;
							}
							else
							{
								//Массив хостов
								if(($a_hit["ip"]==null) OR (array_search($ip, $a_hit["ip"], true)===false))
								{
									$a_host["ip"][]=$ip;
									$a_host["url"][]=$url;
									$a_host["referer"][]=$referer;
									$a_host["sid"][]=$sid;
									$a_host["browser"][]=$sbrowser;
									$a_host["os"][]=$this->getOS($user_agent);	
								}
								//Массив хитов
								$a_hit["ip"][]=$ip;
								$a_hit["url"][]=$url;
								$a_hit["referer"][]=$referer;
								$a_hit["sid"][]=$sid;
								$a_hit["browser"][]=$sbrowser;
								$a_hit["os"][]=$this->getOS($user_agent);			
							}
						}
					}		
					$content_group="";
					
					//SEARCH новый массив без поисковых систем						
					arsort($a_search);
					$content_group.="a|SEARCH\t".count($a_search)."\n";
					foreach ($a_search as $key=>$val) $content_group.="b|".$key."\t".$val."\n";						
					
					//SCRIPT новый массив без скриптов (без заголовка браузера)
					$content_group.="c|SCRIPT\t".count($a_script)."\n";
					
					//HIT количество
					$content_group.="d|HIT\t".count($a_hit["ip"])."\n";
					
					//SESSION количество
					$content_group.="e|SESSION\t".count(array_unique($a_hit["sid"]))."\n";
					
					//HOST новый массив уникальных ip адресов
					$content_group.="f|HOST\t".count($a_host["ip"])."\n";
					
					
					//HIT-URL<=HOST-URL		
					$a_url_hit=$this->groupsorthit($a_hit["url"]);				
					$a_url_host=$this->groupsort($a_host["url"]);				
					$a_url=array_merge($a_url_hit,$a_url_host);
					arsort($a_url);
					$content_group.="g|URL\t".count($a_url)."\n";
					foreach ($a_url as $key=>$val) $content_group.="h|".$key."\t".$val."\n";	
					
					//HIT-REFERER<=HOST-URL
					$a_referer_hit=$this->groupsorthit($a_hit["referer"]);				
					$a_referer_host=$this->groupsort($a_host["referer"]);				
					$a_referer=array_merge($a_referer_hit,$a_referer_host);
					arsort($a_referer);
					$content_group.="i|REFERER\t".count($a_referer)."\n";
					foreach ($a_referer as $key=>$val) $content_group.="j|".$key."\t".$val."\n";
					
					//HOST - BROWSER
					$a_browser=$this->groupsort($a_host["browser"]);
					$content_group.="k|BROWSER\t".count($a_browser)."\n";
					foreach ($a_browser as $key=>$val) $content_group.="l|".$key."\t".$val."\n";
					
					//HOST - OS
					$a_os=$this->groupsort($a_host["os"]);
					$content_group.="m|OS\t".count($a_os)."\n";
					foreach ($a_os as $key=>$val) $content_group.="n|".$key."\t".$val."\n";
					
					//HOST - GEO 					
					require_once($this->path_geo."geoip.inc");
					require_once($this->path_geo."geoipcity.inc");
					require_once($this->path_geo."geoipregionvars.php");		
					$gi = geoip_open($this->path_geo."GeoLiteCity.dat", GEOIP_STANDARD);
											
					for($h=0;$h<count($a_host["ip"]);$h++)
					{
						$rsGeoData = geoip_record_by_addr($gi, $a_host["ip"][$h]);						
						$a_geo["code"][]=strtolower($rsGeoData->country_code);
						$a_geo["country"][]=$rsGeoData->country_name;
						$a_geo["region"][]=$GEOIP_REGION_NAME[$rsGeoData->country_code][$rsGeoData->region].' '.$rsGeoData->city;						
					}

					geoip_close($gi);	
					$a_country_sort=$this->groupsort($a_geo["country"]);	
					$content_group.="o|GEO\t".count($a_country_sort)."\n";
					foreach ($a_country_sort as $key=>$val) 
					{
						$content_group.="p|".$key."\t".$val."\n";
						$mass_region=array();
						for($m=0;$m<count($a_geo["country"]);$m++)
						{
							if ($key==$a_geo["country"][$m])
							{
								$mass_region[]=$a_geo["country"][$m].' '.$a_geo["region"][$m];
							}
						}
						$a_region_sort=$this->groupsort($mass_region);
						foreach ($a_region_sort as $key=>$val) $content_group.="q|".$key."\t".$val."\n";
					}
					
					
					$f=fopen($mass_syn[$d]."_group.dat","w+");
					$content_group_size=strlen($content_group);
					flock($f,2);
					fputs($f, $content_group,$content_group_size);
					//fseek($f,-6,SEEK_END);
					//fWrite($f, $call);
					flock($f,3);
					fclose($f);
				}
			}
		}	
	}

	function synMounth($cuttern_mounth=false)
	{
		$mass_syn_mounth=$this->getMounthPath($cuttern_mounth);
		if (is_dir($mass_syn_mounth))
		{
			$mass_syn_files=$this->getMounthFiles($mass_syn_mounth);
			
			if(!(($ftimemounthgroup=@filemtime($mass_syn_mounth."_group.dat")) AND (($this->path.date('Y',$ftimemounthgroup).'/'.date('m',$ftimemounthgroup))!=($mass_syn_mounth))))												
			{
				$mounth_group=array();
				for($d=0;$d<count($mass_syn_files);$d++)
				{		
					$mounth_file = file($mass_syn_files[$d]);
					while(list($key, $val) = each($mounth_file))
					{						
						list($name, $value) = split("\t", $val);
						
						if ((stristr($name, '|SEARCH')) OR (stristr($name, '|URL')) OR (stristr($name, '|REFERER')) OR (stristr($name, '|BROWSER')) OR (stristr($name, '|OS')) OR (stristr($name, '|GEO')))
						{
							$mounth_group[$name]+=0;
						}
						else
						{
							if ((stristr($name, 'b|')) AND ($mounth_group[$name]==0)) 
							{
								$mounth_group["a|SEARCH"]+=1;
							}
							
							if ((stristr($name, 'h|')) AND ($mounth_group[$name]==0)) 
							{
								$mounth_group["g|URL"]+=1;								
							}
							
							if ((stristr($name, 'j|')) AND ($mounth_group[$name]==0)) 
							{
								$mounth_group["i|REFERER"]+=1;
							}
							
							if ((stristr($name, 'l|')) AND ($mounth_group[$name]==0)) 
							{
								$mounth_group["k|BROWSER"]+=1;
							}
							
							if ((stristr($name, 'n|')) AND ($mounth_group[$name]==0)) 
							{
								$mounth_group["m|OS"]+=1;
							}
							
							if ((stristr($name, 'p|')) AND ($mounth_group[$name]==0)) 
							{
								$mounth_group["o|GEO"]+=1;
							}
							$mounth_group[$name]+=$value;
						}
					}										
				}
				ksort($mounth_group);
				$content_group='';
				foreach ($mounth_group as $key=>$val)
				{
					$content_group.=$key."\t".$val."\n";
				}
								
				$f=fopen($mass_syn_mounth."_group.dat","w+");
				$content_group_size=strlen($content_group);
				flock($f,2);
				fputs($f, $content_group,$content_group_size);
				flock($f,3);
				fclose($f);
			}
		}
	}
	
	function record_sort($records, $field, $reverse=false)
	{
		$hash = array();
	   
		foreach($records as $record)
		{
			$hash[$record[$field]] = $record;
		}
	   
		($reverse)? krsort($hash) : ksort($hash);
	   
		$records = array();
	   
		foreach($hash as $record)
		{
			$records []= $record;
		}
	   
		return $records;
	}
	
	function synYear($cuttern_year=false)
	{
		$mass_syn_year=$this->getYearPath($cuttern_year);

		if (is_dir($mass_syn_year))
		{
			$mass_syn_files=$this->getMounthFiles($mass_syn_year);
			
			if(!(($ftimemounthgroup=@filemtime($mass_syn_year."_group.dat")) AND (($this->path.date('Y',$ftimemounthgroup))!=($mass_syn_year))))												
			{

				$mounth_group=array();
				for($d=0;$d<count($mass_syn_files);$d++)
				{	
					$mounth_file = file($mass_syn_files[$d]);
					while(list($key, $val) = each($mounth_file))
					{						
						list($name, $value) = split("\t", $val);
						
						if ((stristr($name, '|SEARCH')) OR (stristr($name, '|URL')) OR (stristr($name, '|REFERER')) OR (stristr($name, '|BROWSER')) OR (stristr($name, '|OS')) OR (stristr($name, '|GEO')))
						{
							$mounth_group[$name]+=0;
						}
						else
						{
							if ((stristr($name, 'b|')) AND ($mounth_group[$name]==0)) 
							{
								$mounth_group["a|SEARCH"]+=1;
							}
							
							if ((stristr($name, 'h|')) AND ($mounth_group[$name]==0)) 
							{
								$mounth_group["g|URL"]+=1;
							}
							
							if ((stristr($name, 'j|')) AND ($mounth_group[$name]==0)) 
							{
								$mounth_group["i|REFERER"]+=1;
							}
							
							if ((stristr($name, 'l|')) AND ($mounth_group[$name]==0)) 
							{
								$mounth_group["k|BROWSER"]+=1;
							}
							
							if ((stristr($name, 'n|')) AND ($mounth_group[$name]==0)) 
							{
								$mounth_group["m|OS"]+=1;
							}
							
							if ((stristr($name, 'p|')) AND ($mounth_group[$name]==0)) 
							{
								$mounth_group["o|GEO"]+=1;
							}
							$mounth_group[$name]+=$value;
						}
					}										
				}
				ksort($mounth_group);
				$content_group='';
				foreach ($mounth_group as $key=>$val)
				{
					$content_group.=$key."\t".$val."\n";
				}								
				
				$f=fopen($mass_syn_year."_group.dat","w+");
				$content_group_size=strlen($content_group);
				flock($f,2);
				fputs($f, $content_group,$content_group_size);
				flock($f,3);
				fclose($f);				
			}
		}
	}
    //Создание пути
    function check_path($dir)
    {
        if (is_dir($dir)) return 0;

        $w_dir=split("/",$dir);
        $c_str='';
        for ($i=0; $i<count($w_dir); $i++)
        {
            $c_str.=$w_dir[$i]."/";
            if ($w_dir[$i]!=".")
            {
                if (!is_dir($c_str)) 
                {
                	mkdir($c_str, 0777);
                	chmod($c_str, 0777);
                }
            }
        }
    }
	
	//Получение IP адреса
	function getRealIpAddr()
	{
		if (!empty($_SERVER['HTTP_CLIENT_IP']))
		{
		$ip=$_SERVER['HTTP_CLIENT_IP'];
		}
		elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
		{
		$ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
		}
		else
		{
		$ip=$_SERVER['REMOTE_ADDR'];
		}
		return $ip;
	}
	
	//Получение браузера
	function getBrowser($user_agent)
	{
		if ( stristr($user_agent, 'Firefox') ) $browser='firefox';
		elseif ( stristr($user_agent, 'Chrome') ) $browser='chrome';
		elseif ( stristr($user_agent, 'Safari') ) $browser='safari';
		elseif ( stristr($user_agent, 'Opera') ) $browser='opera';
		elseif ( stristr($user_agent, 'MSIE 6.0') ) $browser='ie6';
		elseif ( stristr($user_agent, 'MSIE 7.0') ) $browser='ie7';
		elseif ( stristr($user_agent, 'MSIE 8.0') ) $browser='ie8';
		else $browser='unknown';
		return $browser;
	}
	
	//Получение ОС
	function getOS($user_agent)
	{
		if (stristr($user_agent, 'Win')) $os="windows";
		elseif ( stristr($user_agent, 'Linux') ) $os='linux';
		elseif ( stristr($user_agent, 'Unix') ) $os='unix';
		elseif ( stristr($user_agent, 'Mac') ) $os='macintosh';
		else $os='unknown';
		return $os;
	}
	
	function check_search($user_agent)
	{
		if (stristr($user_agent, 'Yandex')) $search="yandex";
		elseif ( stristr($user_agent, 'Google') ) $search='google';
		elseif ( stristr($user_agent, 'msn') ) $search='msn';
		elseif ( stristr($user_agent, 'Rambler') ) $search='rambler';
		elseif ( stristr($user_agent, 'Yahoo') ) $search='yahoo';
		else $search=false;
		return $search;
	}
	
	//Получение путей для проверки дней
	function getDayPath($number, $cuttern_day=false)
	{
		$mass=array();
		if ($cuttern_day) $current_number=0; else $current_number=1;

		for($i=$current_number;$i<($number+1);$i++)
		{
			$ldate=($this->dates-$i)*86400;
			$mass[]=$this->path.date('Y',$ldate).'/'.date('m',$ldate).'/'.date('d',$ldate);	
		}	
		return $mass;
	}
	
	//Получение пути - $number
	function getDayPathThis($number)
	{
		$mass=array();
		$ldate=($this->dates-$number)*86400;
		$mass[]=$this->path.date('Y',$ldate).'/'.date('m',$ldate).'/'.date('d',$ldate);	
		return $mass;
	}
	
	//Преобразование даты в число (YYYY/mm/dd)
	function getDateInt($str_date)
	{
		$sdate=split("/",$str_date);
		$tdate=mktime(0, 0, 0, $sdate[1], $sdate[2], $sdate[0]);		
		$nubmer_date = (int)($tdate/86400);
		return $nubmer_date;
	}
	
	//Преобразование числа в дату 
	function getIntDate($nubmer_date)
	{
		$ldate=$nubmer_date*86400;		
		$str_date =date('Y',$ldate).'/'.date('m',$ldate).'/'.date('d',$ldate);
		return $str_date;
	}
	
	//Получение путей за период from - to (YYYY/mm/dd)
	function getDayPathPeriod($from, $to)
	{
		$mass=array();
		$sdate_from=split("/",$from);
		$tdate_from=mktime(0, 0, 0, $sdate_from[1], $sdate_from[2], $sdate_from[0]);
		$tdate_from = (int)($tdate_from/86400);
		
		$sdate_to=split("/",$to);
		$tdate_to=mktime(0, 0, 0, $sdate_to[1], $sdate_to[2], $sdate_to[0]);
		$tdate_to = (int)($tdate_to/86400);

		for($i=$tdate_from;$i<=$tdate_to;$i++)
		{
			$ldate=($i)*86400;
			$mass[]=$this->path.date('Y',$ldate).'/'.date('m',$ldate).'/'.date('d',$ldate);	
		}
		return $mass;
	}
	
	//Получение путей за период from - to (YYYY/mm)
	function getMounthPathPeriod($from, $to)
	{
		$mass=array();
		$sdate_from=split("/",$from);
		$tdate_from=mktime(0, 0, 0, $sdate_from[1], '30', $sdate_from[0]);
		$tdate_from = floor($tdate_from / 2678400);
		
		
		$sdate_to=split("/",$to);
		$tdate_to=mktime(0, 0, 0, $sdate_to[1], '30', $sdate_to[0]);
		$tdate_to = floor($tdate_to / 2678400);

		for($i=$tdate_from;$i<=$tdate_to;$i++)
		{
			$ldate=$i*2678400;
			$mass[]=$this->path.date('Y',$ldate).'/'.date('m',$ldate);		
		}
		return $mass;
	}
	
	//Получение пути для проверки прошлого месяца
	function getMounthPath($cuttern_mounth=false)
	{
		$mass=array();
		if ($cuttern_mounth) $current_number=0; else $current_number=1;
		
		$nmounth=$this->mounth-$current_number; 
		$nyear=intval(date('Y',$this->times));
		
		if($nmounth==0) 
		{ 
			$nmounth=12; 
			$nyear=intval(date('Y',$this->times))-1; 
		}
		$nmounth=str_pad($nmounth, 2, "0", STR_PAD_LEFT); 
				
		return $this->path.$nyear.'/'.$nmounth;
	}
	
	//Получение пути для проверки прошлого месяца
	function getMounthPathThis($cuttern_mounth)
	{
		$mass=array();

		$nyear=intval(date('Y',$this->times));	
		$nmounth=str_pad($cuttern_mounth, 2, "0", STR_PAD_LEFT); 
		$mass[]=$this->path.$nyear.'/'.$nmounth;	
		return $mass;
	}
	
	//Получение пути для проверки прошлого года
	function getYearPath($cuttern_year=false)
	{
		$mass=array();
		if ($cuttern_year) $current_number=0; else $current_number=1;
		
		$nyear=intval(date('Y',$this->times))-$current_number; 
				
		return $this->path.$nyear;
	}
	
	function getDayFiles($path)
	{		
		$mass=array();
		
		if (is_dir($path))
		{
			if ($handle = opendir($path)) 
			{
				while (false !== ($file = readdir($handle)))
				{
					if (($file != "." && $file != ".." && $file{0} != '.') AND (stristr($file, 'group')))
					{
						$mass[]=$path.'/'.$file;
					}
				}
			}
		}
		
		return $mass;
	}
	
	function getMounthFiles($path)
	{
		$mass=array();
		
		if (is_dir($path))
		{
			if ($handle = opendir($path)) 
			{
				while (false !== ($file = readdir($handle)))
				{
					if (($file != "." && $file != ".." && $file{0} != '.') AND (stristr($file, 'group')))
					{
						$mass[]=$path.'/'.$file;
					}
				}
			}
		}
		
		return $mass;
	}
	
	function getYearFiles($path=null)
	{
		if(!isset($path)) $path=$this->path;
		$mass=array();
		
		if (is_dir($path))
		{
			if ($handle = opendir($path)) 
			{
				while (false !== ($file = readdir($handle)))
				{
					if (($file != "." && $file != ".." && $file{0} != '.') AND (stristr($file, 'group')))
					{
						$mass[]=$path.$file;
					}
				}
			}
		}
		
		return $mass;
	}
	
	
	function getFileGroup($path)
	{
		$statistic_array=array();
		$file=array();
		for($i=0;$i<count($path);$i++)
		{
			$path[$i]=str_replace('_group.dat','',$path[$i]);
			if (is_file($path[$i].'_group.dat'))
			{
				$tmp_file=@file($path[$i].'_group.dat');
				if(count($tmp_file)>0)
				{				
					$file=array_merge($file, $tmp_file); 
				}
			}
		}		

		while(list($key, $val) = @each($file))
		{						
			list($name, $value) = split("\t", $val);	
			
			if ((stristr($name, '|SEARCH')) OR (stristr($name, '|URL')) OR (stristr($name, '|REFERER')) OR (stristr($name, '|BROWSER')) OR (stristr($name, '|OS')) OR (stristr($name, '|GEO')))
			{
				$statistic_array[$name]+=0;
			}
			else
			{
				if ((stristr($name, 'b|')) AND ($statistic_array[$name]==0)) 
				{
					$statistic_array["a|SEARCH"]+=1;
				}
				
				if ((stristr($name, 'h|')) AND ($statistic_array[$name]==0)) 
				{
					$statistic_array["g|URL"]+=1;
				}
				
				if ((stristr($name, 'j|')) AND ($statistic_array[$name]==0)) 
				{
					$statistic_array["i|REFERER"]+=1;
				}
				
				if ((stristr($name, 'l|')) AND ($statistic_array[$name]==0)) 
				{
					$statistic_array["k|BROWSER"]+=1;
				}
				
				if ((stristr($name, 'n|')) AND ($statistic_array[$name]==0)) 
				{
					$statistic_array["m|OS"]+=1;
				}
				
				if ((stristr($name, 'p|')) AND ($statistic_array[$name]==0)) 
				{
					$statistic_array["o|GEO"]+=1;
				}
				$statistic_array[$name]+=$value;
			}			
		}							
		ksort($statistic_array);
		
		return $statistic_array;
	}
	
	function getFile($path)
	{
		$statistic_array=array();
		
		$file=array();
		for($i=0;$i<count($path);$i++)
		{
			$path[$i]=str_replace('.dat','',$path[$i]);
			if (is_file($path[$i].'.dat'))
			{
				$tmp_file=@file($path[$i].'.dat');
				if(count($tmp_file)>0)
				{				
					$file=array_merge($file, $tmp_file); 
				}
			}
		}

		//Общий массив
		while(list($key, $val) = each($file))
		{
			$mass_file[]= split("\|", $val);
			list($ip, $user_agent, $times, $url, $referer, $sid) = split("\|", $val);
			//Проверка на поисковые системы
			if($sname=$this->check_search($user_agent))
			{
				$statistic_array["a|SEARCH"]["ip"][]=$ip;
				$statistic_array["a|SEARCH"]["url"][]=$url;
				$statistic_array["a|SEARCH"]["referer"][]=$referer;
				$statistic_array["a|SEARCH"]["sid"][]=$sid;
				$statistic_array["a|SEARCH"]["times"][]=$times;	
				$statistic_array["a|SEARCH"]["user_agent"][]=$user_agent;
			}
			else
			{
				//Проверка на скрипты
				$sbrowser=$this->getBrowser($user_agent);
				if($sbrowser=='unknown')
				{			
					$statistic_array["c|SCRIPT"]["ip"][]=$ip;
					$statistic_array["c|SCRIPT"]["url"][]=$url;
					$statistic_array["c|SCRIPT"]["referer"][]=$referer;
					$statistic_array["c|SCRIPT"]["sid"][]=$sid;
					$statistic_array["c|SCRIPT"]["times"][]=$times;	
					$statistic_array["c|SCRIPT"]["user_agent"][]=$user_agent;
					
				}
				else
				{
					//Массив хостов
					if(($statistic_array["d|HIT"]["ip"]==null) OR (array_search($ip, $statistic_array["d|HIT"]["ip"], true)===false))
					{
						$statistic_array["f|HOST"]["ip"][]=$ip;
						$statistic_array["f|HOST"]["url"][]=$url;
						$statistic_array["f|HOST"]["referer"][]=$referer;
						$statistic_array["f|HOST"]["sid"][]=$sid;
						$statistic_array["f|HOST"]["browser"][]=$sbrowser;
						$statistic_array["f|HOST"]["os"][]=$this->getOS($user_agent);	
						$statistic_array["f|HOST"]["times"][]=$times;	
						$statistic_array["f|HOST"]["user_agent"][]=$user_agent;
					}
					//Массив хитов
					$statistic_array["d|HIT"]["ip"][]=$ip;
					$statistic_array["d|HIT"]["url"][]=$url;
					$statistic_array["d|HIT"]["referer"][]=$referer;
					$statistic_array["d|HIT"]["sid"][]=$sid;
					$statistic_array["d|HIT"]["browser"][]=$sbrowser;
					$statistic_array["d|HIT"]["os"][]=$this->getOS($user_agent);			
					$statistic_array["d|HIT"]["times"][]=$times;
					$statistic_array["d|HIT"]["user_agent"][]=$user_agent;
				}
			}
		}	
		return $statistic_array;
	}
	
}

//Сортировка массива
function cmp($a, $b) 
{
	if ($a == $b) {
		return 0;
	}
	return ($a > $b) ? -1 : 1;
}
?>
