<?php
//Получение передаваемых параметров
function getParam($s_parName, $type = null)
{
    GLOBAL $a_params;
    if (isset($_GET[$s_parName]) || isset($_POST[$s_parName]))
        {
            $value = isset($_GET[$s_parName]) ? $_GET[$s_parName] : $_POST[$s_parName];
            $value = str_replace("create", "", $value);
            $value = str_replace("select", "", $value);
            $value = str_replace("table", "", $value);
            $value = str_replace("insert", "", $value);
            $value = str_replace("grant", "", $value);
            $value = str_replace("identified", "", $value);
            $value = str_replace("update", "", $value);
            $value = str_replace("use", "", $value);
            $value = str_replace("from", "", $value);
            $value = str_replace("delete", "", $value);
            $value = str_replace("drop", "", $value);
            $value = str_replace("where", "", $value);
    	    $a_params[$s_parName] = $value;
        }
    else $a_params[$s_parName] = "";

    if ((isset($type)) AND ($type=="check")) getParam($s_parName."_check");
}

//Получение всех параметров
function getParams($default)
{
    GLOBAL $a_params;

    getParam("c", null);
    getParam("o", null);
    getParam("s", null);
    getParam("a", null);
    getParam("p", null);
    getParam("n", null);
    getParam("w", null);
    getParam("d", null);
    getParam("m", null);
    getParam("t", null);
    getParam("f", null);
    getParam("l", null);
    getParam("k", null);
    getParam("t", null);
    getParam("h", null);
    getParam("z", null);
    getParam("g", null);
    getParam("u", null);
    getParam("r", null);
    getParam("start", null);
    getParam("sort", null);

    $url = urldecode($_SERVER['QUERY_STRING']);
    $parametres=explode(",",$url);
    for ($i=0;$i<count($parametres);$i++)
    {
        if ($parametres[$i]=="c") $a_params["c"]=$parametres[$i+1];
        if ($parametres[$i]=="o") $a_params["o"]=$parametres[$i+1];
        if ($parametres[$i]=="s") $a_params["s"]=$parametres[$i+1];
        if ($parametres[$i]=="a") $a_params["a"]=$parametres[$i+1];
        if ($parametres[$i]=="p") $a_params["p"]=$parametres[$i+1];
        if ($parametres[$i]=="n") $a_params["n"]=$parametres[$i+1];
        if ($parametres[$i]=="w") $a_params["w"]=$parametres[$i+1];
        if ($parametres[$i]=="d") $a_params["d"]=$parametres[$i+1];
        if ($parametres[$i]=="m") $a_params["m"]=$parametres[$i+1];
        if ($parametres[$i]=="t") $a_params["t"]=$parametres[$i+1];
        if ($parametres[$i]=="f") $a_params["f"]=$parametres[$i+1];
        if ($parametres[$i]=="l") $a_params["l"]=$parametres[$i+1];
        if ($parametres[$i]=="k") $a_params["k"]=$parametres[$i+1];
        if ($parametres[$i]=="t") $a_params["t"]=$parametres[$i+1];
        if ($parametres[$i]=="h") $a_params["h"]=$parametres[$i+1];
        if ($parametres[$i]=="z") $a_params["z"]=$parametres[$i+1];
        if ($parametres[$i]=="g") $a_params["g"]=$parametres[$i+1];
        if ($parametres[$i]=="u") $a_params["u"]=$parametres[$i+1];
        if ($parametres[$i]=="r") $a_params["r"]=$parametres[$i+1];
        if ($parametres[$i]=="start") $a_params["start"]=$parametres[$i+1];
        if ($parametres[$i]=="sort") $a_params["sort"]=$parametres[$i+1];
    }

    //for($i=0;$i<$a_params["q"];$i++)
    //{
    //    getParam("p".$i, null);
    //}

    //главной страница
    if (($a_params["c"]=="") AND ($a_params["o"]=="")) $a_params["c"]=$default;  //id=2 - главная
}

//Установка параметров
function setParams()
{
    GLOBAL $a_params;
    $form_link="";
    $great_labels = array_keys($a_params);
    for ($i=0; $i<count($great_labels); $i++)
    {
        if ((isset($a_params[$great_labels[$i]])) AND ($a_params[$great_labels[$i]]!="")) $form_link.= $great_labels[$i].','.$a_params[$great_labels[$i]].',';
    }
    $form_link=substr($form_link,0,strlen($form_link)-1);
    return $form_link;
}

//frequently used functions
function show_price($price)
{
	//now show price
	$price = round(100*$price)/100;
	if (round($price*10) == $price*10 && round($price)!=$price) $price = "$price"."0";
	if (round($price) == $price)
		$price  = "$price".".00";

	return "US $".$price;
}

function get_current_time()
{
	return strftime("%Y-%m-%d %H:%M:%S", time());
}

function validate_search_string($s)
{
	$s = str_replace("%","",$s);
	$s = str_replace("_","",$s);
	$s = stripslashes($s);
	$s = str_replace("'","\'",$s);
	return $s;

}

function string_encode($s)
{
	$result = base64_encode($s);
	return $result;
}

function string_decode($s)
{
	$result = base64_decode($s);
	return $result;
}

    function array_key_multi_sort($arr, $l , $f='strnatcasecmp')
{
    usort($arr, create_function('$a, $b', "return $f(\$a['$l'], \$b['$l']);"));
    return($arr);
    //$mass_element= $this->array_key_multi_sort($mass_element, 'lang_translate_name_name');
}
//Перекодировка Win в UTF
function win2utf($in_text)
{
    $output="";
    $other[151]="—";
    $other[171]="«";
    $other[187]="»";
    $other[133]="…";
    $other[38]="&";
    $other[1025]="&#168;";
    $other[1105]="&#184;";
    $other[1028]="&#170;";
    $other[1108]="&#186;";
    $other[1030]="I";
    $other[1110]="i";
    $other[1030]="І";
    $other[1110]="і";
    $other[1031]="Ї";
    $other[1111]="ї";
    $other[1028]="Є";
    $other[1108]="є";

    for ($i=0; $i<strlen($in_text); $i++){
    if (ord($in_text{$i})>191){
      $output.="&#".(ord($in_text{$i})+848).";";
    } else {
      if (array_search($in_text{$i}, $other)===false){
       $output.=$in_text{$i};
      } else {
       $output.="&#".array_search($in_text{$i}, $other).";";
      }
    }
    }
    return $output;
}

//Формирование строки обновления
function setupdate($base, $par, $type)
{
    GLOBAL $stroka;
    GLOBAL $a_params;
    if ($type=="password")
    {
        if ($a_params[$par."_check"]=="on") {$stroka=$stroka.$base."='".md5($a_params[$par])."', ";}
    }
    else
    {
        if ($a_params[$par."_check"]=="on") {$stroka=$stroka.$base."='".$a_params[$par]."', ";}
    }
    return 1;
}

//UPLOAD
function fileupdate($par, $id, $upload_categoty, $functionname, $base, $type, $pref)
{
    GLOBAL $a_params;
    //UPLOAD insert
    if (($type=="insert") OR ($type==""))
    {
        if (!$_FILES[$par]['name']=="")
        {
            if (move_uploaded_file($_FILES[$par]['tmp_name'],$upload_categoty.$id.$pref.substr($_FILES[$par]['name'],-4)))
            {
                echo 'Upload='.$_FILES[$par]['name'].' to '.$upload_categoty.$id.$pref.substr($_FILES[$par]['name'],-4).'<BR>';
                chmod ($upload_categoty.$id.$pref.substr($_FILES[$par]['name'],-4),0777);
                $functionname($base."='".$id.$pref.substr($_FILES[$par]['name'],-4)."'", $id);
            }
            else
            {
                echo 'File '.$_FILES[$par]['name'].' some errors! to '.$upload_categoty.$id.$pref.substr($_FILES[$par]['name'],-4).'<BR>';
            }
        }
    }

    //UPLOAD update
    if ($type=="update")
    {
        if ((!$_FILES[$par]['name']=="") AND ($a_params["check_".$par]=="on"))
        {
            if (move_uploaded_file($_FILES[$par]['tmp_name'],$upload_categoty.$id.$pref.substr($_FILES[$par]['name'],-4)))
            {
                echo 'Upload='.$_FILES[$par]['name'].' to '.$upload_categoty.$id.$pref.substr($_FILES[$par]['name'],-4).'<BR>';
                chmod ($upload_categoty.$id.$pref.substr($_FILES[$par]['name'],-4),0777);
                $functionname($base."='".$id.$pref.substr($_FILES[$par]['name'],-4)."'", $id);
            }
            else
            {
                echo 'File '.$_FILES[$par]['name'].' some errors! to '.$upload_categoty.$id.$pref.substr($_FILES[$par]['name'],-4).'<BR>';
            }
        }
    }
    return 1;
}


//Постраничная разбивка
function LeftRight($records,$r_start,$URL,$inpage)
{
    $str="";
    if ($records<=$inpage) return;
    if ($r_start!=0)
    {
        $str.='<a href="'.$URL.'0" class="menu_grey">«</a>&nbsp;';
        $str.='<a href="'.$URL.($r_start-1).'" class="menu_grey">‹</a>&nbsp;&nbsp;';
    }
    else $str.='<span class="menu_grey">«&nbsp;‹&nbsp;<span>&nbsp;';

    if ($r_start==0) {$sstart=$r_start-0;$send=$r_start+25;}
    if ($r_start==1) {$sstart=$r_start-1;$send=$r_start+24;}
    if ($r_start==2) {$sstart=$r_start-2;$send=$r_start+23;}
    if ($r_start==3) {$sstart=$r_start-3;$send=$r_start+22;}
    if ($r_start==4) {$sstart=$r_start-4;$send=$r_start+21;}
    if ($r_start==5) {$sstart=$r_start-5;$send=$r_start+20;}
    if ($r_start==6) {$sstart=$r_start-6;$send=$r_start+19;}
    if ($r_start==7) {$sstart=$r_start-7;$send=$r_start+18;}
    if ($r_start==8) {$sstart=$r_start-8;$send=$r_start+17;}
    if ($r_start==9) {$sstart=$r_start-9;$send=$r_start+16;}
    if ($r_start==10) {$sstart=$r_start-10;$send=$r_start+15;}
    if ($r_start==11) {$sstart=$r_start-11;$send=$r_start+14;}
    if ($r_start==12) {$sstart=$r_start-12;$send=$r_start+13;}
    if ($r_start>=13) {$sstart=$r_start-12;$send=$r_start+13;}


    if ($send*$inpage>$records) $send=$records/$inpage;
    if ($sstart<0) $sstart=0;

    if ($records%$inpage==0) $add=0; else $add=1;

    for ($i=$sstart;$i<$send;$i++) {
        if ($i==$r_start) $str.='<span style="color: #7e2827; font-weight: bold;">'.($i+1).'</span>&nbsp;';
        else $str.='<a href="'.$URL.($i).'" class="menu_grey">'.($i+1)."</a>&nbsp;";
        
        if ($i!=($send-1)) $str.='|&nbsp;';
        
        }


    if ($r_start+(1-$add)<intval($records/$inpage)) {
        $str.='&nbsp;<a href="'.$URL.($r_start+1).'" class="menu_grey">›</a>&nbsp;';
        $str.='<a href="'.$URL.(intval($records/$inpage)-(1-$add)).'" class="menu_grey">»</a>';
        }
    else $str.='&nbsp;<span class="menu_grey">›&nbsp;»<span>';

    //<div align="center"><a href="#">[1] </a>&nbsp;<a href="#">[2] </a>&nbsp;<a href="#">[3] </a>&nbsp;            ..... <a href="#">[20] </a>&nbsp;<a href="#">[»]</a></div>
    return("<div align=\"center\">".$str."</div>");
}


//Постраничная разбивка
function LeftRightPhoto($records,$r_start,$URL,$inpage)
{
    $str="";
    if ($records<=$inpage) return;
    if ($r_start!=0)
    {
        $prev=$URL.($r_start-1);
    }
    else $prev='#';

    if ($r_start==0) {$sstart=$r_start-0;$send=$r_start+25;}
    if ($r_start==1) {$sstart=$r_start-1;$send=$r_start+24;}
    if ($r_start==2) {$sstart=$r_start-2;$send=$r_start+23;}
    if ($r_start==3) {$sstart=$r_start-3;$send=$r_start+22;}
    if ($r_start==4) {$sstart=$r_start-4;$send=$r_start+21;}
    if ($r_start==5) {$sstart=$r_start-5;$send=$r_start+20;}
    if ($r_start==6) {$sstart=$r_start-6;$send=$r_start+19;}
    if ($r_start==7) {$sstart=$r_start-7;$send=$r_start+18;}
    if ($r_start==8) {$sstart=$r_start-8;$send=$r_start+17;}
    if ($r_start==9) {$sstart=$r_start-9;$send=$r_start+16;}
    if ($r_start==10) {$sstart=$r_start-10;$send=$r_start+15;}
    if ($r_start==11) {$sstart=$r_start-11;$send=$r_start+14;}
    if ($r_start==12) {$sstart=$r_start-12;$send=$r_start+13;}
    if ($r_start>=13) {$sstart=$r_start-12;$send=$r_start+13;}


    if ($send*$inpage>$records) $send=$records/$inpage;
    if ($sstart<0) $sstart=0;

    if ($records%$inpage==0) $add=0; else $add=1;

    for ($i=$sstart;$i<$send;$i++) {
        if ($i==$r_start) $str.='<span class="menu_orange">'.($i+1).'&nbsp;</span>';
        else $str.='<a href="'.$URL.($i).'" class="menu_grey">'.($i+1)."</a>&nbsp;";
        }


    if ($r_start+(1-$add)<intval($records/$inpage)) {
        $next=$URL.($r_start+1);        
        }
    else $next='#';

    $str='<table width="35%" border="0" cellspacing="0" cellpadding="0" align="center"><tr><td>&nbsp;</td>
    <td valign="middle" width="14px"><a href="'.$prev.'" class="left">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</a></td>
    <td class="menu_href" valign="top" style="padding:4px;"><a href="'.$prev.'">Предыдущие фото </a></td>
    <td>&nbsp;</td>
    <td class="menu_href" valign="top" style="padding:4px;" align="right"><a href="'.$next.'"> Следующее фото</a></td>
    <td valign="middle" width="14px"><a href="'.$next.'" class="right">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</a></td>
    <td>&nbsp;</td>
    </tr>
    </table>';
    
    return($str);
}


//Преобразование даты и времени
function str2time($strStr, $strPattern = null)
{
   // an array of the valide date characters, see: http://php.net/date#AEN21898
   $arrCharacters = array(
       'd', // day
       'm', // month
       'y', // year, 2 digits
       'Y', // year, 4 digits
       'H', // hours
       'i', // minutes
       's'  // seconds
   );
   // transform the characters array to a string
   $strCharacters = implode('', $arrCharacters);

   // splits up the pattern by the date characters to get an array of the delimiters between the date characters
   $arrDelimiters = preg_split('~['.$strCharacters.']~', $strPattern);
   // transform the delimiters array to a string
   $strDelimiters = quotemeta(implode('', array_unique($arrDelimiters)));

   // splits up the date by the delimiters to get an array of the declaration
   $arrStr    = preg_split('~['.$strDelimiters.']~', $strStr);
   // splits up the pattern by the delimiters to get an array of the used characters
   $arrPattern = preg_split('~['.$strDelimiters.']~', $strPattern);

   // if the numbers of the two array are not the same, return false, because the cannot belong together
   if (count($arrStr) !== count($arrPattern)) {
       return false;
   }

   // creates a new array which has the keys from the $arrPattern array and the values from the $arrStr array
   $arrTime = array();
   for ($i = 0;$i < count($arrStr);$i++) {
       $arrTime[$arrPattern[$i]] = $arrStr[$i];
   }

   // gernerates a 4 digit year declaration of a 2 digit one by using the current year
   if (isset($arrTime['y']) && !isset($arrTime['Y'])) {
       $arrTime['Y'] = substr(date('Y'), 0, 2) . $arrTime['y'];
   }

   // if a declaration is empty, it will be filled with the current date declaration
   foreach ($arrCharacters as $strCharacter) {
       if (empty($arrTime[$strCharacter])) {
           $arrTime[$strCharacter] = date($strCharacter);
       }
   }

   // checks if the date is a valide date
   if (!checkdate($arrTime['m'], $arrTime['d'], $arrTime['Y'])) {
       return false;
   }

   // generates the timestamp
   $intTime = mktime($arrTime['H'], $arrTime['i'], $arrTime['s'], $arrTime['m'], $arrTime['d'], $arrTime['Y']);
   // returns the timestamp
   return $intTime;
}

//Генерация ключа
function rndCode()
{
    //Генерация ключа
    $msg1 = rand(0,9); 				// text to display
    $msg2 = rand(0,9); 				// text to display
    $msg3 = rand(0,9); 				// text to display
    $msg4 = rand(0,9); 				// text to display

    $cislo=$msg1.$msg2.$msg3.$msg4;
    return $cislo;
}

function getUrl()
{
    GLOBAL $a_params;
    $form_link='';
    $great_labels = array_keys($a_params);
    for ($i=0; $i<count($great_labels); $i++)
    {
        if ($a_params[$great_labels[$i]]!="") $form_link = $form_link.'&'.$great_labels[$i].'='.$a_params[$great_labels[$i]];
    }
    $form_link=substr($form_link,1,strlen($form_link)-1);
    return $form_link;
}
function getWWW($url) 
{ 
 $ch = curl_init ();
 curl_setopt ($ch , CURLOPT_URL , $url);
 curl_setopt ($ch , CURLOPT_USERAGENT , "Mozilla/5.0 (Windows; U; Windows NT 5.1; ru-RU; rv:1.7.12) Gecko/20050919 Firefox/1.0.7");
 curl_setopt ($ch , CURLOPT_RETURNTRANSFER , 1);
 curl_setopt ($ch, CURLOPT_TIMEOUT, 1000);
 $content = curl_exec($ch);
 curl_close($ch);
 return $content;
}

function rew_url($url)
{
    GLOBAL $absolute_link;
    GLOBAL $a_params;
    GLOBAL $lang_mass;
    GLOBAL $lang_id;

    if ((isset($lang_mass["lang_id"])) AND (count($lang_mass["lang_id"])>1) AND ($lang_id!=1))
    {
        return $absolute_link.$url.'&l='.$lang_id;
    }
    else
    {
        return $absolute_link.$url;
    }
}

function getABC()
{
    global $lang_id;
    $mass_abc=array();      
    
    if ($lang_id==3)
    {
    $mass_abc[]='<a href="http://abcname.net" title="Development site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="production site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="design" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://www.abcname.net" title="create site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="Development site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="set as site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="create site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="create site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="Design Studio" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="website development" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://www.abcname.net" title="Online shop" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="website promotion" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="web design" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="website design" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="development sites" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="Internet advertising" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="promotion of web sites" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="book site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="production sites" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="Optimization of the site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/index.php?c=117" title="website development" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/index.php?c=117" title="creation of sites are effectively" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://www.abcname.net/index.php?c=117" title="Professional Website Design" target="_blank">abcname.net</a>' ;
    $mass_abc[]='<a href="http://abcname.net/index.php?c=118" title="Effective promotion site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/index.php?c=118" title="Reliable promotion site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/index.php?c=118" title="website promotion" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="the rapid advance of your site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="the rapid advance of the site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://www.abcname.net/" title="Promotion of sites" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="website promotion" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="Promotion of the Internet site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="progress web site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="site promotion in search engines" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="progress sites on the Internet" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://www.abcname.net/" title="Integrated site promotion" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="progress map" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="search promotion website" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="progress of your site" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="progress map" target="_blank">abcname.net</a>';    
    }
    else
    {    
    $mass_abc[]='<a href="http://abcname.net" title="разработка сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="изготовление сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="дизайн сайта"  target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://www.abcname.net" title="создание сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="разработка сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="cделать сайт" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="создание сайта" target="_blank">abcname.net</a>';  
    $mass_abc[]='<a href="http://abcname.net" title="создать сайт" target="_blank">abcname.net</a>';  
    $mass_abc[]='<a href="http://abcname.net" title="дизайн студия" target="_blank">abcname.net</a>';  
    $mass_abc[]='<a href="http://abcname.net" title="создание сайтов" target="_blank">abcname.net</a>';  
    $mass_abc[]='<a href="http://www.abcname.net" title="создание интернет магазинов" target="_blank">abcname.net</a>';  
    $mass_abc[]='<a href="http://abcname.net" title="раскрутка сайта" target="_blank">abcname.net</a>';  
    $mass_abc[]='<a href="http://abcname.net" title="веб дизайн" target="_blank">abcname.net</a>';  
    $mass_abc[]='<a href="http://abcname.net" title="дизайна сайта" target="_blank">abcname.net</a>';      
    $mass_abc[]='<a href="http://abcname.net" title="разработка сайтов" target="_blank">abcname.net</a>';  
    $mass_abc[]='<a href="http://abcname.net" title="интернет реклама" target="_blank">abcname.net</a>';  
    $mass_abc[]='<a href="http://abcname.net" title="раскрутка сайтов" target="_blank">abcname.net</a>';  
    $mass_abc[]='<a href="http://abcname.net" title="заказать сайт" target="_blank">abcname.net</a>';  
    $mass_abc[]='<a href="http://abcname.net" title="изготовление сайтов" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net" title="оптимизация сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/index.php?c=117" title="создание сайтов" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/index.php?c=117" title="эфективное создание сайтов" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://www.abcname.net/index.php?c=117" title="профессиональное создание сайтов" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/index.php?c=118" title="эффективная раскрутка сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/index.php?c=118" title="надежная раскрутка сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/index.php?c=118" title="раскрутка сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="быстрое продвижение вашего сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="быстрое продвижение сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://www.abcname.net/" title="Продвижение сайтов" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="продвижение сайтов" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="продвижение интернет сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="продвижение веб сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="продвижение сайта в поисковых системах" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="продвижение сайтов в Интернете" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://www.abcname.net/" title="комплексное продвижение сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="продвижение сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="поисковое продвижение сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="продвижение вашего сайта" target="_blank">abcname.net</a>';
    $mass_abc[]='<a href="http://abcname.net/" title="продвижение сайта" target="_blank">abcname.net</a>';
    }

    $index=rand(0,(count($mass_abc)-1));
    
    return $mass_abc[$index];
}

function send_mime_mail($name_from, // имя отправителя
                        $email_from, // email отправителя
                        $name_to, // имя получателя
                        $email_to, // email получателя
                        $data_charset, // кодировка переданных данных
                        $send_charset, // кодировка письма
                        $subject, // тема письма
                        $body // текст письма
                        ) {
  $to = mime_header_encode($name_to, $data_charset, $send_charset)
                 . ' <' . $email_to . '>';
  $subject = mime_header_encode($subject, $data_charset, $send_charset);
  $from =  mime_header_encode($name_from, $data_charset, $send_charset)
                     .' <' . $email_from . '>';
  if($data_charset != $send_charset) {
    $body = iconv($data_charset, $send_charset, $body);
  }
  
  $headers= "Content-Type: text/html; charset=$send_charset\n";
  $headers.= "Content-Transfer-Encoding: 8bit\n";
  $headers.= "Mime-Version: 1.0\n";
  $headers.= "From: $from";
 
  $headers = iconv($data_charset, $send_charset, $headers); 

  return mail($to, $subject, $body, $headers);
}


function mime_header_encode($str, $data_charset, $send_charset) {
  if($data_charset != $send_charset) {
    $str = iconv($data_charset, $send_charset, $str);
  }
  return '=?' . $send_charset . '?B?' . base64_encode($str) . '?=';
}
// удаление папки со всем содержимым
function RemoveDir($path)
{
    if(file_exists($path) && is_dir($path))
    {
        $dirHandle = opendir($path);
        while (false !== ($file = readdir($dirHandle))) 
        {
            if ($file!='.' && $file!='..')// исключаем папки с назварием '.' и '..' 
            {
                $tmpPath=$path.'/'.$file;
                chmod($tmpPath, 0777);
                
                if (is_dir($tmpPath))
                  {  // если папка
                    RemoveDir($tmpPath);
                   } 
                  else 
                  { 
                      if(file_exists($tmpPath))
                    {
                        // удаляем файл 
                          unlink($tmpPath);
                    }
                  }
            }
        }
        closedir($dirHandle);
        
        // удаляем текущую папку
        if(file_exists($path))
        {
            rmdir($path);
        }
    }
    else
    {
       // echo "Удаляемой папки не существует или это файл!";
    }
}
  // функция копирования, файла, паки со всем содержимым
function copyr($source, $dest)
{
    // Если это файл то просто копируем
    if (is_file($source)) {
        return copy($source, $dest);
    }
 
    // Если это папка, проверяем есть ли конечная папка , если нет - создаем ее
    if (!is_dir($dest)) {
        mkdir($dest);
    }
   
    // Если это символическая ссылка
    if (is_link($source)) {
        $link_dest = readlink($source);
        return symlink($link_dest, $dest);
    }
 
    // Перебираем исходную  папку и копируем в конечную
    $dir = dir($source);
    while (false !== $entry = $dir->read()) {
        // Пропускаем папки перехода на верхний и самый верхний уровень
        if ($entry == '.' || $entry == '..') {
            continue;
        }
 
        // Рекурсия
        if ($dest !== "$source/$entry") {
            copyr("$source/$entry", "$dest/$entry");
        }
    }
 
    // Очищаем
    $dir->close();
    return true;
}
//Оквадрачиваем картинку пример ImageKvadrat("5.jpg",100);
function ImageKvadrat($file, $w)
{
    $sfile=split("\.", $file);

    if (strtolower($sfile[(count($sfile)-1)])=="jpg") $srcImage = ImageCreateFromJPEG($file);
    if (strtolower($sfile[(count($sfile)-1)])=="gif") $srcImage = ImageCreateFromGIF($file);
    if (strtolower($sfile[(count($sfile)-1)])=="png") $srcImage = ImageCreateFromPNG($file);
    
    list($img_width, $img_height, $type, $attr) = getimagesize($file);

      $w_src=$img_width;
      $h_src=$img_height;
      $src=$srcImage;
      $dest = imagecreatetruecolor($w,$w); 
      // вырезаем квадратную серединку по x, если фото горизонтальное 
         if ($w_src>$h_src) 
         imagecopyresized($dest, $src, 0, 0,
                          round((max($w_src,$h_src)-min($w_src,$h_src))/2),
                          0, $w, $w, min($w_src,$h_src), min($w_src,$h_src)); 

         // вырезаем квадратную верхушку по y, 
         // если фото вертикальное (хотя можно тоже серединку) 
         if ($w_src<$h_src) 
         imagecopyresized($dest, $src, 0, 0, 0, 0, $w, $w,
                          min($w_src,$h_src), min($w_src,$h_src)); 

         // квадратная картинка масштабируется без вырезок 
         if ($w_src==$h_src) 
         imagecopyresized($dest, $src, 0, 0, 0, 0, $w, $w, $w_src, $w_src); 
         
         
         
    if ($sfile[(count($sfile)-1)]=="jpg") imagejpeg($dest, $file);
    if ($sfile[(count($sfile)-1)]=="gif") imagegif($dest, $file);
    if ($sfile[(count($sfile)-1)]=="png") imagepng($dest, $file);
    if ($sfile[(count($sfile)-1)]=="JPG") imagejpeg($dest, $file);
    if ($sfile[(count($sfile)-1)]=="GIF") imagegif($dest, $file);
    if ($sfile[(count($sfile)-1)]=="PNG") imagepng($dest, $file);
   
    imagedestroy($dest);  
    
   
}

?>