<?php  
 session_start();
 mb_internal_encoding("UTF-8");
 require_once("../cfg/connect.php");
 require_once('./class/statistic.php');
 require_once("./functions/functions.php"); 
 require_once('./class/db_mysql.php');
 
 $db = new db(DB_HOST, $DB_USER, $DB_PASSWORD, DB_BASE_NAME);
 $sql = 'SET NAMES utf8';
 $db->Execute($sql);
 unset($DB_PASSWORD, $DB_USER);
 
 include(dirname(__FILE__).DIRECTORY_SEPARATOR."pChart/pData.class");   
 include(dirname(__FILE__).DIRECTORY_SEPARATOR."pChart/pChart.class");  
 include(dirname(__FILE__).DIRECTORY_SEPARATOR."pChart/pCache.class"); 
 
 $statistic = new statistic();
 $statistic->setPath();
 $statistic->setPathGeo();
 getParam("graph_mounth", null);
 getParam("graph_value", null);
 
 $month_name = array (1 => "Январь", 2 => "Февраль", 3 => "Март", 4 => "Апрель", 5 => "Май", 6 => "Июнь", 7 => "Июль", 8 => "Август", 9 => "Сентябрь", 10 => "Октябрь", 11 => "Ноябрь", 12 => "Декабрь");
 $exclusive_name=$_SESSION["type"].$_SESSION["year"].$_SESSION["name"].$a_params["graph_value"];
 
 //Вывод таблицы + сравнение с БД
 $category_array=$db->getSelect("SELECT category_id, category_name FROM category;");
 $object_array=$db->getSelect("SELECT object_id, object_name FROM object;");
 
 if ($_SESSION["name"]=='mounth')
 {
		$day_array=$statistic->getMounthPathThis(intval($_SESSION["mounth"])); //Месяц
		$res_array["url"][]=$statistic->getFileGroup($day_array);	
		$graph_name=$month_name[intval($_SESSION["mounth"])].' месяц (TOP-10)';
		$url_array=SortURL($res_array);
 }

if (($_SESSION["name"]=='year') AND ($_SESSION["year"]==$statistic->year))
{	
	if ($a_params["graph_value"]=='day')
	{
		//За сегодня
		$day_array=array();
		$res_array=array();
		$day_array=$statistic->getDayPathThis(0); //Сегодня
		$res_array["url"][]=$statistic->getFileGroup($day_array);
		$graph_name=$month_name[intval($statistic->mounth)].' сегодня (TOP-10)';
		$url_array=SortURL($res_array);
	}
	
	if ($a_params["graph_value"]=='day2')
	{
		//За вчера
		$day_array=array();
		$res_array=array();
		$day_array=$statistic->getDayPathThis(1); //Вчера	
		$res_array["url"][]=$statistic->getFileGroup($day_array);	
		$graph_name=$month_name[intval($statistic->mounth)].' вчера (TOP-10)';
		$url_array=SortURL($res_array);
	}
	
	if ($a_params["graph_value"]=='week')
	{
		//За неделю
		$day_array=array();
		$res_array=array();
		$day_array=$statistic->getDayPath(6, true); //Неделя
		$res_array["url"][]=$statistic->getFileGroup($day_array);
		$graph_name=$month_name[intval($statistic->mounth)].' неделя (TOP-10)';
		$url_array=SortURL($res_array);
	}
	
	if ($a_params["graph_value"]=='mounth')
	{
		//За месяц
		$day_array=array();
		$res_array=array();
		$day_array=$statistic->getMounthPathThis($statistic->mounth); 
		$res_array["url"][]=$statistic->getFileGroup($day_array);
		$graph_name=$month_name[intval($statistic->mounth)].' (TOP-10)';
		$url_array=SortURL($res_array);
	}
	
	if ($a_params["graph_value"]=='year')
	{
		//За год
		$day_array=array();
		$res_array=array();
		$mounth_files=$statistic->getMounthFiles('./visit/'.$_SESSION["year"]);
		for($i=0;$i<count($mounth_files);$i++)
		{
			$res_array["url"][]=$statistic->getFileGroup(array($mounth_files[$i]));
		}
		$graph_name='Год '.$_SESSION["year"].' (TOP-10)';
		$url_array=SortURL($res_array);
	}
}

if (($_SESSION["name"]=='year') AND ($_SESSION["year"]!=$statistic->year))
{		
	//За год
	$day_array=array();
	$res_array=array();
	$mounth_files=$statistic->getMounthFiles('./visit/'.$_SESSION["year"]);
	for($i=0;$i<count($mounth_files);$i++)
	{
		$res_array["url"][]=$statistic->getFileGroup(array($mounth_files[$i]));
	}
	$graph_name='Год '.$_SESSION["year"].' (TOP-10)';
	$url_array=SortURL($res_array);
}
 
function SortURL(&$res_array)
{	
	$url_array=array();
	for($i=0;$i<count($res_array["url"]);$i++)
	{
		foreach ($res_array["url"][$i] as $key=>$val)
		{
			if ($_SESSION["type"]=='url')
			{
				$key=str_replace('//','/',$key);
				$key=str_replace('index.php?c=1','',$key);
				if (stristr($key, 'h|')) $url_array[$key]+=$val;
			}
			
			if ($_SESSION["type"]=='state') if (stristr($key, 'p|')) $url_array[$key]+=$val;
			if ($_SESSION["type"]=='region') if (stristr($key, 'q|')) $url_array[$key]+=$val;
			if ($_SESSION["type"]=='os') if (stristr($key, 'n|')) $url_array[$key]+=$val;
			if ($_SESSION["type"]=='browser') if (stristr($key, 'l|')) $url_array[$key]+=$val;
			if ($_SESSION["type"]=='referer') if (stristr($key, 'j|')) $url_array[$key]+=$val;
			if ($_SESSION["type"]=='search') if (stristr($key, 'b|')) $url_array[$key]+=$val;			
		}		
	}
	arsort($url_array);
	return $url_array;
} 
 if((isset($url_array)) AND (count($url_array)>0))
 {
	 $n=0;
	 if ($_SESSION["type"]=='url')
	 {
		 foreach ($url_array as $key=>$val)
		 {
			if($val>0)
			{
				$key=str_replace('h|','',$key);
				//Поиск категорий
				$out=array();
				preg_match('|c=(\d{1,}).*$|i', $key, $out);  
				if ($out[1]) 
				{	
					$key_id = array_search($out[1], $category_array["category_id"]); 
					if (mb_strlen($category_array["category_name"][$key_id])>30) $name[]=mb_substr($category_array["category_name"][$key_id],0,30).'...'; 
					else
					$name[]=$category_array["category_name"][$key_id];
				}
				else
				{
					//Поиск объектов
					$out=array();
					preg_match('|o=(\d{1,}).*$|i', $key, $out); 
					if ($out[1]) 
					{	
						$key_id = array_search($out[1], $object_array["object_id"]); 
						if (mb_strlen($object_array["object_name"][$key_id])>30) $name[]=mb_substr($object_array["object_name"][$key_id],0,30).'...'; 
						else
						$name[]=$object_array["object_name"][$key_id];
					}
					else
					{
						if (substr($key,strlen($key)-1,1)=="/") 
						{
							$key_id = array_search(1, $category_array["category_id"]); 
							if (mb_strlen($category_array["category_name"][$key_id])>30) $name[]=mb_substr($category_array["category_name"][$key_id],0,30).'...'; 
							else
							$name[]=$category_array["category_name"][$key_id];
						}
						else
						{
							if (mb_strlen($key)>30) $name[]=mb_substr($key,0,30).'...'; 
							else
							$name[]=$key;
						}
					}
				}
				$value[]=$val;
				$n++;
				if ($n>9) break;
			}		
		 }
	 }
	 else
	 {
		 foreach ($url_array as $key=>$val)
		 {
			if($val>0)
			{
				if ($_SESSION["type"]=='state') $key=str_replace('p|','',$key);
				if ($_SESSION["type"]=='region') $key=str_replace('q|','',$key);
				if ($_SESSION["type"]=='os') $key=str_replace('n|','',$key);
				if ($_SESSION["type"]=='browser') $key=str_replace('l|','',$key);
				if ($_SESSION["type"]=='referer') $key=str_replace('j|','',$key);
				if ($_SESSION["type"]=='search') $key=str_replace('b|','',$key);
				
				if (mb_strlen($key)>30) $name[]=mb_substr($key,0,30).'...'; 
				else				
				$name[]=$key;				
				$value[]=$val;
				$n++;
				if ($n>9) break;
			}
		 }
	 }
 }
 else
 {
	$value=array(100);
	$name=array("");
	$graph_name='Нет данных';
 }

 // Dataset definition    
 $DataSet = new pData;
 $DataSet->AddPoint($value,"Serie1");
 $DataSet->AddPoint($name,"Serie2");
 $DataSet->AddAllSeries();
 $DataSet->SetAbsciseLabelSerie("Serie2");
 
 // Cache definition 
 $Cache = new pCache();
 $Cache->GetFromCache($exclusive_name,$DataSet->GetData());
  
 // Initialise the graph
 $Test = new pChart(820,250);
 $Test->drawFilledRoundedRectangle(7,7,813,243,5,240,240,240);
 $Test->drawRoundedRectangle(5,5,815,245,5,230,230,230);
 $Test->createColorGradientPalette(195,204,56,223,110,41,5);

 // Draw the pie chart
 $Test->setFontProperties(dirname(__FILE__).DIRECTORY_SEPARATOR."Fonts/tahoma.ttf",8);
 $Test->AntialiasQuality = 0;
 $Test->drawPieGraph($DataSet->GetData(),$DataSet->GetDataDescription(),330,120,110,PIE_PERCENTAGE_LABEL,FALSE,60,20,5);
 $Test->drawPieLegend(630,60,$DataSet->GetData(),$DataSet->GetDataDescription(),250,250,250); 

 // Write the title
 $Test->setFontProperties(dirname(__FILE__).DIRECTORY_SEPARATOR."Fonts/tahoma.ttf",10);
 $Test->drawTitle(15,23,$graph_name,100,100,100);
 $Test->drawFromPNG("Sample/logo.png",630,6);
 
 $Cache->WriteToCache($exclusive_name,$DataSet->GetData(),$Test);
 
 $Test->Stroke();
?>