<script type="text/javascript" src="./admin/html_editor/tiny_mce/tiny_mce.js"></script>
<script type="text/javascript">
    tinyMCE.init({
        // General options
        verify_html : false,
        cleanup : true,
        cleanup_on_startup : true,
        force_p_newlines : false,
        apply_source_formatting : false,
        convert_urls : false,
        relative_urls : false,
        remove_script_host : false,
        
        mode : "exact",
        elements : "elm1",
        theme : "advanced",
        skin : "o2k7",
        skin_variant : "black",
        plugins : "safari,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,inlinepopups",

        // Theme options
        theme_advanced_buttons1 : "bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,formatselect,fontselect,fontsizeselect,|,cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent",
        theme_advanced_buttons2 : "link,unlink,anchor,image,cleanup,code,|,preview,|,forecolor,backcolor,|,hr,removeformat,|,sub,sup,|,charmap,iespell,|,fullscreen,|,undo,redo",
        theme_advanced_buttons3 : "",
        theme_advanced_toolbar_location : "top",
        theme_advanced_toolbar_align : "left",
        theme_advanced_statusbar_location : "bottom",
        theme_advanced_resizing : true,

        // Example content CSS (should be your site CSS)
        content_css : "skins/3/css/container.css",

        // Drop lists for link/image/media/template dialogs
        template_external_list_url : "admin/html_editor/lists/template_list.js",
        external_link_list_url : "admin/html_editor/lists/link_list.js",
        external_image_list_url : "admin/html_editor/lists/image_list.js",
        media_external_list_url : "admin/html_editor/lists/media_list.js",

        // Replace values for the template plugin
        template_replace_values : {
            username : "Some User",
            staffid : "991234"
        }
    });
</script>
