<?php
class browser
{
	var $name = NULL;
	var $version = NULL;
	var $useragent = NULL;
    var $accept = NULL;
    var $telephone = NULL;
    var $model = NULL;
    var $file_format;
	var $platform;
	var $aol = FALSE;
	var $browsertype;
    var $wap_size;
    var $res;
    var $db;

	function browser(&$db)
	{
        $this->db = &$db;
		$agent = $_SERVER['HTTP_USER_AGENT'];
        $accept = $_SERVER['HTTP_ACCEPT'];
		$this->useragent = $agent;
        $this->accept = $accept;
	}

    // web  wap
    function getHeader()
	{
        $browser_name=$this->whatBrowser();

        //*****   *****
        $this->getWapBrowser();
        $this->getWapBrowserFormat();
        return 'web';
        //*********************

        if ($browser_name=="")
        {
            if (ereg("application/xhtml\+xml", $this->accept))
            {
                $this->getWapBrowser();
                $this->getWapBrowserFormat();
                return 'wap2';
            }

            if (ereg("text/vnd.wap.wml", $this->accept))
            {
                $this->getWapBrowser();
                $this->getWapBrowserFormat();
                return 'wap1';
            }
            else
            {
                $this->getWapBrowser();
                $this->getWapBrowserFormat();
                return 'wap2';
            }
        }
        else
        {
            return 'web';
        }
	}

    // wap .    .
    function getWapBrowser()
	{
    	$browser_user_agent = ( isset( $this->useragent ) ) ? strtolower( $this->useragent ) : '';
        $prefiks=explode("/",$browser_user_agent);

        //*****   *****
        //$prefiks[0]="SIE-C62";
        //*********************

        $a_browser_types[] = array('SAMSUNG-SGH-', 'Samsung' );
        $a_browser_types[] = array('SIE-', 'Siemens' );
        $a_browser_types[] = array('BenQ-', 'BenQ-Siemens' );
        $a_browser_types[] = array('Nokia', 'Nokia' );
        $a_browser_types[] = array('LG-', 'LG' );
        $a_browser_types[] = array('SonyEricsson', 'SonyEricsson' );
        $a_browser_types[] = array('MOT-', 'Motorola' );
        $a_browser_types[] = array('PHILIPS', 'Philips' );
        $a_browser_types[] = array('Panasonic-', 'Panasonic' );
        $a_browser_types[] = array('Alcatel', 'Alcatel' );
        $a_browser_types[] = array('unknown', 'unknown' );

    	for ($i = 0; $i < count($a_browser_types); $i++)
    	{
    		$s_browser = $a_browser_types[$i][0];
    		$browser_name = $a_browser_types[$i][1];

    		if (stristr($prefiks[0], $s_browser))
    		{
                $len1=strlen($s_browser);
                $len2=strlen($prefiks[0]);
                $this->telephone=$browser_name;
                $this->model=substr($prefiks[0],$len1,$len2);
    			break;
    		}
    	}
	}

    //  wap .   .
    function getWapBrowserFormat()
	{
    	$browser_accept = ( isset( $this->accept ) ) ? strtolower( $this->accept ) : '';

        //*****   *****
        //$browser_accept="*/*";
        //*********************

        $prefiks=explode(",",$browser_accept);

        $file_types[] = array('bmp', 'bmp' );
        $file_types[] = array('jpg', 'jpg' );
        $file_types[] = array('pjpeg', 'jpg' );
        $file_types[] = array('jpeg', 'jpg' );
        $file_types[] = array('gif', 'gif' );
        $file_types[] = array('png', 'png' );
        $file_types[] = array('mpeg', 'mpeg' );
        $file_types[] = array('mpeg', 'mpg' );
        $file_types[] = array('mid', 'mid' );
        $file_types[] = array('midi', 'mid' );
        $file_types[] = array('3gp', '3gp' );
        $file_types[] = array('3gpp', '3gpp' );
        $file_types[] = array('mp3', 'mp3' );
        $file_types[] = array('mp4', 'mp4' );
        $file_types[] = array('avi', 'avi' );
        $file_types[] = array('amr', 'amr' );
        $file_types[] = array('mmf', 'mmf' );
        $file_types[] = array('wav', 'wav' );
        $file_types[] = array('x-wav', 'wav' );
        $file_types[] = array('mmf', 'mmf' );
        $file_types[] = array('*/*', '*/*' );


    	for ($i = 0; $i < count($prefiks); $i++)
    	{
            for ($n = 0; $n < count($file_types); $n++)
    	    {
        		if (stristr($prefiks[$i], $file_types[$n][0]))
        		{
                    $this->file_format[]=$file_types[$n][1];
        			break;
        		}
            }
    	}

        if (($this->telephone=="Samsung") OR ($this->telephone=="LG")) $this->file_format[]="mmf";
	}

    //  .    .
    function getTelephone()
	{
        //    
        if (($this->telephone!="") AND ($this->model!=""))
        {
            $res = $this->db->Execute("SELECT object_property.object_property_name FROM ((telephone LEFT JOIN object ON telephone.telephone_id=object.telephone_id)
            LEFT JOIN object_property_link ON object.object_id=object_property_link.object_id)
            LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id
            WHERE telephone.telephone_name='".$this->telephone."' AND object.object_name='".$this->model."';");

            if ($res->RecordCount()>0)
            {
                $elements = $res->FetchArray();
                $this->wap_size = $elements["object_property_name"];
            }
        }
	}

	function getBrowserOS()
	{
		$win = eregi("win", $this->useragent);
		$linux = eregi("linux", $this->useragent);
		$mac = eregi("mac", $this->useragent);
		$os2 = eregi("OS/2", $this->useragent);
		$beos = eregi("BeOS", $this->useragent);

		if($win)
		{
			$this->platform = "Windows";
		}
		elseif ($linux)
		{
			$this->platform = "Linux";
		}
		elseif ($mac)
		{
			$this->platform = "Macintosh";
		}
		elseif ($os2)
		{
			$this->platform = "OS/2";
		}
		elseif ($beos)
		{
			$this->platform = "BeOS";
		}
		return $this->platform;
	}

	function isOpera()
	{
		if (eregi("opera",$this->useragent))
		{
			$val = stristr($this->useragent, "opera");
			if (eregi("/", $val)){
				$val = explode("/",$val);
				$this->browsertype = $val[0];
				$val = explode(" ",$val[1]);
				$this->version = $val[0];
			}else{
				$val = explode(" ",stristr($val,"opera"));
				$this->browsertype = $val[0];
				$this->version = $val[1];
			}
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isFirefox()
	{
		if(eregi("Firefox", $this->useragent))
		{
			$this->browsertype = "Firefox";
			$val = stristr($this->useragent, "Firefox");
			$val = explode("/",$val);
			$this->version = $val[1];
			return true;
		}
		else {
			return FALSE;
		}
	}

	function isKonqueror()
	{
		if(eregi("Konqueror",$this->useragent))
		{
			$val = explode(" ",stristr($this->useragent,"Konqueror"));
			$val = explode("/",$val[0]);
			$this->browsertype = $val[0];
			$this->version = str_replace(")","",$val[1]);
			return TRUE;
		}
		else {
			return FALSE;
		}

	}

	function isIEv1()
	{
		if(eregi("microsoft internet explorer", $this->useragent))
		{
			$this->browsertype = "MSIE";
			$this->version = "1.0";
			$var = stristr($this->useragent, "/");
			if (ereg("308|425|426|474|0b1", $var))
			{
				$this->version = "1.5";
			}
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isMSIE()
	{
		if(eregi("msie", $this->useragent) && !eregi("opera",$this->useragent))
		{
			$this->browsertype = "MSIE";
			$val = explode(" ",stristr($this->useragent,"msie"));
			$this->browsertype = $val[0];
			$this->version = $val[1];

			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isGaleon()
	{
		if(eregi("galeon",$this->useragent))
		{
			$val = explode(" ",stristr($this->useragent,"galeon"));
			$val = explode("/",$val[0]);
			$this->browsertype = $val[0];
			$this->version = $val[1];
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isWebTV()
	{
		if(eregi("webtv",$this->useragent))
		{
			$val = explode("/",stristr($this->useragent,"webtv"));
			$this->browsertype = $val[0];
			$this->version = $val[1];
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isNetPositive()
	{
		if(eregi("NetPositive", $this->useragent))
		{
			$val = explode("/",stristr($this->useragent,"NetPositive"));
			$this->platform = "BeOS";
			$this->browsertype = $val[0];
			$this->version = $val[1];
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isMSPIE()
	{
		if(eregi("mspie",$this->useragent) || eregi("pocket", $this->useragent))
		{
			$val = explode(" ",stristr($this->useragent,"mspie"));
			$this->browsertype = "MSPIE";
			$this->platform = "WindowsCE";
			if (eregi("mspie", $this->useragent))
				$this->version = $val[1];
			else {
				$val = explode("/",$this->useragent);
				$this->version = $val[1];
			}
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isIcab()
	{
		if(eregi("icab",$this->useragent))
		{
			$val = explode(" ",stristr($this->useragent,"icab"));
			$this->browsertype = $val[0];
			$this->version = $val[1];
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isOmniWeb()
	{
		if(eregi("omniweb",$this->useragent))
		{
			$val = explode("/",stristr($this->useragent,"omniweb"));
			$this->browsertype = $val[0];
			$this->version = $val[1];
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isPhoenix()
	{
		if(eregi("Phoenix", $this->useragent))
		{
			$this->browsertype = "Phoenix";
			$val = explode("/", stristr($this->useragent,"Phoenix/"));
			$this->version = $val[1];
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isFirebird()
	{
		if(eregi("firebird", $this->useragent))
		{
			$this->browsertype = "Firebird";
			$val = stristr($this->useragent, "Firebird");
			$val = explode("/",$val);
			$this->version = $val[1];
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isMozAlphaBeta()
	{
		if(eregi("mozilla",$this->useragent) &&
		   eregi("rv:[0-9].[0-9][a-b]",$this->useragent) &&
		   !eregi("netscape",$this->useragent))

		{
			$this->browsertype = "Mozilla";
			$val = explode(" ",stristr($this->useragent,"rv:"));
			eregi("rv:[0-9].[0-9][a-b]",$this->useragent,$val);
			$this->version = str_replace("rv:","",$val[0]);
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isMozStable()
	{
		if(eregi("mozilla",$this->useragent) &&
		   eregi("rv:[0-9]\.[0-9]",$this->useragent) &&
		   !eregi("netscape",$this->useragent))
		{
			$this->browsertype = "Mozilla";
			$val = explode(" ",stristr($this->useragent,"rv:"));
			eregi("rv:[0-9]\.[0-9]\.[0-9]",$this->useragent,$val);
			$this->version = str_replace("rv:","",$val[0]);
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isLynx()
	{
		if(eregi("libwww", $this->useragent))
		{
			if (eregi("amaya", $this->useragent))
			{
				$val = explode("/",stristr($this->useragent,"amaya"));
				$this->browsertype = "Amaya";
				$val = explode(" ", $val[1]);
				$this->version = $val[0];
			} else {
				$val = explode("/",$this->useragent);
				$this->browsertype = "Lynx";
				$this->version = $val[1];
			}
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isSafari()
	{
		if(eregi("safari", $this->useragent))
		{
			$this->browsertype = "Safari";
			$this->version = "";
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isNetscape()
	{
		if(eregi("netscape",$this->useragent))
		{
			$val = explode(" ",stristr($this->useragent,"netscape"));
			$val = explode("/",$val[0]);
			$this->browsertype = $val[0];
			$this->version = $val[1];
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function isAOL()
	{
		if (eregi("AOL", $this->useragent)){
			$var = stristr($this->useragent, "AOL");
			$var = explode(" ", $var);
			$this->aol = ereg_replace("[^0-9,.,a-z,A-Z]", "", $var[1]);
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	function whatBrowser()
	{
		//$this->getBrowserOS();
		$this->isOpera();
		$this->isFirefox();
		$this->isKonqueror();
		$this->isIEv1();
		$this->isMSIE();
		$this->isGaleon();
		$this->isNetPositive();
		$this->isMSPIE();
		$this->isIcab();
		$this->isOmniWeb();
		$this->isPhoenix();
		$this->isFirebird();
		$this->isLynx();
		$this->isSafari();
		$this->isMozAlphaBeta();
		$this->isMozStable();
		$this->isNetscape();
		//$this->isAOL();
		return $this->browsertype;
	}

    function RecordCount()
    {
        return $this->res->RecordCount();
    }

    function FetchArray()
    {
        return $this->res->FetchArray();
    }
}
?>
