<?php
class links
{
    var $table;
    var $res;
    var $db;
    var $a_params;

    function links(&$db, &$a_params)
    {
        $this->db = &$db;
        $this->a_params = &$a_params;
    }

    //Вывод afisha
    function getAfisha($where)
    {
        $mass_element=array();
        if ($where=="") return 0;

        $res = $this->db->Execute("SELECT object.object_name, object_link.object_link_id, object_link.object_id, object_link.id,
        object_link.table, object_link.database, afisha.afisha_name, afisha.object_link_id, afisha.category_link_id, afisha.afisha_time1,
        afisha.afisha_time2, afisha.afisha_time3, afisha.afisha_time4, afisha.afisha_time5, afisha.afisha_time6,
        afisha.afisha_time7, afisha.afisha_time8, afisha.afisha_time9, afisha.afisha_time10, afisha.afisha_ticket
        FROM (afisha LEFT JOIN object_link ON afisha.object_link_id=object_link.object_link_id) LEFT JOIN object ON object_link.object_id=object.object_id
        WHERE ".$where);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["afisha_name"][]=$element["afisha_name"];
                $mass_element["afisha_time1"][]=$element["afisha_time1"];
                $mass_element["afisha_time2"][]=$element["afisha_time2"];
                $mass_element["afisha_time3"][]=$element["afisha_time3"];
                $mass_element["afisha_time4"][]=$element["afisha_time4"];
                $mass_element["afisha_time5"][]=$element["afisha_time5"];
                $mass_element["afisha_time6"][]=$element["afisha_time6"];
                $mass_element["afisha_time7"][]=$element["afisha_time7"];
                $mass_element["afisha_time8"][]=$element["afisha_time8"];
                $mass_element["afisha_time9"][]=$element["afisha_time9"];
                $mass_element["afisha_time10"][]=$element["afisha_time10"];
                $mass_element["afisha_ticket"][]=$element["afisha_ticket"];

                $mass_element["object_name"][]=$element["object_name"];
                $mass_element["object_link_id"][]=$element["object_link_id"];
                $mass_element["category_link_id"][]=$element["category_link_id"];
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["id"][]=$element["id"];
                $mass_element["table"][]=$element["table"];
                $mass_element["database"][]=$element["database"];
            }
        }

        return $mass_element;
    }

    //Вывод связи объекта по where
    function getObjectLinkWhere($where)
    {
        $mass_element=array();
        if ($where=="") return 0;

        $res = $this->db->Execute("SELECT * FROM object_link
        WHERE ".$where);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_link_id"][]=$element["object_link_id"];
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["id"][]=$element["id"];
                $mass_element["table"][]=$element["table"];
                $mass_element["database"][]=$element["database"];
                $mass_element["object_link_sort"][]=$element["object_link_sort"];
            }
        }

        return $mass_element;
    }

    //Вывод связи объекта по id
    function getObjectLinkLink_id($object_link_id)
    {
        $mass_element=array();
        if ($object_link_id=="") return 0;

        $res = $this->db->Execute("SELECT * FROM object_link
        WHERE object_link.object_link_id=".$object_link_id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_link_id"][]=$element["object_link_id"];
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["id"][]=$element["id"];
                $mass_element["table"][]=$element["table"];
                $mass_element["database"][]=$element["database"];
                $mass_element["object_link_sort"][]=$element["object_link_sort"];
            }
        }

        return $mass_element;
    }

    //Вывод связей категории
    function getCategoryLink($category_id, $table, $where = null)
    {
        $mass_element=array();
        if (($category_id=="") OR ($table=="")) return 0;

        if ($where!="") $where=" AND ".$where;

        $res = $this->db->Execute("SELECT *
        FROM category_link RIGHT JOIN ".$table." ON category_link.id=".$table.".".$table."_id
        WHERE category_link.category_id=".$category_id." AND (".$table.".".$table."_visible=1 OR ".$table.".".$table."_visible=2) AND category_link.table='".$table."'".$where."
        ORDER BY category_link.category_link_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["category_link_id"][]=$element["category_link_id"];
                $mass_element[$table."_id"][]=$element[$table."_id"];
                $mass_element[$table."_name"][]=$element[$table."_name"];
                $mass_element[$table."_picture_icon"][]=$element[$table."_picture_icon"];
                $mass_element[$table."_visible"][]=$element[$table."_visible"];
            }
        }

        return $mass_element;
    }

    //Вывод связей объекта
    function getObjectLink($object_id, $table, $where = null)
    {
        $mass_element=array();
        if (($object_id=="") OR ($table=="")) return 0;

        if ($where!="") $where=" AND ".$where;

        $res = $this->db->Execute("SELECT *
        FROM object_link RIGHT JOIN ".$table." ON object_link.id=".$table.".".$table."_id
        WHERE object_link.object_id=".$object_id." AND (".$table.".".$table."_visible=1 OR ".$table.".".$table."_visible=2) AND object_link.table='".$table."'".$where."
        ORDER BY object_link.object_link_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_link_id"][]=$element["object_link_id"];
                $mass_element[$table."_id"][]=$element[$table."_id"];
                $mass_element[$table."_name"][]=$element[$table."_name"];
                $mass_element[$table."_picture_icon"][]=$element[$table."_picture_icon"];
                $mass_element[$table."_visible"][]=$element[$table."_visible"];
            }
        }

        return $mass_element;
    }

    //Вывод расписания
    function getAfishaLink($object_link_id)
    {
        $mass_element=array();
        if ($object_link_id=="") return 0;

        $res = $this->db->Execute("SELECT *
        FROM object_link RIGHT JOIN afisha ON object_link.object_link_id=afisha.object_link_id
        WHERE object_link.object_link_id=".$object_link_id."
        ORDER BY afisha.afisha_name");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["afisha_name"][]=$element["afisha_name"];
                $mass_element["object_link_id"][]=$element["object_link_id"];
                $mass_element["category_link_id"][]=$element["category_link_id"];
                $mass_element["afisha_time1"][]=$element["afisha_time1"];
                $mass_element["afisha_time2"][]=$element["afisha_time2"];
                $mass_element["afisha_time3"][]=$element["afisha_time3"];
                $mass_element["afisha_time4"][]=$element["afisha_time4"];
                $mass_element["afisha_time5"][]=$element["afisha_time5"];
                $mass_element["afisha_time6"][]=$element["afisha_time6"];
                $mass_element["afisha_time7"][]=$element["afisha_time7"];
                $mass_element["afisha_time8"][]=$element["afisha_time8"];
                $mass_element["afisha_time9"][]=$element["afisha_time9"];
                $mass_element["afisha_time10"][]=$element["afisha_time10"];
            }
        }

        return $mass_element;
    }

    function RecordCount()
    {
        return $this->res->RecordCount();
    }

    function FetchArray()
    {
        return $this->res->FetchArray();
    }
}
?>
