<?php
class property
{
    var $table;
    var $table_parent;
    var $object_tree;
    var $res;
    var $db;
    var $a_params;
    var $lang_id;

    function property(&$db, &$a_params, $lang_id = null)
    {
        $this->db = &$db;
        $this->a_params = &$a_params;
        $this->lang_id = $lang_id;
    }

    //  
    function getObjectPropertyLink($object_id)
    {
        $mass_element=array();
        if ($object_id=="") return 0;
        $res = $this->db->Execute("SELECT * FROM (object_property_link LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id) LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id WHERE object_id=".$object_id." ORDER BY object_property_link_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_property_group_id"][]=$element["object_property_group_id"];
                $mass_element["object_property_group_name"][]=$element["object_property_group_name"];
                $mass_element["object_property_group_parent"][]=$element["object_property_group_parent"];
                $mass_element["object_property_name"][]=$element["object_property_name"];
                $mass_element["object_property_type"][]=$element["object_property_type"];
                $mass_element["object_property_format"][]=$element["object_property_format"];
                $mass_element["object_property_link_id"][]=$element["object_property_link_id"];
                $mass_element["object_property_link_group_id"][]=$element["object_property_link_group_id"];
                $mass_element["object_property_id"][]=$element["object_property_id"];
                $mass_element["object_property_link_integer"][]=$element["object_property_link_integer"];
                $mass_element["object_property_link_double"][]=$element["object_property_link_double"];
                $mass_element["object_property_link_text"][]=$element["object_property_link_text"];
                $mass_element["object_property_link_data"][]=$element["object_property_link_data"];
                $mass_element["object_property_link_file"][]=$element["object_property_link_file"];
            }
            return $mass_element;
        }

        return null;

    }

    //  
    function getObjectPropertyLinkName($object_id)
    {
        $mass_element=array();
        if ($object_id=="") return 0;

        //   
        $lang_where='';
        if ($this->lang_id > 0) $lang_where=" AND (object_property_name.lang_id=".$this->lang_id." OR object_property_name.lang_id=0)
        AND (object_property_group_name.lang_id=".$this->lang_id." OR object_property_group_name.lang_id=0)";

        $res = $this->db->Execute("
        SELECT * FROM (((object_property_link LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id)
        LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id)
        LEFT JOIN object_property_name ON object_property.object_property_id=object_property_name.object_property_id)
        LEFT JOIN object_property_group_name ON object_property_group.object_property_group_id=object_property_group_name.object_property_group_id
        WHERE object_id=".$object_id.$lang_where." ORDER BY object_property_link_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_property_group_id"][]=$element["object_property_group_id"];
                $mass_element["object_property_group_name"][]=$element["object_property_group_name"];
                $mass_element["object_property_group_name_name"][]=$element["object_property_group_name_name"];
                $mass_element["object_property_name"][]=$element["object_property_name"];
                $mass_element["object_property_name_name"][]=$element["object_property_name_name"];
                $mass_element["object_property_type"][]=$element["object_property_type"];
                $mass_element["object_property_format"][]=$element["object_property_format"];
                $mass_element["object_property_link_id"][]=$element["object_property_link_id"];
                $mass_element["object_property_link_group_id"][]=$element["object_property_link_group_id"];
                $mass_element["object_property_id"][]=$element["object_property_id"];
                $mass_element["object_property_link_integer"][]=$element["object_property_link_integer"];
                $mass_element["object_property_link_double"][]=$element["object_property_link_double"];
                $mass_element["object_property_link_text"][]=$element["object_property_link_text"];
                $mass_element["object_property_link_data"][]=$element["object_property_link_data"];
                $mass_element["object_property_link_file"][]=$element["object_property_link_file"];
            }
        }

        return $mass_element;
    }

    //  
    function getCategoryPropertyLink($category_id)
    {
        $mass_element=array();
        if ($category_id=="") return 0;

        $res = $this->db->Execute("SELECT * FROM category_property_link WHERE category_id=".$category_id." ORDER BY category_property_link_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["category_property_link_id"][]=$element["category_property_link_id"];
                $mass_element["category_property_link_group_id"][]=$element["category_property_link_group_id"];
                $mass_element["category_property_id"][]=$element["category_property_id"];
                $mass_element["category_property_link_integer"][]=$element["category_property_link_integer"];
                $mass_element["category_property_link_double"][]=$element["category_property_link_double"];
                $mass_element["category_property_link_text"][]=$element["category_property_link_text"];
                $mass_element["category_property_link_data"][]=$element["category_property_link_data"];
                $mass_element["category_property_link_file"][]=$element["category_property_link_file"];
            }
        }

        return $mass_element;
    }

    // 
    function getObjectProperty($object_property_group_id)
    {
        $mass_element=array();
        if ($object_property_group_id=="") return 0;        
        $res = $this->db->Execute("SELECT * FROM object_property WHERE object_property_group_id=".$object_property_group_id." ORDER BY object_property_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_property_id"][]=$element["object_property_id"];
                $mass_element["object_property_group_id"][]=$element["object_property_group_id"];
                $mass_element["object_property_name"][]=$element["object_property_name"];
                $mass_element["object_property_type"][]=$element["object_property_type"];
                $mass_element["object_property_format"][]=$element["object_property_format"];
                $mass_element["object_property_module"][]=$element["object_property_module"];
                $mass_element["object_property_value"][]=$element["object_property_value"];
				$mass_element["object_property_value1"][]=$element["object_property_value1"];
            }
        }
        return $mass_element;
    }
    
    //  
    function getTree($id)
    {
        if ($id=="") return 0;
        $res = $this->db->Execute("SELECT * FROM object_property_group WHERE object_property_group_id=".$id.";");
        
        if ($res->RecordCount()>0)
        {
            $element = $res->FetchArray();
        
	        if ($element["object_property_group_parent"]!=0)
	        {	        
	            $this->object_tree["object_property_group_id"][]=$element["object_property_group_id"];
	            $this->object_tree["object_property_group_parent"][]=$element["object_property_group_parent"];
	            $this->object_tree["object_property_group_name"][]=$element["object_property_group_name"];
	            return $this->getTree($element["object_property_group_parent"]);
	        }
	        else
	        {
	            $this->object_tree["object_property_group_id"][]=$element["object_property_group_id"];
	            $this->object_tree["object_property_group_parent"][]=$element["object_property_group_parent"];
	            $this->object_tree["object_property_group_name"][]=$element["object_property_group_name"];
	            return $element["object_property_group_id"];
	        }
        }
    }
    
    //  
    function getObjectPropertyGroup($object_property_group_id)
    {
        $mass_element=array();
        if (($object_property_group_id=="") OR ($object_property_group_id==0)) return 0;
        $res = $this->db->Execute("SELECT * FROM object_property_group WHERE object_property_group_id=".$object_property_group_id.";");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_property_group_id"][]=$element["object_property_group_id"];
                $mass_element["object_property_group_parent"][]=$element["object_property_group_parent"];
                $mass_element["object_property_group_name"][]=$element["object_property_group_name"];
            }
        }
        return $mass_element;
    }
    
    //  
    function getObjectPropertyGroupParent($object_property_group_id)
    {
        $mass_element=array();
        if (($object_property_group_id=="") OR ($object_property_group_id==0)) return 0;
        $res = $this->db->Execute("SELECT * FROM object_property_group WHERE object_property_group_parent=".$object_property_group_id.";");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_property_group_id"][]=$element["object_property_group_id"];
                $mass_element["object_property_group_parent"][]=$element["object_property_group_parent"];
                $mass_element["object_property_group_name"][]=$element["object_property_group_name"];
            }
        }
        return $mass_element;
    }

    // ;
    function showProperty($o_property, $table = "object", $property_id = null, $property_group_id = null)
    {
        if ($o_property=="") return null;
        $str_property=null;
        if (isset($o_property[$table."_property_id"]))
        {
        for ($p=0;$p<count($o_property[$table."_property_id"]);$p++)
        {
            if ($property_id!=null)
            {
                if ($o_property[$table."_property_id"][$p]==$property_id)
                {
                    $str_property["id"][] = $o_property[$table."_property_link_id"][$p];  
                    $str_property["property_id"][] = $o_property[$table."_property_id"][$p];
                    $str_property["name"][] = $o_property[$table."_property_name"][$p];
                    if ($o_property[$table."_property_format"][$p]==1) $str_property["value"][] = $o_property[$table."_property_link_integer"][$p];
                    if ($o_property[$table."_property_format"][$p]==2) $str_property["value"][] = $o_property[$table."_property_link_double"][$p];
                    if ($o_property[$table."_property_format"][$p]==3) $str_property["value"][] = $o_property[$table."_property_link_text"][$p];
                    if ($o_property[$table."_property_format"][$p]==4) $str_property["value"][] = $o_property[$table."_property_link_data"][$p];
                    if ($o_property[$table."_property_format"][$p]==5) $str_property["value"][] = $o_property[$table."_property_link_file"][$p];
                }
            }

            if ($property_group_id!=null)
            {
                if ($o_property[$table."_property_group_id"][$p]==$property_group_id)
                {
                     $str_property["id"][] = $o_property[$table."_property_link_id"][$p];
                     $str_property["property_id"][] = $o_property[$table."_property_id"][$p];
                     $str_property["name"][] = $o_property[$table."_property_group_name"][$p];
                     if ($this->lang_id > 0) if (isset($o_property[$table."_property_name"][$p])) $str_property["value"][] = $o_property[$table."_property_name"][$p];
                     else $str_property["value"][] = $o_property[$table."_property_name"][$p];
                }
            }                                                                                 
        }
        }
        return $str_property;
    }
    
    
    function searchProperty($p_mass)
    {
    	$where='';
		// 
		if ((isset($a_params["project_name"])) AND (trim($a_params["project_name"])!=""))
		{
		    $where.=' AND object.object_name LIKE "%'.$a_params["project_name"].'%"';
		}
		// 
		if ((isset($a_params["pay_from"])) AND (trim($a_params["pay_from"])!=""))
		{
		    $where.=' AND object.object_id=any
		(
		SELECT DISTINCT object.object_id
		FROM ((object
		LEFT JOIN object_property_link ON object.object_id=object_property_link.object_id)
		LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id)
		LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id
		WHERE object_property_link.object_property_id=2 AND object_property.object_property_id=15 AND object_property_link.object_property_link_double>='.$a_params["pay_from"];
		    $num++;
		}
		// 
		if ((isset($a_params["pay_to"])) AND (trim($a_params["pay_to"])!=""))
		{
		    $where.=' AND object.object_id=any
		(
		SELECT DISTINCT object.object_id
		FROM ((object
		LEFT JOIN object_property_link ON object.object_id=object_property_link.object_id)
		LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id)
		LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id
		WHERE object_property_link.object_property_id=2 AND object_property.object_property_id=15 AND object_property_link.object_property_link_double<='.$a_params["pay_to"];
		    $num++;
		}
		// 
		if ((isset($a_params["sqare_from"])) AND (trim($a_params["sqare_from"])!=""))
		{
		    $where.=' AND object.object_id=any
		(
		SELECT DISTINCT object.object_id
		FROM ((object
		LEFT JOIN object_property_link ON object.object_id=object_property_link.object_id)
		LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id)
		LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id
		WHERE object_property_link.object_property_id=2 AND object_property.object_property_id=2 AND object_property_link.object_property_link_double>='.$a_params["sqare_from"];
		    $num++;
		}
		// 
		if ((isset($a_params["sqare_to"])) AND (trim($a_params["sqare_to"])!=""))
		{
		    $where.=' AND object.object_id=any
		(
		SELECT DISTINCT object.object_id
		FROM ((object
		LEFT JOIN object_property_link ON object.object_id=object_property_link.object_id)
		LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id)
		LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id
		WHERE object_property_link.object_property_id=2 AND object_property.object_property_id=2 AND object_property_link.object_property_link_double<='.$a_params["sqare_to"];
		    $num++;
		}
		// 
		if ((isset($a_params["gabarit_from"])) AND (trim($a_params["gabarit_from"])!=""))
		{
		    $where.=' AND object.object_id=any
		(
		SELECT DISTINCT object.object_id
		FROM ((object
		LEFT JOIN object_property_link ON object.object_id=object_property_link.object_id)
		LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id)
		LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id
		WHERE object_property_link.object_property_id=2 AND object_property.object_property_id=4 AND object_property_link.object_property_link_integer<='.$a_params["gabarit_from"];
		    $num++;
		}
		// 
		if ((isset($a_params["gabarit_to"])) AND (trim($a_params["gabarit_to"])!=""))
		{
		    $where.=' AND object.object_id=any
		(
		SELECT DISTINCT object.object_id
		FROM ((object
		LEFT JOIN object_property_link ON object.object_id=object_property_link.object_id)
		LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id)
		LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id
		WHERE object_property_link.object_property_id=2 AND object_property.object_property_id=78 AND object_property_link.object_property_link_integer<='.$a_params["gabarit_to"];
		    $num++;
		}
		//
		if ((isset($a_params["floor"])) AND (trim($a_params["floor"])!=""))
		{
		    $where.=' AND object.object_id=any
		(
		SELECT DISTINCT object.object_id
		FROM ((object
		LEFT JOIN object_property_link ON object.object_id=object_property_link.object_id)
		LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id)
		LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id
		WHERE object_property_link.object_property_id=2 AND object_property.object_property_id=39 AND object_property_link.object_property_link_integer='.$a_params["floor"];
		    $num++;
		}
		// 
		if ((isset($a_params["cokol"])) AND (trim($a_params["cokol"])!=""))
		{
		    $where.=' AND object.object_id=any
		(
		SELECT DISTINCT object.object_id
		FROM ((object
		LEFT JOIN object_property_link ON object.object_id=object_property_link.object_id)
		LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id)
		LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id
		WHERE object_property_link.object_property_id=2 AND object_property.object_property_id=73';
		    $num++;
		}
		//
		if ((isset($a_params["mansarda"])) AND (trim($a_params["mansarda"])!=""))
		{
		    $where.=' AND object.object_id=any
		(
		SELECT DISTINCT object.object_id
		FROM ((object
		LEFT JOIN object_property_link ON object.object_id=object_property_link.object_id)
		LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id)
		LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id
		WHERE object_property_link.object_property_id=2 AND object_property.object_property_id=76';
		    $num++;
		}
		//
		if ((isset($a_params["garage"])) AND (trim($a_params["garage"])!=""))
		{
		    $where.=' AND object.object_id=any
		(
		SELECT DISTINCT object.object_id
		FROM ((object
		LEFT JOIN object_property_link ON object.object_id=object_property_link.object_id)
		LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id)
		LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id
		WHERE object_property_link.object_property_id=2 AND object_property.object_property_id=25';
		    $num++;
		}
		
		$skoba='';
		for($n=1;$n<=$num;$n++)
		{
		    $skoba=$skoba.')';
		}
		
		$where='SELECT DISTINCT object.object_id, object.object_name, object.object_picture_icon
		FROM ((object
		LEFT JOIN object_property_link ON object.object_id=object_property_link.object_id)
		LEFT JOIN object_property ON object_property_link.object_property_id=object_property.object_property_id)
		LEFT JOIN object_property_group ON object_property.object_property_group_id=object_property_group.object_property_group_id
		WHERE object_property_link.object_property_id=2 AND object.view_id=6'.$where.$skoba;
		
		//
		$o_object_count = $objects->getAllObjectNameCOUNT($where);
		
		$limit=" LIMIT ".$a_params["start"]*$kol.",".$kol;
		$o_object = $objects->getAllObjectName($where , $limit, ' ORDER BY object_property_link.object_property_link_double');
    }

    function RecordCount()
    {
        return $this->res->RecordCount();
    }

    function FetchArray()
    {
        return $this->res->FetchArray();
    }
}
?>
