<?php
//Категории и Объекты
class objects
{
    var $db;
    var $object_tree;
    var $a_params;
    var $lang_id;
    var $lang_name;
    var $table;
    var $res;

    function objects(&$db, &$a_params, $lang_id = null)
    {
        $this->db = &$db;
        $this->a_params = &$a_params;
        $this->lang_id = $lang_id;
    }

    //Дерево объектов
    function getTree($table, $id)
    {
        $res = $this->db->Execute("SELECT * FROM ".$table." WHERE ".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            $elements = $res->FetchArray();
        }
        if ($elements[$table."_parent"]!=0)
        {
            $this->object_tree[$table."_id"][]=$elements[$table."_id"];
            $this->object_tree[$table."_name"][]=$elements[$table."_name"];
            $this->object_tree[$table."_parent"][]=$elements[$table."_parent"];
            $this->object_tree["category_id"][]=$elements["category_id"];
            $this->object_tree["view_id"][]=$elements["view_id"];                  
            $this->object_tree[$table."_filename"][]=$elements[$table."_filename"];
            $this->object_tree[$table."_picture_icon"][]=$elements[$table."_picture_icon"];
            $this->object_tree[$table."_picture_banner"][]=$elements[$table."_picture_banner"];
            $this->object_tree[$table."_picture_background"][]=$elements[$table."_picture_background"];
            return $this->getTree($table, $elements[$table."_parent"]);
        }
        else
        {
            $this->object_tree[$table."_id"][]=$elements[$table."_id"];
            $this->object_tree[$table."_name"][]=$elements[$table."_name"];
            $this->object_tree[$table."_parent"][]=$elements[$table."_parent"];
            $this->object_tree["category_id"][]=$elements["category_id"];
            $this->object_tree["view_id"][]=$elements["view_id"];
            $this->object_tree[$table."_filename"][]=$elements[$table."_filename"];
            $this->object_tree[$table."_picture_icon"][]=$elements[$table."_picture_icon"];
            $this->object_tree[$table."_picture_banner"][]=$elements[$table."_picture_banner"];
            $this->object_tree[$table."_picture_background"][]=$elements[$table."_picture_background"];
            return $elements["category_id"];
        }
    }
    
    //Вывод запроса
    function getSelect($select)
    {
        $mass_element=array();
        if ($select=="") return 0;

        $res = $this->db->Execute($select);
        $columns = $res->FieldNums($res);
        $mass_name=array();
        for ($i = 0; $i < $columns; $i++) 
        {
            $mass_name[]=$res->FieldName($i);
        }
        
        if ($res->RecordCount()>0)
        {           
            while ($element = $res->FetchArray())
            {
                for ($i = 0; $i < $columns; $i++) 
                {
                    $mass_element[$mass_name[$i]][]=$element[$mass_name[$i]]; 
                }                
            }
        }

        return $mass_element;
    }

    function getNameName($table, $id)
    {
        if (!isset($id)) return '';
        if ($id<=0) return '';
        //Проверка на выбранный язык
        $lang_where="";
        if ($this->lang_id > 0) $lang_where="(".$table."_name.lang_id=".$this->lang_id.") AND "; 
        
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_name FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_name"];
            }
        }
        
        //Default
        $lang_where="";
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_name FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_name"];
            }
        }
        //-------

        return '';
    }
        function getNameAddTitle($table, $id)
    {
        if (!isset($id)) return '';
        if ($id<=0) return '';
        //Проверка на выбранный язык
        $lang_where="";
        if ($this->lang_id > 0) $lang_where="(".$table."_name.lang_id=".$this->lang_id.") AND "; 
        
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_add_title FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_add_title"];
            }
        }
        
        //Default
        $lang_where="";
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_add_title FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_add_title"];
            }
        }
        //-------

        return '';
    }
    
    function getNameID($table, $id)
    {
        if (!isset($id)) return '';
        if ($id<=0) return '';
        //Проверка на выбранный язык
        $lang_where="";
        if ($this->lang_id > 0) $lang_where="(".$table."_name.lang_id=".$this->lang_id.") AND "; 
        
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_id FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_id"];
            }
        }
        
        //Default
        $lang_where="";
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_id FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_id"];
            }
        }
        //-------
        
        return '';
    }
    
    function getNameDescription($table, $id)
    {
        if (!isset($id)) return '';
        if ($id<=0) return '';
        //Проверка на выбранный язык
        $lang_where="";
        if ($this->lang_id > 0) $lang_where="(".$table."_name.lang_id=".$this->lang_id.") AND "; 
        
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_description FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_description"];
            }
        }
        
        //Default
        $lang_where="";
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_description FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_description"];
            }
        }
        //-------

        return '';
    }
    
    function getNameTitle($table, $id)
    {
        if (!isset($id)) return '';
        if ($id<=0) return '';
        //Проверка на выбранный язык
        $lang_where="";
        if ($this->lang_id > 0) $lang_where="(".$table."_name.lang_id=".$this->lang_id.") AND "; 
        
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_title FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_title"];
            }
        }
        
        //Default
        $lang_where="";
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_title FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_title"];
            }
        }
        //-------

        return '';
    }
    
    function getNameKeywords($table, $id)
    {
        if (!isset($id)) return '';
        if ($id<=0) return '';
        //Проверка на выбранный язык
        $lang_where="";
        if ($this->lang_id > 0) $lang_where="(".$table."_name.lang_id=".$this->lang_id.") AND "; 
        
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_keywords FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_keywords"];
            }
        }
        
        //Default
        $lang_where="";
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_keywords FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_keywords"];
            }
        }
        //-------

        return '';
    }
    
    function getNameDescriptions($table, $id)
    {
        if (!isset($id)) return '';
        if ($id<=0) return '';
        //Проверка на выбранный язык
        $lang_where="";
        if ($this->lang_id > 0) $lang_where="(".$table."_name.lang_id=".$this->lang_id.") AND "; 
        
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_descriptions FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_descriptions"];
            }
        }
        
        //Default
        $lang_where="";
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_descriptions FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_descriptions"];
            }
        }
        //-------

        return '';
    }
    
    function getNameStreet($table, $id)
    {
        if (!isset($id)) return '';
        if ($id<=0) return '';
        //Проверка на выбранный язык
        $lang_where="";
        if ($this->lang_id > 0) $lang_where="(".$table."_name.lang_id=".$this->lang_id.") AND "; 
        
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_street FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_street"];
            }
        }
        
        //Default
        $lang_where="";
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_street FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_street"];
            }
        }
        //-------

        return '';
    }
    
    function getNameMaterials($table, $id)
    {
        if (!isset($id)) return '';
        if ($id<=0) return '';
        //Проверка на выбранный язык
        $lang_where="";
        if ($this->lang_id > 0) $lang_where="(".$table."_name.lang_id=".$this->lang_id.") AND "; 
        
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_materials FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_materials"];
            }
        }
        
        //Default
        $lang_where="";
        $mass_element=array();
        $res = $this->db->Execute("SELECT ".$table."_name_materials FROM ".$table."_name WHERE ".$lang_where.$table."_name.".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                return $element[$table."_name_materials"];
            }
        }
        //-------

        return '';
    }
    
    //Запись по id
    function getTableID($table, $id)
    {
        $res = $this->db->Execute("SELECT * FROM ".$table." WHERE ".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            $elements = $res->FetchArray();
        }
        $this->object_tree[$table."_id"][]=$elements[$table."_id"];
        $this->object_tree[$table."_name"][]=$elements[$table."_name"];
        $this->object_tree[$table."_picture_icon"][]=$elements[$table."_picture_icon"];
    }

    //Текущий язык
    function getLang()
    {
        $res = $this->db->Execute("SELECT * FROM lang WHERE lang_id=".$this->lang_id);

        if ($res->RecordCount()>0)
        {
            $lang_query = $res->FetchArray();
            $lang_name=$lang_query["lang_name"];
        }

        if ($lang_name!="") $this->lang_name=$lang_name;
        if ($this->lang_name=="") $this->lang_name="rus";

        return $this->lang_name;
    }

    //Вывод категорий по category_parent
    function getCategory($parent)
    {
        $mass_element=array();
        if ($parent=="") $parent=1;  //по умолчанию

        $res = $this->db->Execute("SELECT * FROM category WHERE category_parent=".$parent." AND (category_visible=1 OR category_visible=2) ORDER BY category_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["category_id"][]=$element["category_id"];
                $mass_element["category_parent"][]=$element["category_parent"];
                $mass_element["category_name"][]=$element["category_name"];
                $mass_element["category_name_name"][]=$this->getNameName("category", $element["category_id"]);  
                $mass_element["view_id"][]=$element["view_id"];
                $mass_element["category_picture_icon"][]=$element["category_picture_icon"];
            }
        }

        return $mass_element;
    }

    //Вывод категорий по category_id
    function getCategoryID($id)
    {
        $mass_element=array();
         $mass_element["col"]=0; 
        if ($id=="") $id=1;  //по умолчанию

        $res = $this->db->Execute("SELECT * FROM category WHERE category_id=".$id." AND (category_visible=1 OR category_visible=2) ORDER BY category_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["category_id"][]=$element["category_id"];
                $mass_element["category_parent"][]=$element["category_parent"];
                $mass_element["category_name"][]=$element["category_name"];
                $mass_element["category_name_name"][]=$this->getNameName("category", $element["category_id"]); 
                $mass_element["view_id"][]=$element["view_id"];
                $mass_element["category_picture_icon"][]=$element["category_picture_icon"];
                 $mass_element["col"]++; 
            }
        }

        return $mass_element;
    }

    //Вывод категорий по category_parent
    function getCategoryParentName($parent)
    {
        $mass_element=array();
        if ($parent=="") $parent=1;  //по умолчанию

        //Проверка на выбранный язык
        $lang_where='';
        if ($this->lang_id > 0) $lang_where="AND (category_name.lang_id=".$this->lang_id." OR category_name.lang_id=0)";

        $res = $this->db->Execute("SELECT
        category.category_id,
        category.category_parent,
        category.category_name,
        category.view_id,
        category.category_subdomain,
        category.category_picture_icon,
        category_name.category_name_id,
        category_name.category_name_name,
        category_name.category_name_add_title, 
        category_name.category_name_description,
        category_name.category_name_picture,
        category_name.category_name_title,
        category_name.category_name_keywords,
        category_name.category_name_descriptions ".
        "FROM category LEFT JOIN category_name ON category.category_id=category_name.category_id ".
        "WHERE category.category_parent=".$parent." AND category.category_visible=1 ".$lang_where." ORDER BY category.category_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["category_id"][]=$element["category_id"];
                $mass_element["category_parent"][]=$element["category_parent"];
                $mass_element["category_subdomain"][]=$element["category_subdomain"];
                $mass_element["category_name"][]=$element["category_name"];
                $mass_element["view_id"][]=$element["view_id"];
                $mass_element["category_picture_icon"][]=$element["category_picture_icon"];
                $mass_element["category_name_id"][]=$element["category_name_id"];
                $mass_element["category_name_name"][]=$element["category_name_name"];
                $mass_element["category_name_description"][]=$element["category_name_description"];
                $mass_element["category_name_picture"][]=$element["category_name_picture"];
                $mass_element["category_name_title"][]=$element["category_name_title"];
                if (isset($element["category_name_add_title"]) and $element["category_name_add_title"]!="") $mass_element["category_name_add_title"][]=$element["category_name_add_title"];
                else $mass_element["category_name_add_title"][]=$element["category_name_name"];
                $mass_element["category_name_keywords"][]=$element["category_name_keywords"];
                $mass_element["category_name_descriptions"][]=$element["category_name_descriptions"];
            }
        }

        return $mass_element;
    }
    
    //Вывод категорий по category_parent
    function getCategoryParentNameCount($parent)
    {
        $mass_element=array();
        if ($parent=="") $parent=1;  //по умолчанию

        //Проверка на выбранный язык
        $lang_where='';
        if ($this->lang_id > 0) $lang_where="AND (category_name.lang_id=".$this->lang_id." OR category_name.lang_id=0)";

        $res = $this->db->Execute("SELECT
        count(object.object_id) as obj_count,
        category.category_id,
        category.category_parent,
        category.category_name,
        category.view_id,
        category.category_subdomain,
        category.category_picture_icon,
        category_name.category_name_id,
        category_name.category_name_name,
        category_name.category_name_description,
        category_name.category_name_picture,
        category_name.category_name_title,
        category_name.category_name_keywords,
        category_name.category_name_descriptions ".
        "FROM (category LEFT JOIN category_name ON category.category_id=category_name.category_id)
         LEFT JOIN object ON category.category_id=object.category_id ".
        "WHERE category.category_parent=".$parent." AND category.category_visible=1 ".$lang_where." GROUP BY category.category_id ORDER BY category.category_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["obj_count"][]=$element["obj_count"];
                $mass_element["category_id"][]=$element["category_id"];
                $mass_element["category_parent"][]=$element["category_parent"];
                $mass_element["category_subdomain"][]=$element["category_subdomain"];
                $mass_element["category_name"][]=$element["category_name"];
                $mass_element["view_id"][]=$element["view_id"];
                $mass_element["category_picture_icon"][]=$element["category_picture_icon"];
                $mass_element["category_name_id"][]=$element["category_name_id"];
                $mass_element["category_name_name"][]=$element["category_name_name"];
                $mass_element["category_name_description"][]=$element["category_name_description"];
                $mass_element["category_name_picture"][]=$element["category_name_picture"];
                $mass_element["category_name_title"][]=$element["category_name_title"];
                $mass_element["category_name_keywords"][]=$element["category_name_keywords"];
                $mass_element["category_name_descriptions"][]=$element["category_name_descriptions"];
            }
        }

        return $mass_element;
    }

    //Вывод объектов по category_id
    function getObject($category_id, $sorting = "ORDER BY object_sort")
    {
        $mass_element=array();
        if ($category_id=="") return 0;

        $res = $this->db->Execute("SELECT * FROM object WHERE category_id=".$category_id." AND (object_visible=1 OR object_visible=2) ".$sorting);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["object_parent"][]=$element["object_parent"];
                $mass_element["object_name"][]=$element["object_name"];
                $mass_element["object_name_name"][]=$this->getNameName("object", $element["object_id"]);  
                $mass_element["view_id"][]=$element["view_id"];
                $mass_element["object_filename"][]=$element["object_filename"];
                $mass_element["object_date"][]=$element["object_date"];
            }
        }

        return $mass_element;
    }
     function getObjectWHERE($where, $sorting = "ORDER BY object_sort")
   {
      $mass_element=array();
      $mass_element["col"]=0;
      if ($where=="") return 0;
    
      $res = $this->db->Execute("SELECT * FROM object WHERE $where AND (object_visible=1 OR object_visible=2) ".$sorting);

      if ($res->RecordCount()>0)
      {
         while ($element = $res->FetchArray())
         {
            $mass_element["object_id"][]=$element["object_id"];
            $mass_element["category_id"][]=$element["category_id"];
            $mass_element["object_parent"][]=$element["object_parent"];
            $mass_element["object_name"][]=$element["object_name"];
            $mass_element["view_id"][]=$element["view_id"];
            $mass_element["object_filename"][]=$element["object_filename"];
            if (($element["object_date"]!="0000-00-00") AND ($element["object_date"]!=""))
            {
               $mass_element["object_date"][]=date('d.m.Y', $this->str2time($element["object_date"], 'Y-m-d'));
            }
            else
            {
               $mass_element["object_date"][]=null;
            }
            if (($element["object_date_from"]!="0000-00-00") AND ($element["object_date_from"]!=""))
            {
               $mass_element["object_date_from"][]=date('d.m.Y', $this->str2time($element["object_date_from"], 'Y-m-d'));
            }
            else
            {
               $mass_element["object_date_from"][]=null;
            }
            if (($element["object_date_to"]!="0000-00-00") AND ($element["object_date_to"]!=""))
            {
               $mass_element["object_date_to"][]=date('d.m.Y', $this->str2time($element["object_date_to"], 'Y-m-d'));
            }
            else
            {
               $mass_element["object_date_to"][]=null;
            }
            $mass_element["object_description"][]=$element["object_description"];
            $mass_element["object_picture_icon"][]=$element["object_picture_icon"];
            $mass_element["col"]++;
         }
      }
      return $mass_element;
   }
    //Вывод объектов по object_parent
    function getObjectParent($object_parent)
    {
        $mass_element=array();
        if ($object_parent=="") return 0;

        $res = $this->db->Execute("SELECT * FROM object WHERE object_parent=".$object_parent." AND (object_visible=1 OR object_visible=2) ORDER BY object_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["object_parent"][]=$element["object_parent"];
                $mass_element["object_name"][]=$element["object_name"];
                $mass_element["object_name_name"][]=$this->getNameName("object", $element["object_id"]);
                $mass_element["view_id"][]=$element["view_id"];
            }
        }

        return $mass_element;
    }

    //Вывод описания категории
    function getCategoryName($id)
    {
        if ($id=="") $id=1;  //по умолчанию

        //Проверка на выбранный язык
        $lang_where="";
        if ($this->lang_id > 0) $lang_where="AND (category_name.lang_id=".$this->lang_id." OR category_name.lang_id=0)";

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        category.category_id,
        category.category_name,
        category_name.category_name_id,
        category_name.category_name_name,
        category_name.category_name_description,
        category_name.category_name_picture,
        category_name.category_name_title,
        category_name.category_name_keywords,
        category_name.category_name_descriptions ".
        "FROM category LEFT JOIN category_name ON category.category_id=category_name.category_id ".
        "WHERE category.category_id=".$id." ".$lang_where." ORDER BY category_name.category_name_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["category_id"][]=$element["category_id"];
                $mass_element["category_name"][]=$element["category_name"];
                $mass_element["category_name_id"][]=$element["category_name_id"];
                $mass_element["category_name_name"][]=$element["category_name_name"];
                $mass_element["category_name_description"][]=$element["category_name_description"];
                $mass_element["category_name_picture"][]=$element["category_name_picture"];
                $mass_element["category_name_title"][]=$element["category_name_title"];
                $mass_element["category_name_keywords"][]=$element["category_name_keywords"];
                $mass_element["category_name_descriptions"][]=$element["category_name_descriptions"];
            }
        }

        return $mass_element;
    }

    //Вывод описания объекта
    function getObjectName($id)
    {
        if ($id<=0) return 0;

        //Проверка на выбранный язык
        $lang_where="";
        //if ($this->lang_id > 0) $lang_where="AND (object_name.lang_id=".$this->lang_id." OR object_name.lang_id=0)";  
        
        $mass_element=array();
        $res = $this->db->Execute("SELECT
        object.object_id,
        object.category_id,
        object.object_name,
        object.object_code,
        object.object_mail,
        object.object_phone,
        object.object_price,
        object.object_price_size,
        object.region_id,
        object.view_id,
        object.object_picture_icon,
        object.object_picture_banner,
        object.object_date,
        object.object_new ".
        "FROM object ".
        "WHERE object.object_id=".$id." AND object.object_visible=1 ".$lang_where.";");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["category_id"][]=$element["category_id"];
                $mass_element["object_name"][]=$element["object_name"];
                $mass_element["object_new"][]=$element["object_new"];
                
                $mass_element["object_picture_icon"][]=$element["object_picture_icon"];
                $mass_element["object_picture_banner"][]=$element["object_picture_banner"]; 
                
                
                $mass_element["object_code"][]=$element["object_code"];                
                $mass_element["object_mail"][]=$element["object_mail"];
                $mass_element["object_phone"][]=$element["object_phone"]; 
                $mass_element["region_id"][]=$element["region_id"];
                 $mass_element["view_id"][]=$element["view_id"];
                
                if ($element["region_id"]>0)
                {
                    $mass_element["region_name_name"][]=$this->getNameName("region", $element["region_id"]); 
                    
                    $region_id=$this->getSelect("SELECT * FROM region WHERE region_id=".$element["region_id"]);
                    $region_parent=$this->getSelect("SELECT * FROM region WHERE region_id=".$region_id["region_parent"][0]);
                    
                    if ((isset($region_parent["region_id"][0])) AND ($region_parent["region_id"][0]>0))
                    {
                        $mass_element["region_parent_name_name"][]=$this->getNameName("region", $region_parent["region_id"][0])."; "; 
                    }
                    else
                    {
                        $mass_element["region_parent_name_name"][]="";
                    }
                    
                    if ((isset($region_parent["region_parent"][0])) AND ($region_parent["region_parent"][0]>0))
                    {
                        $region_parent_parent=$this->getSelect("SELECT * FROM region WHERE region_id=".$region_parent["region_parent"][0]);
                        $mass_element["region_parent_parent_name_name"][]=$this->getNameName("region", $region_parent_parent["region_id"][0])."; ";
                    }
                    else
                    {
                        $mass_element["region_parent_parent_name_name"][]="";
                    }
                    
                }
                else
                {
                    $mass_element["region_name_name"][]="";
                    $mass_element["region_parent_name_name"][]="";
                    $mass_element["region_parent_parent_name_name"][]="";
                }
                

                if (($element["object_date"]!="0000-00-00") AND ($element["object_date"]!=""))
                {
                    $mass_element["object_date"][]=date('d.m.Y', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_day"][]=date('d', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_moon"][]=date('m', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_year"][]=date('Y', $this->str2time($element["object_date"], 'Y-m-d'));
                }
                else
                {
                    $mass_element["object_date"][]=null;
                    $mass_element["object_day"][]=null;
                    $mass_element["object_moon"][]=null;
                    $mass_element["object_year"][]=null;
                }

                
                $mass_element["object_name_id"][]=$this->getNameID("object", $element["object_id"]);
                $mass_element["object_name_name"][]=$this->getNameName("object", $element["object_id"]);
                $mass_element["object_name_description"][]=$this->getNameDescription("object", $element["object_id"]);
                $mass_element["object_name_title"][]=$this->getNameTitle("object", $element["object_id"]);
                $mass_element["object_name_keywords"][]=$this->getNameKeywords("object", $element["object_id"]);
                $mass_element["object_name_descriptions"][]=$this->getNameDescriptions("object", $element["object_id"]);
            }
        }

        return $mass_element;
    }   
     //Вывод списка языков
    function getLangTranslate()
    {

$mass_element=array();
 $lang_where="";
 if ($this->lang_id > 0) $lang_where="AND (lang_translate_name.lang_id=".$this->lang_id." OR lang_translate_name.lang_id=0) ";  
        
$res = $this->db->Execute("
SELECT lang_translate.lang_translate_id, 
lang_translate.lang_translate_name, 
lang_translate.lang_translate_description, 
lang_translate.lang_translate_sort, 
lang_translate_name.lang_translate_name_id, 
lang_translate_name.lang_translate_name_name, 
lang_translate_name.lang_translate_name_description
FROM lang_translate INNER JOIN lang_translate_name ON lang_translate.lang_translate_id = lang_translate_name.lang_translate_id
WHERE lang_translate.lang_translate_id>0 ".$lang_where."
ORDER BY lang_translate_name.lang_translate_name_name");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["lang_translate_id"][]=$element["lang_translate_id"];
                $mass_element["lang_translate_name"][]=$element["lang_translate_name"];
                $mass_element["lang_translate_description"][]=$element["lang_translate_description"];
                $mass_element["lang_translate_sort"][]=$element["lang_translate_sort"];
                
                /*$mass_element["lang_translate_name_id"][]=$this->getNameID("lang_translate", $element["lang_translate_id"]);
                $mass_element["lang_translate_name_name"][]=$this->getNameName("lang_translate", $element["lang_translate_id"]);
                $mass_element["lang_translate_name_description"][]=$this->getNameDescription("lang_translate", $element["lang_translate_id"]);*/
                $mass_element["lang_translate_name_id"][]=$element["lang_translate_name_id"];
                $mass_element["lang_translate_name_name"][]=$element["lang_translate_name_name"];
                $mass_element["lang_translate_name_description"][]=$element["lang_translate_name_description"];
            }
        }


        return $mass_element;
    } 
    function array_key_multi_sort($arr, $l , $f='strnatcasecmp')
{
    usort($arr, create_function('$a, $b', "return $f(\$a['$l'], \$b['$l']);"));
    return($arr);
    //$mass_element= $this->array_key_multi_sort($mass_element, 'lang_translate_name_name');
}


function getLangTranslateById($id)
    {
   if ($id<=0) return 0;  
$mass_element=array();
$res = $this->db->Execute("
SELECT lang_translate_id, 
lang_translate_name, 
lang_translate_description, 
lang_translate_sort
FROM 
lang_translate
where lang_translate_id= ".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["lang_translate_id"][]=$element["lang_translate_id"];
                $mass_element["lang_translate_name"][]=$element["lang_translate_name"];
                $mass_element["lang_translate_description"][]=$element["lang_translate_description"];
                $mass_element["lang_translate_sort"][]=$element["lang_translate_sort"];
                
                $mass_element["lang_translate_name_id"][]=$this->getNameID("lang_translate", $element["lang_translate_id"]);
                $mass_element["lang_translate_name_name"][]=$this->getNameName("lang_translate", $element["lang_translate_id"]);
                $mass_element["lang_translate_name_description"][]=$this->getNameDescription("lang_translate", $element["lang_translate_id"]);                
            }
        }

        return $mass_element;
    }
    function getThemeTranslateById2($id)
    {
   if ($id<=0) return 0;  
$mass_element=array();
$res = $this->db->Execute("
SELECT     theme_id, 
    theme_name, 
    theme_sort
     
    FROM 
    theme 

where theme_id= ".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["theme_id"][]=$element["theme_id"];
                $mass_element["theme_name"][]=$element["theme_name"];

                $mass_element["theme_sort"][]=$element["theme_sort"];
                
                $mass_element["theme_name_id"][]=$this->getNameID("theme", $element["theme_id"]);
                $mass_element["theme_name_name"][]=$this->getNameName("theme", $element["theme_id"]);
                
            }
        }

        return $mass_element;
    }
    //Вывод списка языков юзера-переводчика
function getLangTranslateByUserId($id)
    {
   if ($id<=0) return 0;  
$mass_element=array();
$res = $this->db->Execute("
SELECT
user_site_lang_id, 
user_site_id, 
lang_translate_id, 
lang_translate_to_id, 
user_site_lang_name, 
user_site_file_sort
FROM 
user_site_lang
WHERE user_site_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["user_site_lang_id"][]=$element["user_site_lang_id"];
                $mass_element["lang_translate_id"][]=$element["lang_translate_id"];
                $mass_element["lang_translate_to_id"][]=$element["lang_translate_to_id"];
                $mass_element["user_site_lang_name"][]=$element["user_site_lang_name"];
                $mass_element["user_site_file_sort"][]=$element["user_site_file_sort"];
                              
            }
        }

        return $mass_element;
    }
           //Вывод списка тем юзера-переводчика
function geThemeTranslateByUserId($id)
    {
   if ($id<=0) return 0;  
$mass_element=array();
$res = $this->db->Execute("
SELECT     user_site_theme_id, 
    user_site_theme_name, 
    user_site_id, 
    theme_translate_id, 
    user_site_theme_sort
     
    FROM 
    user_site_theme 
WHERE user_site_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["user_site_theme_id"][]=$element["user_site_theme_id"];
                $mass_element["theme_translate_id"][]=$element["theme_translate_id"];
                
                $mass_element["user_site_theme_name"][]=$element["user_site_theme_name"];
                $mass_element["user_site_theme_sort"][]=$element["user_site_theme_sort"];
                              
            }
        }

        return $mass_element;
    }
       
        //Вывод списка юзеров-переводчиков по языку
function getTranslatorByLangId($id,$stwhere="")
    {
   if ($id<0) return 0;  
$mass_element=array();
if($id==0){
    $res = $this->db->Execute("SELECT 
user_site.user_site_id, 
user_site.user_site_login, 
user_site.user_site_name, 
user_site.user_site_picture, 
user_site.user_site_rating, 
user_site.user_site_thema, 
user_site.user_site_status, 
user_site.user_site_phone, 
user_site.user_site_type
FROM user_site 
WHERE user_site.user_site_type=1 ".$stwhere);
}
else{
$res = $this->db->Execute("SELECT 
user_site.user_site_id, 
user_site.user_site_login, 
user_site.user_site_name, 
user_site.user_site_picture, 
user_site.user_site_rating, 
user_site.user_site_thema, 
user_site.user_site_status, 
user_site.user_site_phone, 
user_site.user_site_type
FROM user_site INNER JOIN user_site_lang ON user_site.user_site_id = user_site_lang.user_site_id
WHERE user_site.user_site_type=1 and user_site_lang.lang_translate_id=".$id.$stwhere);
}
        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["user_site_id"][]=$element["user_site_id"];
                $mass_element["user_site_login"][]=$element["user_site_login"];
                $mass_element["user_site_name"][]=$element["user_site_name"];
                $mass_element["user_site_rating"][]=$element["user_site_rating"];
                $mass_element["user_site_thema"][]=$element["user_site_thema"];
                $mass_element["user_site_status"][]=$element["user_site_status"];
                $mass_element["user_site_phone"][]=$element["user_site_phone"];
                $mass_element["user_site_picture"][]=$element["user_site_picture"];
            }
        }

        return $mass_element;
    }
    
    //Вывод списка тем перевода
    function getThemeTranslate()
    {
$lang_where="";
 if ($this->lang_id > 0) $lang_where="AND (theme_name.lang_id=".$this->lang_id." OR theme_name.lang_id=0) ";  
        
$mass_element=array();
$res = $this->db->Execute("
SELECT theme.theme_id,
theme.theme_name,
theme.theme_sort,
theme_name.theme_name_id,
theme_name.theme_name_name
FROM theme INNER JOIN theme_name ON theme.theme_id = theme_name.theme_id
WHERE theme.theme_id>0 ".$lang_where."
ORDER BY theme_name.theme_name_name");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["theme_id"][]=$element["theme_id"];
                $mass_element["theme_name"][]=$element["theme_name"];
                $mass_element["theme_sort"][]=$element["theme_sort"];
                $mass_element["theme_name_id"][]=$element["theme_name_id"];
                $mass_element["theme_name_name"][]=$element["theme_name_name"];
            }
        }

        return $mass_element;
    }
        //Вывод списка тем перевода id
    function getThemeTranslateById($id)
    {
    if ($id<=0) return 0;  
$mass_element=array();
$res = $this->db->Execute("
SELECT theme_id, 
theme_name, 
theme_sort
 FROM 
theme
where theme_id=".$id);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["theme_id"][]=$element["theme_id"];
                $mass_element["theme_name"][]=$element["theme_name"];
                $mass_element["theme_sort"][]=$element["theme_sort"];
                $mass_element["theme_name_id"][]=$this->getNameID("theme", $element["theme_id"]);
                $mass_element["theme_name_name"][]=$this->getNameName("theme", $element["theme_id"]);
            }
        }

        return $mass_element;
    }
    
    //Вывод описания объекта
    function getObjectNameCategory($id, $sort = null)
    {
        if ($id<=0) return 0;
        if ($sort==null) $sort=" ORDER BY object.object_sort";
        //Проверка на выбранный язык
        $lang_where="";
        //if ($this->lang_id > 0) $lang_where="AND (object_name.lang_id=".$this->lang_id.")";

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        object.object_id,
        object.object_name,
        object.object_mail,
        object.object_phone,        
        object.object_code,
        object.region_id,
        object.object_date,
        object.object_new,
        object.object_picture_icon, 
        object.object_picture_icon_add_alt, 
        object.object_picture_banner, 
        object.object_picture_banner_add_alt 
        FROM object WHERE object.category_id=".$id." AND object.object_visible=1 ".$lang_where.$sort);
       
        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["object_name"][]=$element["object_name"];
                
                
                $mass_element["object_code"][]=$element["object_code"];
                $mass_element["object_mail"][]=$element["object_mail"];
                $mass_element["object_phone"][]=$element["object_phone"]; 
                $mass_element["region_id"][]=$element["region_id"];
                
                if ($element["region_id"]>0)
                {
                    $mass_element["region_name_name"][]=$this->getNameName("region", $element["region_id"]); 
                    
                    $region_id=$this->getSelect("SELECT * FROM region WHERE region_id=".$element["region_id"]);
                    $region_parent=$this->getSelect("SELECT * FROM region WHERE region_id=".$region_id["region_parent"][0]);
                    
                    if ((isset($region_parent["region_id"][0])) AND ($region_parent["region_id"][0]>0))
                    {
                        $mass_element["region_parent_name_name"][]=$this->getNameName("region", $region_parent["region_id"][0])."; "; 
                    }
                    else
                    {
                        $mass_element["region_parent_name_name"][]="";
                    }
                    
                    if ((isset($region_parent["region_parent"][0])) AND ($region_parent["region_parent"][0]>0))
                    {
                        $region_parent_parent=$this->getSelect("SELECT * FROM region WHERE region_id=".$region_parent["region_parent"][0]);
                        $mass_element["region_parent_parent_name_name"][]=$this->getNameName("region", $region_parent_parent["region_id"][0])."; ";
                    }
                    else
                    {
                        $mass_element["region_parent_parent_name_name"][]="";
                    }
                    
                }
                else
                {
                    $mass_element["region_name_name"][]="";
                    $mass_element["region_parent_name_name"][]="";
                    $mass_element["region_parent_parent_name_name"][]="";
                }

                if (($element["object_date"]!="0000-00-00") AND ($element["object_date"]!=""))
                {
                    $mass_element["object_date"][]=date('d.m.Y', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_day"][]=date('d', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_moon"][]=date('m', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_year"][]=date('Y', $this->str2time($element["object_date"], 'Y-m-d'));
                }
                else
                {
                    $mass_element["object_date"][]=null;
                    $mass_element["object_day"][]=null;
                    $mass_element["object_moon"][]=null;
                    $mass_element["object_year"][]=null;
                }

                $mass_element["object_new"][]=$element["object_new"]; 
                $mass_element["object_picture_icon"][]=$element["object_picture_icon"];
                 if (isset($element["object_picture_icon_add_alt"]) and $element["object_picture_icon_add_alt"]!="") $mass_element["object_picture_icon_add_alt"][]=$element["object_picture_icon_add_alt"];
                else $mass_element["object_picture_icon_add_alt"][]=$this->getNameName("object", $element["object_id"]);    
                $mass_element["object_picture_banner"][]=$element["object_picture_banner"];
                if (isset($element["object_picture_banner_add_alt"]) and $element["object_picture_banner_add_alt"]!="") $mass_element["object_picture_banner_add_alt"][]=$element["object_picture_banner_add_alt"];
                else $mass_element["object_picture_banner_add_alt"][]=$this->getNameName("object", $element["object_id"]);
                
                $mass_element["object_name_id"][]=$this->getNameID("object", $element["object_id"]);
                $mass_element["object_name_name"][]=$this->getNameName("object", $element["object_id"]);
                $mass_element["object_name_description"][]=$this->getNameDescription("object", $element["object_id"]); 
                $mass_element["object_name_street"][]=$this->getNameStreet("object", $element["object_id"]);
                $mass_element["object_name_materials"][]=$this->getNameMaterials("object", $element["object_id"]);
            }
        }

        return $mass_element;
    }
    
    //Вывод поиска
    function getObjectNameSearch($where = null, $sort = null)
    {
        if ($sort==null) $sort=" ORDER BY object.object_sort";
        //Проверка на выбранный язык
        $lang_where="";
        //if ($this->lang_id > 0) $lang_where="AND (object_name.lang_id=".$this->lang_id.")";

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        object.object_id,
        object.object_name,
        object.object_code,
        object.region_id,
        object.object_date,
        object.object_new,
        object.object_picture_icon, 
        object.object_picture_banner 
        FROM object WHERE object.view_id=3 AND object.object_visible=1 ".$where.$lang_where.$sort);
       
        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["object_name"][]=$element["object_name"];
                
                $mass_element["object_code"][]=$element["object_code"];
                $mass_element["region_id"][]=$element["region_id"];
                
                if ($element["region_id"]>0)
                {
                    $mass_element["region_name_name"][]=$this->getNameName("region", $element["region_id"]); 
                    
                    $region_id=$this->getSelect("SELECT * FROM region WHERE region_id=".$element["region_id"]);
                    $region_parent=$this->getSelect("SELECT * FROM region WHERE region_id=".$region_id["region_parent"][0]);
                    
                    if ((isset($region_parent["region_id"][0])) AND ($region_parent["region_id"][0]>0))
                    {
                        $mass_element["region_parent_name_name"][]=$this->getNameName("region", $region_parent["region_id"][0])."; "; 
                    }
                    else
                    {
                        $mass_element["region_parent_name_name"][]="";
                    }
                    
                    if ((isset($region_parent["region_parent"][0])) AND ($region_parent["region_parent"][0]>0))
                    {
                        $region_parent_parent=$this->getSelect("SELECT * FROM region WHERE region_id=".$region_parent["region_parent"][0]);
                        $mass_element["region_parent_parent_name_name"][]=$this->getNameName("region", $region_parent_parent["region_id"][0])."; ";
                    }
                    else
                    {
                        $mass_element["region_parent_parent_name_name"][]="";
                    }
                    
                }
                else
                {
                    $mass_element["region_name_name"][]="";
                    $mass_element["region_parent_name_name"][]="";
                    $mass_element["region_parent_parent_name_name"][]="";
                }

                if (($element["object_date"]!="0000-00-00") AND ($element["object_date"]!=""))
                {
                    $mass_element["object_date"][]=date('d.m.Y', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_day"][]=date('d', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_moon"][]=date('m', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_year"][]=date('Y', $this->str2time($element["object_date"], 'Y-m-d'));
                }
                else
                {
                    $mass_element["object_date"][]=null;
                    $mass_element["object_day"][]=null;
                    $mass_element["object_moon"][]=null;
                    $mass_element["object_year"][]=null;
                }

                $mass_element["object_new"][]=$element["object_new"]; 
                $mass_element["object_picture_icon"][]=$element["object_picture_icon"];
                $mass_element["object_picture_banner"][]=$element["object_picture_banner"];
                
                $mass_element["object_name_id"][]=$this->getNameID("object", $element["object_id"]);
                $mass_element["object_name_name"][]=$this->getNameName("object", $element["object_id"]);
                $mass_element["object_name_description"][]=$this->getNameDescription("object", $element["object_id"]); 
                $mass_element["object_name_street"][]=$this->getNameStreet("object", $element["object_id"]);
                $mass_element["object_name_materials"][]=$this->getNameMaterials("object", $element["object_id"]);
            }
        }

        return $mass_element;
    }
    
    //Вывод описания объекта
    function getObjectNameCategoryAll($sort = null)
    {
        if ($sort==null) $sort=" ORDER BY object.object_sort";
        //Проверка на выбранный язык
        $lang_where="";
        //if ($this->lang_id > 0) $lang_where="AND (object_name.lang_id=".$this->lang_id.")";

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        object.object_id,
        object.object_name,
        object.object_date,
        object.object_new,
        object.object_picture_icon,         
        object.object_picture_banner 
        FROM object WHERE object.object_visible=1 ".$lang_where.$sort);
       
        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["object_name"][]=$element["object_name"];

                if (($element["object_date"]!="0000-00-00") AND ($element["object_date"]!=""))
                {
                    $mass_element["object_date"][]=date('d.m.Y', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_day"][]=date('d', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_moon"][]=date('m', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_year"][]=date('Y', $this->str2time($element["object_date"], 'Y-m-d'));
                }
                else
                {
                    $mass_element["object_date"][]=null;
                    $mass_element["object_day"][]=null;
                    $mass_element["object_moon"][]=null;
                    $mass_element["object_year"][]=null;
                }

                $mass_element["object_new"][]=$element["object_new"]; 
                $mass_element["object_picture_icon"][]=$element["object_picture_icon"];
                $mass_element["object_picture_banner"][]=$element["object_picture_banner"];
                
                $mass_element["object_name_id"][]=$this->getNameID("object", $element["object_id"]);
                $mass_element["object_name_name"][]=$this->getNameName("object", $element["object_id"]);
                $mass_element["object_name_description"][]=$this->getNameDescription("object", $element["object_id"]); 
            }
        }

        return $mass_element;
    }

    //Вывод описания объекта
    function getObjectNameCategory1($id, $sort = null)
    {
        if ($id<=0) return 0;
        if ($sort==null) $sort=" ORDER BY object.object_sort";
        //Проверка на выбранный язык
        $lang_where="";
        //if ($this->lang_id > 0) $lang_where="AND (object_name.lang_id=".$this->lang_id.")";

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        object.object_id,
        object.object_name,
        object.object_date,
        object.object_picture_icon,         
        object.object_picture_banner 
        FROM object 
        WHERE object.category_id=".$id." AND object.object_visible=1 ".$sort);
       
        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["object_name"][]=$element["object_name"];

                if (($element["object_date"]!="0000-00-00") AND ($element["object_date"]!=""))
                {
                    $mass_element["object_date"][]=date('d.m.Y', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_day"][]=date('d', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_moon"][]=date('m', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_year"][]=date('Y', $this->str2time($element["object_date"], 'Y-m-d'));
                }
                else
                {
                    $mass_element["object_date"][]=null;
                    $mass_element["object_day"][]=null;
                    $mass_element["object_moon"][]=null;
                    $mass_element["object_year"][]=null;
                }

                $mass_element["object_picture_icon"][]=$element["object_picture_icon"];
                $mass_element["object_picture_banner"][]=$element["object_picture_banner"];  
            }
        }

        return $mass_element;
    }

    //Вывод страницы описания объекта
    function getObjectNamePage($object_name_id)
    {
        if ($object_name_id<=0) return 0;

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        object_name.object_name_id,
        object_name.object_name_name,
        object_name.object_name_description,
        object_name.object_name_picture,
        object_name.object_name_title,
        object_name.object_name_keywords,
        object_name.object_name_descriptions,
        object_name.object_name_sort,
        object_name_page.object_name_page_id,
        object_name_page.object_name_page_name,
        object_name_page.object_name_page_description ".
        "FROM object_name LEFT JOIN object_name_page ON object_name.object_name_id=object_name_page.object_name_id ".
        "WHERE object_name.object_name_id=".$object_name_id." ORDER BY object_name_page.object_name_page_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_name_id"][]=$element["object_name_id"];
                $mass_element["object_name_name"][]=$element["object_name_name"];
                $mass_element["object_name_description"][]=$element["object_name_description"];
                $mass_element["object_name_picture"][]=$element["object_name_picture"];
                $mass_element["object_name_title"][]=$element["object_name_title"];
                $mass_element["object_name_keywords"][]=$element["object_name_keywords"];
                $mass_element["object_name_descriptions"][]=$element["object_name_descriptions"];
                $mass_element["object_name_sort"][]=$element["object_name_sort"];
                $mass_element["object_name_page_id"][]=$element["object_name_page_id"];
                $mass_element["object_name_page_name"][]=$element["object_name_page_name"];
                $mass_element["object_name_page_description"][]=$element["object_name_page_description"];
            }
        }

        return $mass_element;
    }

    //Вывод страницы описания объекта
    function getObjectNameFile($object_name_id)
    {
        if ($object_name_id<=0) return 0;

        $mass_element=array();
        $res = $this->db->Execute("SELECT * FROM object_name_file ".
        "WHERE object_name_id=".$object_name_id." ORDER BY object_name_file_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_name_file_id"][]=$element["object_name_file_id"];
                $mass_element["object_name_file_name"][]=$element["object_name_file_name"];
                $mass_element["object_name_file_description"][]=$element["object_name_file_description"];
                $mass_element["object_name_file_picture"][]=$element["object_name_file_picture"];
                $mass_element["object_name_file_filename"][]=$element["object_name_file_filename"];
            }
        }

        return $mass_element;
    }

    //Вывод описания объекта COUNT
    function getAllObjectNameCOUNT($sql)
    {
        $lang_where="";
        if ($this->lang_id > 0) $lang_where=" AND (object_name.lang_id=".$this->lang_id." OR object_name.lang_id=0)";

        $mass_element=array();
        $res = $this->db->Execute($sql.$lang_where);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_id"][]=$element["object_id"];
            }
        }

        return $mass_element;
    }
    
     //Вывод описания объекта
    function getAllObjectName($sql, $limit = null, $order = null)
    {
        //Проверка на выбранный язык
        $lang_where="";
        if ($this->lang_id > 0) $lang_where=" AND (object_name.lang_id=".$this->lang_id." OR object_name.lang_id=0)";

        if ($order==null) $order=" ORDER BY object.object_sort";

        $mass_element=array();
        $res = $this->db->Execute($sql.$lang_where.$order.$limit);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["object_name"][]=$element["object_name"];
                if (isset($element["object_name_description"])) $mass_element["object_name_description"][]=$element["object_name_description"];
                $mass_element["object_picture_icon"][]=$element["object_picture_icon"];
            }
        }

        return $mass_element;
    }
    
    //Вывод галереи
    function getObjectPicture($id)
    {
        if ($id<=0) return 0;

        //Проверка на выбранный язык
        $lang_where="";
           //if ($this->lang_id > 0) $lang_where=" AND (object_picture_name.lang_id=".$this->lang_id." OR object_picture_name.lang_id=0)"; 
        $mass_element=array();
        $res = $this->db->Execute("SELECT
        object_picture.object_picture_id,
        object_picture.object_picture_name,
        object_picture.object_picture_picture,
        object_picture.object_picture_picturebig,
        object_picture.object_picture_group_id,
        object_picture.object_picture_groupname ".
        "FROM object_picture  ".
        "WHERE object_picture.object_id=".$id." ".$lang_where." ORDER BY object_picture.object_picture_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_picture_id"][]=$element["object_picture_id"];
                $mass_element["object_picture_name"][]=$element["object_picture_name"];
                $mass_element["object_picture_picture"][]=$element["object_picture_picture"];
                $mass_element["object_picture_picturebig"][]=$element["object_picture_picturebig"];
                $mass_element["object_picture_group_id"][]=$element["object_picture_group_id"];
                $mass_element["object_picture_groupname"][]=$element["object_picture_groupname"];
                $mass_element["object_picture_name_name"][]=$this->getNameName("object_picture", $element["object_picture_id"]);
                $mass_element["object_picture_name_description"][]=$this->getNameDescription("object_picture", $element["object_picture_id"]); 
           
            }
        }

        return $mass_element;
    }
    
    
    //Вывод галереи
    function getObjectPictureID($id)
    {
        if ($id<=0) return 0;

        //Проверка на выбранный язык
        $lang_where="";

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        object_picture.object_picture_id,
        object_picture.object_picture_name,
        object_picture.object_picture_picture,
        object_picture.object_picture_group_id ".
        "FROM object_picture ".
        "WHERE object_picture.object_picture_id=".$id." ".$lang_where.";");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_picture_id"][]=$element["object_picture_id"];
                $mass_element["object_picture_name"][]=$element["object_picture_name"];
                $mass_element["object_picture_picture"][]=$element["object_picture_picture"];
                $mass_element["object_picture_group_id"][]=$element["object_picture_group_id"];
                
                $mass_element["object_picture_name_name"][]=$this->getNameName("object_picture", $element["object_picture_id"]);
                $mass_element["object_picture_name_description"][]=$this->getNameDescription("object_picture", $element["object_picture_id"]);
            }
        }

        return $mass_element;
    }

    function getMessage($id)
    {
        if ($id<=0) return 0;

        $lang_where="";
        if ($this->lang_id > 0) $lang_where="AND (interface_name.lang_id=".$this->lang_id." OR interface_name.lang_id=0)";

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        interface.interface_id,
        interface_name.interface_name_id,
        interface_name.interface_name_name,
        interface_name.interface_name_sort ".
        "FROM interface LEFT JOIN interface_name ON interface.interface_id=interface_name.interface_id ".
        "WHERE interface.interface_id=".$id." ".$lang_where);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["interface_id"][]=$element["interface_id"];
                $mass_element["interface_name_id"][]=$element["interface_name_id"];
                $mass_element["interface_name_name"][]=$element["interface_name_name"];
                $mass_element["interface_name_sort"][]=$element["interface_name_sort"];
            }
        }
        else
        {
            $mass_element=array();
            $res = $this->db->Execute("SELECT
            interface.interface_id,
            interface_name.interface_name_id,
            interface_name.interface_name_name,
            interface_name.interface_name_sort ".
            "FROM interface LEFT JOIN interface_name ON interface.interface_id=interface_name.interface_id ".
            "WHERE interface.interface_id=".$id." AND (interface_name.lang_id=2 OR interface_name.lang_id=0)");

            if ($res->RecordCount()>0)
            {
                while ($element = $res->FetchArray())
                {
                    $mass_element["interface_id"][]=$element["interface_id"];
                    $mass_element["interface_name_id"][]=$element["interface_name_id"];
                    $mass_element["interface_name_name"][]=$element["interface_name_name"];
                    $mass_element["interface_name_sort"][]=$element["interface_name_sort"];
                }
            }
        }



        if (isset($mass_element["interface_name_name"][0])) return $mass_element["interface_name_name"][0];
        return "";
    }

    
    //Вывод описания NEW объекта
    function getObjectNameNew($sort = null)
    {
        if ($sort==null) $sort=" ORDER BY object.object_sort";
        //Проверка на выбранный язык
        $lang_where="";
        //if ($this->lang_id > 0) $lang_where="AND (object_name.lang_id=".$this->lang_id.")";

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        object.object_id,
        object.object_name,
        object.object_mail,
        object.object_phone,        
        object.object_code,        
        object.region_id,
        object.object_date,
        object.object_new,
        object.object_picture_icon, 
        object.object_picture_banner 
        FROM object WHERE object.object_new>0 AND object.object_visible=1 ".$lang_where.$sort);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["object_name"][]=$element["object_name"];
                                
                $mass_element["object_code"][]=$element["object_code"];
                $mass_element["object_mail"][]=$element["object_mail"];
                $mass_element["object_phone"][]=$element["object_phone"]; 
                $mass_element["region_id"][]=$element["region_id"];
                
                if ($element["region_id"]>0)
                {
                    $mass_element["region_name_name"][]=$this->getNameName("region", $element["region_id"]); 
                    
                    $region_id=$this->getSelect("SELECT * FROM region WHERE region_id=".$element["region_id"]);
                    $region_parent=$this->getSelect("SELECT * FROM region WHERE region_id=".$region_id["region_parent"][0]);
                    
                    if ((isset($region_parent["region_id"][0])) AND ($region_parent["region_id"][0]>0))
                    {
                        $mass_element["region_parent_name_name"][]=$this->getNameName("region", $region_parent["region_id"][0])."; "; 
                    }
                    else
                    {
                        $mass_element["region_parent_name_name"][]="";
                    }
                    
                    if ((isset($region_parent["region_parent"][0])) AND ($region_parent["region_parent"][0]>0))
                    {
                        $region_parent_parent=$this->getSelect("SELECT * FROM region WHERE region_id=".$region_parent["region_parent"][0]);
                        $mass_element["region_parent_parent_name_name"][]=$this->getNameName("region", $region_parent_parent["region_id"][0])."; ";
                    }
                    else
                    {
                        $mass_element["region_parent_parent_name_name"][]="";
                    }
                    
                }
                else
                {
                    $mass_element["region_name_name"][]="";
                    $mass_element["region_parent_name_name"][]="";
                    $mass_element["region_parent_parent_name_name"][]="";
                }

                if (($element["object_date"]!="0000-00-00") AND ($element["object_date"]!=""))
                {
                    $mass_element["object_date"][]=date('d.m.Y', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_day"][]=date('d', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_moon"][]=date('m', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_year"][]=date('Y', $this->str2time($element["object_date"], 'Y-m-d'));
                }
                else
                {
                    $mass_element["object_date"][]=null;
                    $mass_element["object_day"][]=null;
                    $mass_element["object_moon"][]=null;
                    $mass_element["object_year"][]=null;
                }

                $mass_element["object_new"][]=$element["object_new"]; 
                $mass_element["object_picture_icon"][]=$element["object_picture_icon"];
                $mass_element["object_picture_banner"][]=$element["object_picture_banner"];
                
                $mass_element["object_name_id"][]=$this->getNameID("object", $element["object_id"]);
                $mass_element["object_name_name"][]=$this->getNameName("object", $element["object_id"]);
                $mass_element["object_name_description"][]=$this->getNameDescription("object", $element["object_id"]); 
                $mass_element["object_name_street"][]=$this->getNameStreet("object", $element["object_id"]);
                $mass_element["object_name_materials"][]=$this->getNameMaterials("object", $element["object_id"]);
            }
        }

        return $mass_element;
    }
    
    //Вывод описания NEW объекта
    function getObjectNameTop($sort = null)
    {
        if ($sort==null) $sort=" ORDER BY object.object_sort";
        //Проверка на выбранный язык
        $lang_where="";
        //if ($this->lang_id > 0) $lang_where="AND (object_name.lang_id=".$this->lang_id.")";

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        object.object_id,
        object.object_name,
        object.object_code,
        object.object_mail,
        object.object_phone,
        object.region_id,
        object.object_date,
        object.object_new,
        object.object_picture_icon, 
        object.object_picture_banner 
        FROM object WHERE object.object_top>0 AND object.object_visible=1 ".$lang_where.$sort);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_id"][]=$element["object_id"];
                $mass_element["object_name"][]=$element["object_name"];
                                
                $mass_element["object_code"][]=$element["object_code"];
                $mass_element["object_mail"][]=$element["object_mail"];
                $mass_element["object_phone"][]=$element["object_phone"]; 
                $mass_element["region_id"][]=$element["region_id"];
                
                if ($element["region_id"]>0)
                {
                    $mass_element["region_name_name"][]=$this->getNameName("region", $element["region_id"]); 
                    
                    $region_id=$this->getSelect("SELECT * FROM region WHERE region_id=".$element["region_id"]);
                    $region_parent=$this->getSelect("SELECT * FROM region WHERE region_id=".$region_id["region_parent"][0]);
                    
                    if ((isset($region_parent["region_id"][0])) AND ($region_parent["region_id"][0]>0))
                    {
                        $mass_element["region_parent_name_name"][]=$this->getNameName("region", $region_parent["region_id"][0])."; "; 
                    }
                    else
                    {
                        $mass_element["region_parent_name_name"][]="";
                    }
                    
                    if ((isset($region_parent["region_parent"][0])) AND ($region_parent["region_parent"][0]>0))
                    {
                        $region_parent_parent=$this->getSelect("SELECT * FROM region WHERE region_id=".$region_parent["region_parent"][0]);
                        $mass_element["region_parent_parent_name_name"][]=$this->getNameName("region", $region_parent_parent["region_id"][0])."; ";
                    }
                    else
                    {
                        $mass_element["region_parent_parent_name_name"][]="";
                    }
                    
                }
                else
                {
                    $mass_element["region_name_name"][]="";
                    $mass_element["region_parent_name_name"][]="";
                    $mass_element["region_parent_parent_name_name"][]="";
                }

                if (($element["object_date"]!="0000-00-00") AND ($element["object_date"]!=""))
                {
                    $mass_element["object_date"][]=date('d.m.Y', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_day"][]=date('d', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_moon"][]=date('m', $this->str2time($element["object_date"], 'Y-m-d'));
                    $mass_element["object_year"][]=date('Y', $this->str2time($element["object_date"], 'Y-m-d'));
                }
                else
                {
                    $mass_element["object_date"][]=null;
                    $mass_element["object_day"][]=null;
                    $mass_element["object_moon"][]=null;
                    $mass_element["object_year"][]=null;
                }

                $mass_element["object_new"][]=$element["object_new"]; 
                $mass_element["object_picture_icon"][]=$element["object_picture_icon"];
                $mass_element["object_picture_banner"][]=$element["object_picture_banner"];
                
                $mass_element["object_name_id"][]=$this->getNameID("object", $element["object_id"]);
                $mass_element["object_name_name"][]=$this->getNameName("object", $element["object_id"]);
                $mass_element["object_name_description"][]=$this->getNameDescription("object", $element["object_id"]); 
                $mass_element["object_name_street"][]=$this->getNameStreet("object", $element["object_id"]);
                $mass_element["object_name_materials"][]=$this->getNameMaterials("object", $element["object_id"]);
            }
        }

        return $mass_element;
    }
    
    //Вывод отзывов объектов по object_id
    function getReferenceObject($object_id, $sort=null)
    {
        $mass_element=array();
        if ($object_id=="") return 0;        
        if ((isset($sort)) AND ($sort!=null))
        {
            $sort=' '.$sort;
        }
        else
        {
            $sort='';
        }
        
        $res = $this->db->Execute("SELECT * FROM object_reference WHERE object_id=".$object_id." ORDER BY object_reference_id".$sort);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["object_reference_id"][]=$element["object_reference_id"];  
                $mass_element["object_reference_name"][]=$element["object_reference_name"];
                $mass_element["object_reference_description"][]=$element["object_reference_description"];
                $mass_element["object_reference_date"][]=$element["object_reference_date"];
                
                if (($element["object_reference_date"]!="0000-00-00") AND ($element["object_reference_date"]!=""))
                {
                    $mass_element["object_reference_date"][]=date('d.m.Y', $this->str2time($element["object_reference_date"], 'Y-m-d'));
                    $mass_element["object_reference_day"][]=date('d', $this->str2time($element["object_reference_date"], 'Y-m-d'));
                    $mass_element["object_reference_moon"][]=date('m', $this->str2time($element["object_reference_date"], 'Y-m-d'));
                    $mass_element["object_reference_year"][]=date('Y', $this->str2time($element["object_reference_date"], 'Y-m-d'));
                }
                else
                {
                    $mass_element["object_reference_date"][]='';
                    $mass_element["object_reference_day"][]='';
                    $mass_element["object_reference_moon"][]='';
                    $mass_element["object_reference_year"][]='';
                }
            }
        }

        return $mass_element;
    }

    //Преобразование даты и времени
    function str2time($strStr, $strPattern = null)
    {
       $arrCharacters = array(
           'd', // day
           'm', // month
           'y', // year, 2 digits
           'Y', // year, 4 digits
           'H', // hours
           'i', // minutes
           's'  // seconds
       );
       $strCharacters = implode('', $arrCharacters);
       $arrDelimiters = preg_split('~['.$strCharacters.']~', $strPattern);
       $strDelimiters = quotemeta(implode('', array_unique($arrDelimiters)));
       $arrStr    = preg_split('~['.$strDelimiters.']~', $strStr);
       $arrPattern = preg_split('~['.$strDelimiters.']~', $strPattern);

       if (count($arrStr) !== count($arrPattern)) {
           return false;
       }

       $arrTime = array();
       for ($i = 0;$i < count($arrStr);$i++) {
           $arrTime[$arrPattern[$i]] = $arrStr[$i];
       }

       if (isset($arrTime['y']) && !isset($arrTime['Y'])) {
           $arrTime['Y'] = substr(date('Y'), 0, 2) . $arrTime['y'];
       }

       foreach ($arrCharacters as $strCharacter) {
           if (empty($arrTime[$strCharacter])) {
               $arrTime[$strCharacter] = date($strCharacter);
           }
       }

       if (!checkdate($arrTime['m'], $arrTime['d'], $arrTime['Y'])) {
           return false;
       }

       $intTime = mktime($arrTime['H'], $arrTime['i'], $arrTime['s'], $arrTime['m'], $arrTime['d'], $arrTime['Y']);

       return $intTime;
    }


    function RecordCount()
    {
        return $this->res->RecordCount();
    }

    function FetchArray()
    {
        return $this->res->FetchArray();
    }
}
?>
