<?php

class db {

    //
    var $conn;
    var $database;
    var $lang_id;
    var $insert_id;

    function db($host, $user, $password, $database, $lang_id=1) {
        $this->lang_id = $lang_id;
        $this->database=$database;
        $this->conn = mysql_connect($host, $user, $password);
        if (false === $this->conn) {
            return false;
        }
        if (false === mysql_select_db($database, $this->conn)) {
            return false;
        }
        return true;
    }

    // insert id
    function GenID($seqname, $start) {
        $sql = 'update ' . addslashes($seqname) . ' set id=LAST_INSERT_ID(id+1)';
        $res = $this->Execute($sql);
        $id = $start-1;
        if (false === $res) {
            $sql = 'create table ' . addslashes(strtoupper($seqname)) . ' (id int not null)';
            $this->Execute($sql);
            $sql = 'insert into ' . addslashes(strtoupper($seqname)) . '( id ) values ( ' . $id . ' )';
            $this->Execute($sql);
            return $id;
        }
        return mysql_insert_id($this->conn);
    }

    // 
    function Execute($sql) { 
        $res = mysql_query($sql, $this->conn);
        if (false === $res) {
            return false;
        }
        $this->insert_id=mysql_insert_id();        
        
        $recordset = new recordset($res, $sql);
        return $recordset;
    }

    function CacheExecute($cache, $sql) {
        return $this->Execute($sql);
    }


    function GetUpdateSQL($recordset, $data) {
        if (empty($data)) {
            return '';
        }
        preg_match_all("~FROM\s+([^\s]*)~", $recordset->sql, $maches, PREG_PATTERN_ORDER);
        if (!isset($maches[1][0])) {
            return '';
        } else {
            $table = $maches[1][0];
        }
        preg_match_all("~(WHERE\s+.*)~is", $recordset->sql, $maches, PREG_PATTERN_ORDER);
        if (!isset($maches[0][0])) {
            return '';
        } else {
            $where = $maches[0][0];
        }
        foreach ($data as $k => $v)
        {
        	if ($v == '')
        	{
        		unset($data[$k]);
        	}
		}
        $fld_names = array_keys($data);
        $fld_values = array_values($data);
        $data = 'SET ';
        for ($max = count($fld_names), $i = 0;$i < $max;$i++) {
            $data .= $fld_names[$i] . ' = \'' . $fld_values[$i] . '\' ';
            if ($i < $max-1) $data .= ', ';
        }
        $sql = 'UPDATE ' . $table . ' ' . $data . ' ' . $where;
        return $sql;
    }


    function GetInsertSQL($recordset, $data) {
        if (empty($data)) {
            return '';
        }
        preg_match_all("~FROM\s+([^\s]*)~", $recordset->sql, $maches, PREG_PATTERN_ORDER);
        if (!isset($maches[1][0])) {
            return '';
        } else {
            $table = $maches[1][0];
        }
        foreach ($data as $k => $v)
        {
        	if ($v == '')
        	{
        		unset($data[$k]);
        	}
		}
        if (!empty($data)) {
            $fld_names = implode(', ', array_keys($data));
            $fld_values = '\'' . implode('\', \'', array_values($data)) . '\'';
        }
        $sql = 'INSERT INTO ' . $table . ' (' . $fld_names . ') VALUES (' . $fld_values . ')';
        return $sql;
    }

    // Return on field result
    function GetOne($sql) {
        $res = $this->Execute($sql);
        if (false === $res) {
            return false;
        }
        return reset($res->FetchRow());
    }

    //  
    function StartTrans()
    {
        return;
    }

    function FailTrans()
    {
        return;
    }

    function CompleteTrans()
    {
        
    }

    //Return database error message
    function ErrorMsg()
    {
        return mysql_error();
    }

    //Return database error number
    function ErrorNum()
    {
        return mysql_errno();
    }

    // Close database connection
    function Close()
    {
        mysql_close($this->conn);
    }


    //$data -    
    //$getparam -     get
    function SQLSelect($data, $from, $where, $order, $getparam)
    {
    }

    // 
    function SQLInsert($data, $table)
    {
        $dataname="";
        $valuename="";
        global $a_params;

        for ($i=0;$i<count($data["name"]);$i++)
        {
            if ($data["name"][$i]!="")
            {
                $dataname=$dataname.'`'.$data["name"][$i].'`'.', ';

                if ($data["value"][$i]=="")
                {
                    getParam($data["name"][$i], null);  
                    $valuename=$valuename."'".$a_params[$data["name"][$i]]."', ";
                }
                else
                {       
                    $valuename=$valuename."'".trim($data["value"][$i])."', ";
                }
            }
        }

        $dataname = substr($dataname,0,strlen($dataname)-2);
        $valuename = substr($valuename,0,strlen($valuename)-2);

        $res=$this->Execute("INSERT INTO ".$table." (".$dataname.") VALUES (".$valuename.");");
        //echo "INSERT INTO ".$table." (".$dataname.") VALUES (".$valuename.");<br><br>";
        return $res;
    }

    function SQLUpdate($data, $table, $where, $is_check)
    {
        $stroka="";
        global $a_params;
        $check_mass=explode(" ",$where);

        for ($i=0;$i<count($data["name"]);$i++)
        {
            $temp=$data["name"][$i];
            if (!isset($a_params[$temp."_check"])) getParam($temp, "check");

            $dataname=$data["name"][$i];
            $valuename=$data["value"][$i];
            if ($valuename=="") { if (isset($a_params[$temp])) $valuename=$a_params[$temp]; else $valuename=""; }    
            if (($a_params[$dataname."_check"]=="on") OR ($is_check==true)) $stroka=$stroka.$dataname."='".trim($valuename)."', ";
        }
        if ($stroka!="")
        {
            $stroka = substr($stroka,0,strlen($stroka)-2);

            if (count($check_mass)>1)
            {
                $res = $this->Execute("UPDATE ".$table." SET ".$stroka." WHERE ".$where);
                //echo "UPDATE ".$table." SET ".$stroka." WHERE ".$where."<br>";
            }
            else
            {
                $res = $this->Execute("UPDATE ".$table." SET ".$stroka." WHERE ".$table."_id='".$where."'");
                //echo "UPDATE ".$table." SET ".$stroka." WHERE ".$table."_id='".$where."'"."<br>";
            }
        }
        if (isset($res)) return $res; else return 0;
    }


    
    function SQLPicture($data_picture, $table, $where, $check)
    {
        $stroka='';
        global $a_params;
        $check_mass=explode(" ",$where);

        if (isset($data_picture["name"])) $max=count($data_picture["name"]);
        else $max=0;
        
        for ($i=0;$i<$max;$i++)
        {
            $stroka="";
            
            if ($check==true)
            {
                getParam($data_picture["name"][$i], "check");
                if ($a_params[$data_picture["name"][$i]."_check"]=="on") $dataname=$data_picture["name"][$i];
            }
            else
            {
                $dataname=$data_picture["name"][$i];
            }
            
            if (isset($dataname))
            {
                if (!$_FILES[$dataname]['name']=="")
                {
                    //   
                    $this->check_path('./content/'.$table);

                    //UPLOAD
                    if (move_uploaded_file($_FILES[$dataname]['tmp_name'],'./content/'.$table.'/'.$_FILES[$dataname]['name']))
                    {
                        //echo 'Upload='.$_FILES[$dataname]['name'].' to ./content/'.$table.'/'.$_FILES[$dataname]['name'].'<BR>';
                        chmod ('./content/'.$table.'/'.$_FILES[$dataname]['name'], 0777);
                        $valuename='./content/'.$table.'/'.$_FILES[$dataname]['name'];
                        $stroka=$stroka.$dataname."='".$valuename."', ";
                        //echo $stroka."<br>";
                    }
                    else
                    {
                        $stroka="";
                        //echo 'File '.$_FILES[$dataname]['name'].' some errors! to ./content/'.$table.'/'.$_FILES[$dataname]['name'].'<BR>';
                    }
                }
            }

            if ($stroka!="")
            {
                $stroka = substr($stroka,0,strlen($stroka)-2);

                if (count($check_mass)>1)
                {
                    $res = $this->Execute("UPDATE ".$table." SET ".$stroka." WHERE ".$where);
                    //echo "picture UPDATE ".$table." SET ".$stroka." WHERE ".$where."<br>";
                }
                else
                {
                    $res = $this->Execute("UPDATE ".$table." SET ".$stroka." WHERE ".$table."_id='".$where."'");
                    //echo "picture UPDATE ".$table." SET ".$stroka." WHERE ".$table."_id='".$where."'"."<br>";
                }
            }
        }

        if (isset($res)) return $res;
        else return 0;
    }
    

    function SQLDelete($table, $where)
    {
        $check_mass=explode(" ",$where);
        if (count($check_mass)>1)
        {
            $res = $this->Execute("DELETE FROM ".$table." WHERE ".$where);
            //echo "DELETE FROM ".$table." WHERE ".$where;
        }
        else
        {
            if ($this->database=="telephone")
            {
                $res = $this->Execute("DELETE FROM ".$table." WHERE ".$table."_id='".$where."'");
            }
            else
            {
                //$res = $this->Execute("DELETE FROM ".$table." WHERE ".$table."_id='".$where."'");
                //echo "DELETE FROM ".$table." WHERE ".$table."_id='".$where."'";
                $res=$this->SQLDeleteCascade($table, $table."_id", $where);
                for ($i=count($this->mass_del["table"])-1; $i>=0; $i--)
                {
                    // 
                    if (($this->mass_del["table"][$i]=="category_link") OR ($this->mass_del["table"][$i]=="object_link"))
                    {
                        // 
                        $t=split("_",$this->mass_del["table"][$i]);
                        $res = $this->SQLDeleteLink($t[0], $this->mass_del["table_id"][$i]);
                        //echo "DELETE FROM ".$this->mass_del["table"][$i]." WHERE ".$this->mass_del["table"][$i]."_id=".$this->mass_del["table_id"][$i]."<br>";
                    }
                    else
                    {
                        //  
                        if (trim($this->mass_del["table"][$i])!="category")
                        $res = $this->Execute("DELETE FROM ".$this->mass_del["table"][$i]." WHERE ".$this->mass_del["table"][$i]."_id='".$this->mass_del["table_id"][$i]."'");
                        //echo "DELETE FROM ".$this->mass_del["table"][$i]." WHERE ".$this->mass_del["table"][$i]."_id=".$this->mass_del["table_id"][$i]."<br>";
                    }
                }
            }
        }
        if (isset($res)) return $res; else return 0;
    }

    function SQLDeleteLink($table, $where)
    {

        $res = $this->Execute("SELECT * FROM ".$table."_link WHERE ".$table."_link_id='".$where."'");

        if ($res->RecordCount()>0)
        {
            $link = $res->FetchArray();
            $link_id = $link[$table."_link_id"];
            $table_id = $link[$table."_id"];
            $id = $link["id"];
            $table_name = $link["table"];
            $database_name = $link["database"];
            $sort = $link[$table."_link_sort"];
        }

        // 1- 
        $res = $this->Execute("DELETE FROM ".$table."_link WHERE ".$table."_link_id='".$link_id."'");
        // 2- 
        $res = $this->Execute("DELETE FROM ".$table_name."_link WHERE ".$table_name."_id='".$id."' AND id='".$table_id.
        "' AND `table`='".$table."'");

        return $res;
    }

    function SQLDeleteCascade($table, $field, $id)
    {
        global $a_links;
        require_once('./admin/class/cascade_delete.php');

        $res = $this->Execute("SELECT ".$table."_id FROM ".$table." WHERE ".$field."=".$id);
        //echo "SELECT ".$table."_id FROM ".$table." WHERE ".$field."=".$id;
        if ($res->RecordCount()>0)
        {
            while($obj = $res->FetchArray())
            {
                $this->mass_del["table"][]=$table;
                $this->mass_del["field"][]=$field;
                $this->mass_del["id"][]=$id;
                $this->mass_del["table_id"][]=$obj[$table."_id"];

                for($l=0; $l<count($a_links["table1"]);$l++)
                {
                    if ($table==$a_links["table1"][$l])
                    {
                        $this->SQLDeleteCascade($a_links["table2"][$l], $a_links["field"][$l], $obj[$table."_id"]);
                    }
                }
            }
        }

        //return 0;
    }

    // 
    function check_path($dir)
    {
        if (is_dir($dir)) return 0;

        $w_dir=split("/",$dir);
        $c_str='';
        for ($i=0; $i<count($w_dir); $i++)
        {
            $c_str.=$w_dir[$i]."/";
            if ($w_dir[$i]!=".")
            {
                if (!is_dir($c_str)) mkdir($c_str, 0777);
            }
        }
    }
    
    function getMessage($name)
    {
        if ($name=='') return '';

        $lang_where="";
        if ($this->lang_id > 0) $lang_where="AND (meta_name.lang_id=".$this->lang_id." OR meta_name.lang_id=0)";

        $mass_element=array();
        $res = $this->Execute("SELECT
        meta.meta_id,
        meta_name.meta_name_id,
        meta_name.meta_name_name,
        meta_name.meta_name_sort ".
        "FROM meta LEFT JOIN meta_name ON meta.meta_id=meta_name.meta_id ".
        "WHERE meta.meta_name='".$name."' ".$lang_where);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["meta_id"][]=$element["meta_id"];
                $mass_element["meta_name_id"][]=$element["meta_name_id"];
                $mass_element["meta_name_name"][]=$element["meta_name_name"];
                $mass_element["meta_name_sort"][]=$element["meta_name_sort"];
            }
        }
        else
        {
            $mass_element=array();
            $res = $this->Execute("SELECT
            meta.meta_id,
            meta_name.meta_name_id,
            meta_name.meta_name_name,
            meta_name.meta_name_sort ".
            "FROM meta LEFT JOIN meta_name ON meta.meta_id=meta_name.meta_id ".
            "WHERE meta.meta_name='".$name."' AND (meta_name.lang_id=2 OR meta_name.lang_id=0)");

            if ($res->RecordCount()>0)
            {
                while ($element = $res->FetchArray())
                {
                    $mass_element["meta_id"][]=$element["meta_id"];
                    $mass_element["meta_name_id"][]=$element["meta_name_id"];
                    $mass_element["meta_name_name"][]=$element["meta_name_name"];
                    $mass_element["meta_name_sort"][]=$element["meta_name_sort"];
                }
            }
        }



        if (isset($mass_element["meta_name_name"][0])) return $mass_element["meta_name_name"][0];
        return $name;
    }
}

class recordset
{
    var $recordset;
    var $sql;

    function recordset($recordset, $sql) {
        $this->recordset = $recordset;
        $this->sql = $sql;
    }

    function RecordCount()
    {
        return mysql_num_rows($this->recordset);
    }

    function FetchArray()
    {
        return mysql_fetch_array($this->recordset);
    }

    function FetchRow($opt=MYSQL_BOTH)
    {
        return mysql_fetch_array($this->recordset, $opt);
    }

    function InsertID()
    {
    	return mysql_insert_id();
    }
}
?>