<?php
//  
function getParam($s_parName)
{
    GLOBAL $a_params;
    if (isset($_GET[$s_parName]) || isset($_POST[$s_parName]))
    	$a_params[$s_parName] = isset($_GET[$s_parName]) ? $_GET[$s_parName] : $_POST[$s_parName];
    else $a_params[$s_parName] = "";
}

function drawImage($c1, $c2, $c3, $c4)
{
    GLOBAL $a_params;

    $width  = 85; 				// image height
    $height = 35; 				// image width

    $transparent = 1; 				// transparency
    $interlace = false;

    $msg1 = $c1; 				// text to display
    $msg2 = $c2; 				// text to display
    $msg3 = $c3; 				// text to display
    $msg4 = $c4; 				// text to display

    $font = './verdana.ttf'; 	       // full path to your font

    $size = 22; 				   // font size
    $rotation1 = rand(0,10);	// font rotation.
    $rotation2 = rand(0,10);	// font rotation.
    $rotation3 = rand(0,10);	// font rotation.
    $rotation4 = rand(0,10);	// font rotation.

    $pad_x = 10; 				// padding x
    $pad_y = 28; 				// padding y

    $fg_r = 0; 					// text color RGB - red
    $fg_g = 0; 					// text color RGB - green
    $fg_b = 0; 					// text color RGB - blue


    $bg_r = 255; 				// background color RGB - red
    $bg_g = 255; 				// background color RGB - green
    $bg_b = 255;				// background color RGB - blue

	$image = '';

	$image = ImageCreate($width+($pad_x*2),$height);

	// Allocate background color
	$bg = ImageColorAllocate($image, $bg_r, $bg_g, $bg_b);

	// Allocate text color
	$fg = ImageColorAllocate($image, 128, 128, 128);

	if ($transparent)
		ImageColorTransparent($image, $bg);

	ImageInterlace($image, $interlace);

    ImageTTFText($image, $size, -$rotation1, $pad_x, $pad_y, $fg, $font, $msg1);
    $pad_x=$pad_x+18;
    $pad_y1 = $pad_y + rand(0,3);
    ImageTTFText($image, $size, $rotation2, $pad_x, $pad_y1, $fg, $font, $msg2);
    $pad_x=$pad_x+18;
    $pad_y2 = $pad_y - rand(0,3);
    ImageTTFText($image, $size, -$rotation3, $pad_x, $pad_y2, $fg, $font, $msg3);
    $pad_x=$pad_x+18;
    $pad_y3 = $pad_y + rand(0,3);
	ImageTTFText($image, $size, $rotation4, $pad_x, $pad_y3, $fg, $font, $msg4);

	// Image distortion

	// Alocate distortion color
	//$dc = ImageColorAllocate($image, rand(0,255), rand(0,255), rand(0,255));

	// Draw eclipse
	//ImageArc($image, rand(0, $width ), rand(0, $height ), rand($width / 2, $width) ,rand($height / 2, $height), 0,360, $dc);

	// Alocate distortion color
	//$dc = ImageColorAllocate($image, rand(0,255), rand(0,255), rand(0,255));

	// Draw rectangle
	//ImageRectangle($image, rand(0, $width/2 ), rand(0, $height/2 ), rand($width / 2, $width) ,rand($height / 2, $height), $dc);

	// Draw dots at random position
	$dots = $width * $height / 10;
	for($i=0;$i<$dots;$i++)
	{
		// Alocate dot color
		$dc = ImageColorAllocate($image, rand(0,255), rand(0,255), rand(0,255));

		// Draw dot
		ImageSetPixel($image, rand(0,$width), rand(0,$height), $dc);
	}

	// Create image
	ImagePNG($image);
}

getParam("code");
$cislo=$a_params["code"];

$ttl = 30; // expires in 30 seconds
$now = mktime (date("H"),date("i"),date("s"),date("m"),date("d"),date("Y"));
$expires = mktime (date("H"),date("i"),date("s") + $ttl ,date("m"),date("d"),date("Y"));
$expires_gmt = gmdate('D, d M Y H:i:s', $expires).' GMT';
$last_modified_gmt  = gmdate('D, d M Y H:i:s', $now).' GMT';

header('Content-type:image/png');
header('Expires: '.$expires_gmt);
header('last-modified: '.$last_modified_gmt);

drawImage($cislo[0],$cislo[1],$cislo[2],$cislo[3]);
?>