<?php  
 session_start();
 require_once('./class/statistic.php');
 require_once("./functions/functions.php");
 include(dirname(__FILE__).DIRECTORY_SEPARATOR."pChart/pData.class");   
 include(dirname(__FILE__).DIRECTORY_SEPARATOR."pChart/pChart.class");  
 include(dirname(__FILE__).DIRECTORY_SEPARATOR."pChart/pCache.class"); 

 $month_name = array (1 => "Январь", 2 => "Февраль", 3 => "Март", 4 => "Апрель", 5 => "Май", 6 => "Июнь", 7 => "Июль", 8 => "Август", 9 => "Сентябрь", 10 => "Октябрь", 11 => "Ноябрь", 12 => "Декабрь");
 
 $statistic = new statistic();
 $statistic->setPath();
 $statistic->setPathGeo();
 getParam("graph_mounth", null);
 getParam("graph_value", null);
 
 $exclusive_name=$_SESSION["type"].$_SESSION["year"].$_SESSION["name"].$_SESSION["value"];
 
 //Обработка входящих параметров
 if ($_SESSION["type"]=='common') 
 {
	//Общий график
	if ($a_params["graph_mounth"]=='')
	{
		$graph_name=$_SESSION["year"];
		
		//Получение всех месяцов указанного года
		$mounth_files=$statistic->getMounthFiles('./visit/'.$_SESSION["year"]);
		
		for($i=0;$i<count($mounth_files);$i++)
		{
			$res_array["mounth"][]=$statistic->getFileGroup(array($mounth_files[$i]));
			$str_name=split("_",basename($mounth_files[$i]));
			$numberX[]=$month_name[intval($str_name[0])];
		}
		
		for($i=0;$i<count($res_array["mounth"]);$i++)
		{
			$hit[]=$res_array["mounth"][$i]["d|HIT"];
			$host[]=$res_array["mounth"][$i]["f|HOST"];
		}
	}
	
	//График месяца
	if ($a_params["graph_mounth"]>0)
	{
		$exclusive_name=$_SESSION["type"].$_SESSION["year"].$a_params["graph_mounth"].$_SESSION["value"];
		$graph_name=$month_name[intval($a_params["graph_mounth"])];
		
		//Получение всех месяцов указанного года
		$mounth_files=$statistic->getMounthFiles('./visit/'.$_SESSION["year"].'/'.str_pad($a_params["graph_mounth"], 2, "0", STR_PAD_LEFT));
		
		for($i=0;$i<count($mounth_files);$i++)
		{
			$res_array["mounth"][]=$statistic->getFileGroup(array($mounth_files[$i]));
			$str_name=split("_",basename($mounth_files[$i]));
			$numberX[]=intval($str_name[0]);
		}
		
		for($i=0;$i<count($res_array["mounth"]);$i++)
		{
			$hit[]=$res_array["mounth"][$i]["d|HIT"];
			$host[]=$res_array["mounth"][$i]["f|HOST"];
		}
	}
 }
 
 
 //Обработка входящих параметров
 if (($_SESSION["type"]=='host') OR ($_SESSION["type"]=='hit')) 
 {
	$exclusive_name=$_SESSION["type"].$_SESSION["year"].$a_params["graph_value"].$_SESSION["value"];
	
	if ($a_params["graph_value"]=='day')
	{
		//За сегодня
		$day_array=array();
		$url_array=array();
		$day_array=$statistic->getDayPathThis(0); //Сегодня
		$url_array=$statistic->getFile($day_array);
		$graph_name=$month_name[intval($statistic->mounth)].' (сегодня)';
		$time_array=array();
		if ($_SESSION["type"]=='host') $fhost="f|HOST"; else $fhost="d|HIT";
		for($i=0;$i<count($url_array[$fhost]["ip"]);$i++)
		{
			if ($url_array[$fhost]["times"][$i]>0) $time_array[date("H", $url_array[$fhost]["times"][$i])]+=1;
		}
		
		for($i=0;$i<24;$i++)
		{
			$str_time=str_pad($i, 2, "0", STR_PAD_LEFT);
			$numberX[]=$str_time;
			
			$host_number=0;
			foreach ($time_array as $key=>$val)
			{
				if ($str_time==$key) $host_number=$val;
			}
			if ($_SESSION["type"]=='host') $host[]=$host_number; else $hit[]=$host_number;
		}	
	}
	
	if ($a_params["graph_value"]=='day2')
	{
		//За вчера
		$day_array=array();
		$url_array=array();
		$day_array=$statistic->getDayPathThis(1); //Вчера	
		$url_array=$statistic->getFile($day_array);
		$graph_name=$month_name[intval($statistic->mounth)].' (вчера)';
		$time_array=array();
		if ($_SESSION["type"]=='host') $fhost="f|HOST"; else $fhost="d|HIT";
		for($i=0;$i<count($url_array[$fhost]["ip"]);$i++)
		{
			if ($url_array[$fhost]["times"][$i]>0) $time_array[date("H", $url_array[$fhost]["times"][$i])]+=1;
		}
		
		for($i=0;$i<24;$i++)
		{
			$str_time=str_pad($i, 2, "0", STR_PAD_LEFT);
			$numberX[]=$str_time;
			$host_number=0;
			foreach ($time_array as $key=>$val)
			{
				if ($str_time==$key) $host_number=$val;
			}
			if ($_SESSION["type"]=='host') $host[]=$host_number; else $hit[]=$host_number;
		}
	}
	
	if ($a_params["graph_value"]=='week')
	{
		//За неделю
		$day_array=array();
		$url_array=array();
		$day_array=$statistic->getDayPath(6, true); //Неделя
		$url_array=$statistic->getFile($day_array);
		$graph_name=$month_name[intval($statistic->mounth)].' (неделя)';
		$time_array=array();
		if ($_SESSION["type"]=='host') $fhost="f|HOST"; else $fhost="d|HIT";
		for($i=0;$i<count($url_array[$fhost]["ip"]);$i++)
		{
			if ($url_array[$fhost]["times"][$i]>0) $time_array[date("H", $url_array[$fhost]["times"][$i])]+=1;
		}
		
		for($i=0;$i<24;$i++)
		{
			$str_time=str_pad($i, 2, "0", STR_PAD_LEFT);
			$numberX[]=$str_time;
			$host_number=0;
			foreach ($time_array as $key=>$val)
			{
				if ($str_time==$key) $host_number=$val;
			}
			if ($_SESSION["type"]=='host') $host[]=$host_number; else $hit[]=$host_number;
		}
	}
	
	if ($a_params["graph_value"]=='mounth')
	{
		$day_array=array();
		$url_array=array();
		$day_array=$statistic->getDayPath(30, true); //Месяц
		$url_array=$statistic->getFile($day_array);	
		$graph_name=$month_name[intval($statistic->mounth)].' (месяц)';
		$time_array=array();
		if ($_SESSION["type"]=='host') $fhost="f|HOST"; else $fhost="d|HIT";
		for($i=0;$i<count($url_array[$fhost]["ip"]);$i++)
		{
			if ($url_array[$fhost]["times"][$i]>0) $time_array[date("H", $url_array[$fhost]["times"][$i])]+=1;
		}
		
		for($i=0;$i<24;$i++)
		{
			$str_time=str_pad($i, 2, "0", STR_PAD_LEFT);
			$numberX[]=$str_time;
			$host_number=0;
			foreach ($time_array as $key=>$val)
			{
				if ($str_time==$key) $host_number=$val;
			}
			if ($_SESSION["type"]=='host') $host[]=$host_number; else $hit[]=$host_number;
		}
	}
 }
 
 
 if (($_SESSION["type"]!='common') AND ($_SESSION["type"]!='host') AND ($_SESSION["type"]!='hit'))
 {
	$hit=array(0);
	$host=array(0);
	$graph_name='Нет данных';
	$numberX=array();
    for($x=1;$x<=count($host);$x++)
	{
		$numberX[]=str_pad($x, 2, "0", STR_PAD_LEFT);
	}
 }
 
 
 // Dataset definition    
 $DataSet = new pData; 
 if ($_SESSION["type"]!='host') $DataSet->AddPoint($hit,"Serie1");
 if ($_SESSION["type"]!='hit') $DataSet->AddPoint($host,"Serie2");
 $DataSet->AddPoint($numberX,"Serie3");
 $DataSet->AddAllSeries();
 $DataSet->SetAbsciseLabelSerie("Serie3");
 if ($_SESSION["type"]!='host') $DataSet->SetSerieName("Хиты","Serie1");
 if ($_SESSION["type"]!='hit') $DataSet->SetSerieName("Хосты","Serie2");
 
 //$nmounth=str_pad($nmounth, 2, "0", STR_PAD_LEFT);
 
 // Cache definition 
 $Cache = new pCache();
 $Cache->GetFromCache($exclusive_name,$DataSet->GetData());
  
 //Общий размер
 $Test = new pChart(900,230);
 $Test->reportWarnings("GD");
 //По Y 0-от, 20 - макс, 10 - делитель
 
 //Область графика
 $Test->setFontProperties(dirname(__FILE__).DIRECTORY_SEPARATOR."Fonts/tahoma.ttf",8);   
 $Test->setGraphArea(45,30,780,200);   
 
 $Test->drawFilledRoundedRectangle(7,7,893,223,5,240,240,240);   
 $Test->drawRoundedRectangle(5,5,895,225,5,230,230,230);   
 //Цвет фона
 $Test->drawGraphArea(255,255,255,TRUE);
 //Цвет оси координат + начало отчета
 $Test->drawScale($DataSet->GetData(),$DataSet->GetDataDescription(),SCALE_NORMAL,150,150,150,TRUE,0,0,TRUE,1);   
 $Test->drawGrid(4,TRUE,230,230,230,50);
 
 $DataSet->RemoveSerie("Serie3");
 
 // Вывод линий
 //Пунктир
 //$Test->setLineStyle(1,1);
 $Test->setColorPalette(0,208,125,7);
 if ($_SESSION["type"]!='host') 
 {
 $Test->setFontProperties(dirname(__FILE__).DIRECTORY_SEPARATOR."Fonts/tahoma.ttf",8);   
 $Test->drawLineGraph($DataSet->GetData(),$DataSet->GetDataDescription());   
 $Test->drawPlotGraph($DataSet->GetData(),$DataSet->GetDataDescription(),3,2,255,255,255);  
 $Test->writeValues($DataSet->GetData(),$DataSet->GetDataDescription(),"Serie1");   
 $DataSet->RemoveSerie("Serie1");
 }
 $Test->setColorPalette(1,1,138,33);
 if ($_SESSION["type"]!='hit') 
 {
 $Test->setFontProperties(dirname(__FILE__).DIRECTORY_SEPARATOR."Fonts/tahoma.ttf",8);   
 $Test->drawLineGraph($DataSet->GetData(),$DataSet->GetDataDescription());   
 $Test->drawPlotGraph($DataSet->GetData(),$DataSet->GetDataDescription(),3,2,255,255,255);   
 $Test->writeValues($DataSet->GetData(),$DataSet->GetDataDescription(),"Serie2");   
 $DataSet->RemoveSerie("Serie2");
 }
 //Выводим инфо справа
 $Test->setFontProperties(dirname(__FILE__).DIRECTORY_SEPARATOR."Fonts/tahoma.ttf",8);   
 $Test->drawLegend(800,80,$DataSet->GetDataDescription(),255,255,255);   
 //Выводим название
 $Test->setFontProperties(dirname(__FILE__).DIRECTORY_SEPARATOR."Fonts/tahoma.ttf",10);   
 $Test->drawTitle(60,22,$graph_name,50,50,50,785);

 // Add an image
 $Test->drawFromPNG("Sample/logo.png",786,22);

 $Cache->WriteToCache($exclusive_name,$DataSet->GetData(),$Test);
//$Test->Render("my15.png");  
 $Test->Stroke();
?>