<?php
session_start();
//error_reporting(0);
require_once("../cfg/connect.php");
require_once("./functions/functions.php");
require_once('./class/db_mysql.php');
require_once('./class/statistic.php');

$db = new db(DB_HOST, $DB_USER, $DB_PASSWORD, DB_BASE_NAME);
$sql = 'SET NAMES cp1251';
$db->Execute($sql);
unset($DB_PASSWORD, $DB_USER);

// 
getParam("type", null);
getParam("name", null);
getParam("value", null);

if ($a_params["type"]=='') $a_params["type"]='common';
if ($a_params["name"]=='') $a_params["name"]='year';
if ($a_params["value"]=='') $a_params["value"]=date("Y",time());

$_SESSION["type"]=$a_params["type"]; //common, host, url, state, region, os, browser, page, session, hit, referer, search
$_SESSION["name"]=$a_params["name"]; //today, 1day, 2day, week, mounth, year, all
$_SESSION["value"]=$a_params["value"]; //2010, 2010_11, 2010_01_24

if((isset($_SESSION["year"])) AND ($_SESSION["name"]=='year')) 	$_SESSION["year"]=$_SESSION["value"]; else $_SESSION["year"]=date("Y",time());
if((isset($_SESSION["mounth"])) AND ($_SESSION["name"]=='mounth')) 	$_SESSION["mounth"]=$_SESSION["value"]; else $_SESSION["mounth"]=date("m",time());
if((isset($_SESSION["day"])) AND ($_SESSION["name"]=='day')) 	$_SESSION["day"]=$_SESSION["value"]; else $_SESSION["day"]=date("d",time());

if ($_SESSION["value"])
{
	$value_array=split("_",$_SESSION["value"]);
	if (count($value_array)>0)
	{
		for($i=0;$i<count($value_array);$i++)
		{
			if ($i==0) $_SESSION["year"]=intval($value_array[0]);
			if ($i==1) $_SESSION["mounth"]=intval($value_array[1]);
			if ($i==2) $_SESSION["day"]=intval($value_array[2]);
		}
	}
}

$statistic = new statistic();
$statistic->setPath();
$statistic->setPathGeo();
//   _group   N , false -  
$statistic->synDay(7, true);
//   _group   , false -  
$statistic->synMounth(true);
//   _group   , false -  
$statistic->synYear(true);	

ob_start();
include ('./shablon/main.php');
$contents = ob_get_contents();
ob_end_clean();
if (true)
{		
	echo $contents; 
}
else
{
	echo "error";
}
?>